var Faye =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var constants = __webpack_require__(1),
	    Logging   = __webpack_require__(2);
	
	var Faye = {
	  VERSION:    constants.VERSION,
	
	  Client:     __webpack_require__(4),
	  Scheduler:  __webpack_require__(32)
	};
	
	Logging.wrapper = Faye;
	
	module.exports = Faye;


/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = {
	  VERSION:          '1.2.4',
	
	  BAYEUX_VERSION:   '1.0',
	  ID_LENGTH:        160,
	  JSONP_CALLBACK:   'jsonpcallback',
	  CONNECTION_TYPES: ['long-polling', 'cross-origin-long-polling', 'callback-polling', 'websocket', 'eventsource', 'in-process'],
	
	  MANDATORY_CONNECTION_TYPES: ['long-polling', 'callback-polling', 'in-process']
	};


/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var toJSON = __webpack_require__(3);
	
	var Logging = {
	  LOG_LEVELS: {
	    fatal:  4,
	    error:  3,
	    warn:   2,
	    info:   1,
	    debug:  0
	  },
	
	  writeLog: function(messageArgs, level) {
	    var logger = Logging.logger || (Logging.wrapper || Logging).logger;
	    if (!logger) return;
	
	    var args   = Array.prototype.slice.apply(messageArgs),
	        banner = '[Faye',
	        klass  = this.className,
	
	        message = args.shift().replace(/\?/g, function() {
	          try {
	            return toJSON(args.shift());
	          } catch (error) {
	            return '[Object]';
	          }
	        });
	
	    if (klass) banner += '.' + klass;
	    banner += '] ';
	
	    if (typeof logger[level] === 'function')
	      logger[level](banner + message);
	    else if (typeof logger === 'function')
	      logger(banner + message);
	  }
	};
	
	for (var key in Logging.LOG_LEVELS)
	  (function(level) {
	    Logging[level] = function() {
	      this.writeLog(arguments, level);
	    };
	  })(key);
	
	module.exports = Logging;


/***/ },
/* 3 */
/***/ function(module, exports) {

	'use strict';
	
	// http://assanka.net/content/tech/2009/09/02/json2-js-vs-prototype/
	
	module.exports = function(object) {
	  return JSON.stringify(object, function(key, value) {
	    return (this[key] instanceof Array) ? this[key] : value;
	  });
	};


/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var asap            = __webpack_require__(5),
	    Class           = __webpack_require__(7),
	    Promise         = __webpack_require__(9),
	    URI             = __webpack_require__(10),
	    array           = __webpack_require__(11),
	    browser         = __webpack_require__(12),
	    constants       = __webpack_require__(1),
	    extend          = __webpack_require__(8),
	    validateOptions = __webpack_require__(13),
	    Deferrable      = __webpack_require__(14),
	    Logging         = __webpack_require__(2),
	    Publisher       = __webpack_require__(15),
	    Channel         = __webpack_require__(17),
	    Dispatcher      = __webpack_require__(19),
	    Error           = __webpack_require__(33),
	    Extensible      = __webpack_require__(34),
	    Publication     = __webpack_require__(35),
	    Subscription    = __webpack_require__(36);
	
	var Client = Class({ className: 'Client',
	  UNCONNECTED:        1,
	  CONNECTING:         2,
	  CONNECTED:          3,
	  DISCONNECTED:       4,
	
	  HANDSHAKE:          'handshake',
	  RETRY:              'retry',
	  NONE:               'none',
	
	  CONNECTION_TIMEOUT: 60,
	
	  DEFAULT_ENDPOINT:   '/bayeux',
	  INTERVAL:           0,
	
	  initialize: function(endpoint, options) {
	    this.info('New client created for ?', endpoint);
	    options = options || {};
	
	    validateOptions(options, ['interval', 'timeout', 'endpoints', 'proxy', 'retry', 'scheduler', 'websocketExtensions', 'tls', 'ca']);
	
	    this._channels   = new Channel.Set();
	    this._dispatcher = Dispatcher.create(this, endpoint || this.DEFAULT_ENDPOINT, options);
	
	    this._messageId = 0;
	    this._state     = this.UNCONNECTED;
	
	    this._responseCallbacks = {};
	
	    this._advice = {
	      reconnect: this.RETRY,
	      interval:  1000 * (options.interval || this.INTERVAL),
	      timeout:   1000 * (options.timeout  || this.CONNECTION_TIMEOUT)
	    };
	    this._dispatcher.timeout = this._advice.timeout / 1000;
	
	    this._dispatcher.bind('message', this._receiveMessage, this);
	
	    if (browser.Event && global.onbeforeunload !== undefined)
	      browser.Event.on(global, 'beforeunload', function() {
	        if (array.indexOf(this._dispatcher._disabled, 'autodisconnect') < 0)
	          this.disconnect();
	      }, this);
	  },
	
	  addWebsocketExtension: function(extension) {
	    return this._dispatcher.addWebsocketExtension(extension);
	  },
	
	  disable: function(feature) {
	    return this._dispatcher.disable(feature);
	  },
	
	  setHeader: function(name, value) {
	    return this._dispatcher.setHeader(name, value);
	  },
	
	  // Request
	  // MUST include:  * channel
	  //                * version
	  //                * supportedConnectionTypes
	  // MAY include:   * minimumVersion
	  //                * ext
	  //                * id
	  //
	  // Success Response                             Failed Response
	  // MUST include:  * channel                     MUST include:  * channel
	  //                * version                                    * successful
	  //                * supportedConnectionTypes                   * error
	  //                * clientId                    MAY include:   * supportedConnectionTypes
	  //                * successful                                 * advice
	  // MAY include:   * minimumVersion                             * version
	  //                * advice                                     * minimumVersion
	  //                * ext                                        * ext
	  //                * id                                         * id
	  //                * authSuccessful
	  handshake: function(callback, context) {
	    if (this._advice.reconnect === this.NONE) return;
	    if (this._state !== this.UNCONNECTED) return;
	
	    this._state = this.CONNECTING;
	    var self = this;
	
	    this.info('Initiating handshake with ?', URI.stringify(this._dispatcher.endpoint));
	    this._dispatcher.selectTransport(constants.MANDATORY_CONNECTION_TYPES);
	
	    this._sendMessage({
	      channel:                  Channel.HANDSHAKE,
	      version:                  constants.BAYEUX_VERSION,
	      supportedConnectionTypes: this._dispatcher.getConnectionTypes()
	
	    }, {}, function(response) {
	
	      if (response.successful) {
	        this._state = this.CONNECTED;
	        this._dispatcher.clientId  = response.clientId;
	
	        this._dispatcher.selectTransport(response.supportedConnectionTypes);
	
	        this.info('Handshake successful: ?', this._dispatcher.clientId);
	
	        this.subscribe(this._channels.getKeys(), true);
	        if (callback) asap(function() { callback.call(context) });
	
	      } else {
	        this.info('Handshake unsuccessful');
	        global.setTimeout(function() { self.handshake(callback, context) }, this._dispatcher.retry * 1000);
	        this._state = this.UNCONNECTED;
	      }
	    }, this);
	  },
	
	  // Request                              Response
	  // MUST include:  * channel             MUST include:  * channel
	  //                * clientId                           * successful
	  //                * connectionType                     * clientId
	  // MAY include:   * ext                 MAY include:   * error
	  //                * id                                 * advice
	  //                                                     * ext
	  //                                                     * id
	  //                                                     * timestamp
	  connect: function(callback, context) {
	    if (this._advice.reconnect === this.NONE) return;
	    if (this._state === this.DISCONNECTED) return;
	
	    if (this._state === this.UNCONNECTED)
	      return this.handshake(function() { this.connect(callback, context) }, this);
	
	    this.callback(callback, context);
	    if (this._state !== this.CONNECTED) return;
	
	    this.info('Calling deferred actions for ?', this._dispatcher.clientId);
	    this.setDeferredStatus('succeeded');
	    this.setDeferredStatus('unknown');
	
	    if (this._connectRequest) return;
	    this._connectRequest = true;
	
	    this.info('Initiating connection for ?', this._dispatcher.clientId);
	
	    this._sendMessage({
	      channel:        Channel.CONNECT,
	      clientId:       this._dispatcher.clientId,
	      connectionType: this._dispatcher.connectionType
	
	    }, {}, this._cycleConnection, this);
	  },
	
	  // Request                              Response
	  // MUST include:  * channel             MUST include:  * channel
	  //                * clientId                           * successful
	  // MAY include:   * ext                                * clientId
	  //                * id                  MAY include:   * error
	  //                                                     * ext
	  //                                                     * id
	  disconnect: function() {
	    if (this._state !== this.CONNECTED) return;
	    this._state = this.DISCONNECTED;
	
	    this.info('Disconnecting ?', this._dispatcher.clientId);
	    var promise = new Publication();
	
	    this._sendMessage({
	      channel:  Channel.DISCONNECT,
	      clientId: this._dispatcher.clientId
	
	    }, {}, function(response) {
	      if (response.successful) {
	        this._dispatcher.close();
	        promise.setDeferredStatus('succeeded');
	      } else {
	        promise.setDeferredStatus('failed', Error.parse(response.error));
	      }
	    }, this);
	
	    this.info('Clearing channel listeners for ?', this._dispatcher.clientId);
	    this._channels = new Channel.Set();
	
	    return promise;
	  },
	
	  // Request                              Response
	  // MUST include:  * channel             MUST include:  * channel
	  //                * clientId                           * successful
	  //                * subscription                       * clientId
	  // MAY include:   * ext                                * subscription
	  //                * id                  MAY include:   * error
	  //                                                     * advice
	  //                                                     * ext
	  //                                                     * id
	  //                                                     * timestamp
	  subscribe: function(channel, callback, context) {
	    if (channel instanceof Array)
	      return array.map(channel, function(c) {
	        return this.subscribe(c, callback, context);
	      }, this);
	
	    var subscription = new Subscription(this, channel, callback, context),
	        force        = (callback === true),
	        hasSubscribe = this._channels.hasSubscription(channel);
	
	    if (hasSubscribe && !force) {
	      this._channels.subscribe([channel], subscription);
	      subscription.setDeferredStatus('succeeded');
	      return subscription;
	    }
	
	    this.connect(function() {
	      this.info('Client ? attempting to subscribe to ?', this._dispatcher.clientId, channel);
	      if (!force) this._channels.subscribe([channel], subscription);
	
	      this._sendMessage({
	        channel:      Channel.SUBSCRIBE,
	        clientId:     this._dispatcher.clientId,
	        subscription: channel
	
	      }, {}, function(response) {
	        if (!response.successful) {
	          subscription.setDeferredStatus('failed', Error.parse(response.error));
	          return this._channels.unsubscribe(channel, subscription);
	        }
	
	        var channels = [].concat(response.subscription);
	        this.info('Subscription acknowledged for ? to ?', this._dispatcher.clientId, channels);
	        subscription.setDeferredStatus('succeeded');
	      }, this);
	    }, this);
	
	    return subscription;
	  },
	
	  // Request                              Response
	  // MUST include:  * channel             MUST include:  * channel
	  //                * clientId                           * successful
	  //                * subscription                       * clientId
	  // MAY include:   * ext                                * subscription
	  //                * id                  MAY include:   * error
	  //                                                     * advice
	  //                                                     * ext
	  //                                                     * id
	  //                                                     * timestamp
	  unsubscribe: function(channel, subscription) {
	    if (channel instanceof Array)
	      return array.map(channel, function(c) {
	        return this.unsubscribe(c, subscription);
	      }, this);
	
	    var dead = this._channels.unsubscribe(channel, subscription);
	    if (!dead) return;
	
	    this.connect(function() {
	      this.info('Client ? attempting to unsubscribe from ?', this._dispatcher.clientId, channel);
	
	      this._sendMessage({
	        channel:      Channel.UNSUBSCRIBE,
	        clientId:     this._dispatcher.clientId,
	        subscription: channel
	
	      }, {}, function(response) {
	        if (!response.successful) return;
	
	        var channels = [].concat(response.subscription);
	        this.info('Unsubscription acknowledged for ? from ?', this._dispatcher.clientId, channels);
	      }, this);
	    }, this);
	  },
	
	  // Request                              Response
	  // MUST include:  * channel             MUST include:  * channel
	  //                * data                               * successful
	  // MAY include:   * clientId            MAY include:   * id
	  //                * id                                 * error
	  //                * ext                                * ext
	  publish: function(channel, data, options) {
	    validateOptions(options || {}, ['attempts', 'deadline']);
	    var publication = new Publication();
	
	    this.connect(function() {
	      this.info('Client ? queueing published message to ?: ?', this._dispatcher.clientId, channel, data);
	
	      this._sendMessage({
	        channel:  channel,
	        data:     data,
	        clientId: this._dispatcher.clientId
	
	      }, options, function(response) {
	        if (response.successful)
	          publication.setDeferredStatus('succeeded');
	        else
	          publication.setDeferredStatus('failed', Error.parse(response.error));
	      }, this);
	    }, this);
	
	    return publication;
	  },
	
	  _sendMessage: function(message, options, callback, context) {
	    message.id = this._generateMessageId();
	
	    var timeout = this._advice.timeout
	                ? 1.2 * this._advice.timeout / 1000
	                : 1.2 * this._dispatcher.retry;
	
	    this.pipeThroughExtensions('outgoing', message, null, function(message) {
	      if (!message) return;
	      if (callback) this._responseCallbacks[message.id] = [callback, context];
	      this._dispatcher.sendMessage(message, timeout, options || {});
	    }, this);
	  },
	
	  _generateMessageId: function() {
	    this._messageId += 1;
	    if (this._messageId >= Math.pow(2,32)) this._messageId = 0;
	    return this._messageId.toString(36);
	  },
	
	  _receiveMessage: function(message) {
	    var id = message.id, callback;
	
	    if (message.successful !== undefined) {
	      callback = this._responseCallbacks[id];
	      delete this._responseCallbacks[id];
	    }
	
	    this.pipeThroughExtensions('incoming', message, null, function(message) {
	      if (!message) return;
	      if (message.advice) this._handleAdvice(message.advice);
	      this._deliverMessage(message);
	      if (callback) callback[0].call(callback[1], message);
	    }, this);
	  },
	
	  _handleAdvice: function(advice) {
	    extend(this._advice, advice);
	    this._dispatcher.timeout = this._advice.timeout / 1000;
	
	    if (this._advice.reconnect === this.HANDSHAKE && this._state !== this.DISCONNECTED) {
	      this._state = this.UNCONNECTED;
	      this._dispatcher.clientId = null;
	      this._cycleConnection();
	    }
	  },
	
	  _deliverMessage: function(message) {
	    if (!message.channel || message.data === undefined) return;
	    this.info('Client ? calling listeners for ? with ?', this._dispatcher.clientId, message.channel, message.data);
	    this._channels.distributeMessage(message);
	  },
	
	  _cycleConnection: function() {
	    if (this._connectRequest) {
	      this._connectRequest = null;
	      this.info('Closed connection for ?', this._dispatcher.clientId);
	    }
	    var self = this;
	    global.setTimeout(function() { self.connect() }, this._advice.interval);
	  }
	});
	
	extend(Client.prototype, Deferrable);
	extend(Client.prototype, Publisher);
	extend(Client.prototype, Logging);
	extend(Client.prototype, Extensible);
	
	module.exports = Client;
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	// rawAsap provides everything we need except exception management.
	var rawAsap = __webpack_require__(6);
	// RawTasks are recycled to reduce GC churn.
	var freeTasks = [];
	// We queue errors to ensure they are thrown in right order (FIFO).
	// Array-as-queue is good enough here, since we are just dealing with exceptions.
	var pendingErrors = [];
	var requestErrorThrow = rawAsap.makeRequestCallFromTimer(throwFirstError);
	
	function throwFirstError() {
	    if (pendingErrors.length) {
	        throw pendingErrors.shift();
	    }
	}
	
	/**
	 * Calls a task as soon as possible after returning, in its own event, with priority
	 * over other events like animation, reflow, and repaint. An error thrown from an
	 * event will not interrupt, nor even substantially slow down the processing of
	 * other events, but will be rather postponed to a lower priority event.
	 * @param {{call}} task A callable object, typically a function that takes no
	 * arguments.
	 */
	module.exports = asap;
	function asap(task) {
	    var rawTask;
	    if (freeTasks.length) {
	        rawTask = freeTasks.pop();
	    } else {
	        rawTask = new RawTask();
	    }
	    rawTask.task = task;
	    rawAsap(rawTask);
	}
	
	// We wrap tasks with recyclable task objects.  A task object implements
	// `call`, just like a function.
	function RawTask() {
	    this.task = null;
	}
	
	// The sole purpose of wrapping the task is to catch the exception and recycle
	// the task object after its single use.
	RawTask.prototype.call = function () {
	    try {
	        this.task.call();
	    } catch (error) {
	        if (asap.onerror) {
	            // This hook exists purely for testing purposes.
	            // Its name will be periodically randomized to break any code that
	            // depends on its existence.
	            asap.onerror(error);
	        } else {
	            // In a web browser, exceptions are not fatal. However, to avoid
	            // slowing down the queue of pending tasks, we rethrow the error in a
	            // lower priority turn.
	            pendingErrors.push(error);
	            requestErrorThrow();
	        }
	    } finally {
	        this.task = null;
	        freeTasks[freeTasks.length] = this;
	    }
	};


/***/ },
/* 6 */
/***/ function(module, exports) {

	/* WEBPACK VAR INJECTION */(function(global) {"use strict";
	
	// Use the fastest means possible to execute a task in its own turn, with
	// priority over other events including IO, animation, reflow, and redraw
	// events in browsers.
	//
	// An exception thrown by a task will permanently interrupt the processing of
	// subsequent tasks. The higher level `asap` function ensures that if an
	// exception is thrown by a task, that the task queue will continue flushing as
	// soon as possible, but if you use `rawAsap` directly, you are responsible to
	// either ensure that no exceptions are thrown from your task, or to manually
	// call `rawAsap.requestFlush` if an exception is thrown.
	module.exports = rawAsap;
	function rawAsap(task) {
	    if (!queue.length) {
	        requestFlush();
	        flushing = true;
	    }
	    // Equivalent to push, but avoids a function call.
	    queue[queue.length] = task;
	}
	
	var queue = [];
	// Once a flush has been requested, no further calls to `requestFlush` are
	// necessary until the next `flush` completes.
	var flushing = false;
	// `requestFlush` is an implementation-specific method that attempts to kick
	// off a `flush` event as quickly as possible. `flush` will attempt to exhaust
	// the event queue before yielding to the browser's own event loop.
	var requestFlush;
	// The position of the next task to execute in the task queue. This is
	// preserved between calls to `flush` so that it can be resumed if
	// a task throws an exception.
	var index = 0;
	// If a task schedules additional tasks recursively, the task queue can grow
	// unbounded. To prevent memory exhaustion, the task queue will periodically
	// truncate already-completed tasks.
	var capacity = 1024;
	
	// The flush function processes all tasks that have been scheduled with
	// `rawAsap` unless and until one of those tasks throws an exception.
	// If a task throws an exception, `flush` ensures that its state will remain
	// consistent and will resume where it left off when called again.
	// However, `flush` does not make any arrangements to be called again if an
	// exception is thrown.
	function flush() {
	    while (index < queue.length) {
	        var currentIndex = index;
	        // Advance the index before calling the task. This ensures that we will
	        // begin flushing on the next task the task throws an error.
	        index = index + 1;
	        queue[currentIndex].call();
	        // Prevent leaking memory for long chains of recursive calls to `asap`.
	        // If we call `asap` within tasks scheduled by `asap`, the queue will
	        // grow, but to avoid an O(n) walk for every task we execute, we don't
	        // shift tasks off the queue after they have been executed.
	        // Instead, we periodically shift 1024 tasks off the queue.
	        if (index > capacity) {
	            // Manually shift all values starting at the index back to the
	            // beginning of the queue.
	            for (var scan = 0, newLength = queue.length - index; scan < newLength; scan++) {
	                queue[scan] = queue[scan + index];
	            }
	            queue.length -= index;
	            index = 0;
	        }
	    }
	    queue.length = 0;
	    index = 0;
	    flushing = false;
	}
	
	// `requestFlush` is implemented using a strategy based on data collected from
	// every available SauceLabs Selenium web driver worker at time of writing.
	// https://docs.google.com/spreadsheets/d/1mG-5UYGup5qxGdEMWkhP6BWCz053NUb2E1QoUTU16uA/edit#gid=783724593
	
	// Safari 6 and 6.1 for desktop, iPad, and iPhone are the only browsers that
	// have WebKitMutationObserver but not un-prefixed MutationObserver.
	// Must use `global` or `self` instead of `window` to work in both frames and web
	// workers. `global` is a provision of Browserify, Mr, Mrs, or Mop.
	
	/* globals self */
	var scope = typeof global !== "undefined" ? global : self;
	var BrowserMutationObserver = scope.MutationObserver || scope.WebKitMutationObserver;
	
	// MutationObservers are desirable because they have high priority and work
	// reliably everywhere they are implemented.
	// They are implemented in all modern browsers.
	//
	// - Android 4-4.3
	// - Chrome 26-34
	// - Firefox 14-29
	// - Internet Explorer 11
	// - iPad Safari 6-7.1
	// - iPhone Safari 7-7.1
	// - Safari 6-7
	if (typeof BrowserMutationObserver === "function") {
	    requestFlush = makeRequestCallFromMutationObserver(flush);
	
	// MessageChannels are desirable because they give direct access to the HTML
	// task queue, are implemented in Internet Explorer 10, Safari 5.0-1, and Opera
	// 11-12, and in web workers in many engines.
	// Although message channels yield to any queued rendering and IO tasks, they
	// would be better than imposing the 4ms delay of timers.
	// However, they do not work reliably in Internet Explorer or Safari.
	
	// Internet Explorer 10 is the only browser that has setImmediate but does
	// not have MutationObservers.
	// Although setImmediate yields to the browser's renderer, it would be
	// preferrable to falling back to setTimeout since it does not have
	// the minimum 4ms penalty.
	// Unfortunately there appears to be a bug in Internet Explorer 10 Mobile (and
	// Desktop to a lesser extent) that renders both setImmediate and
	// MessageChannel useless for the purposes of ASAP.
	// https://github.com/kriskowal/q/issues/396
	
	// Timers are implemented universally.
	// We fall back to timers in workers in most engines, and in foreground
	// contexts in the following browsers.
	// However, note that even this simple case requires nuances to operate in a
	// broad spectrum of browsers.
	//
	// - Firefox 3-13
	// - Internet Explorer 6-9
	// - iPad Safari 4.3
	// - Lynx 2.8.7
	} else {
	    requestFlush = makeRequestCallFromTimer(flush);
	}
	
	// `requestFlush` requests that the high priority event queue be flushed as
	// soon as possible.
	// This is useful to prevent an error thrown in a task from stalling the event
	// queue if the exception handled by Node.js’s
	// `process.on("uncaughtException")` or by a domain.
	rawAsap.requestFlush = requestFlush;
	
	// To request a high priority event, we induce a mutation observer by toggling
	// the text of a text node between "1" and "-1".
	function makeRequestCallFromMutationObserver(callback) {
	    var toggle = 1;
	    var observer = new BrowserMutationObserver(callback);
	    var node = document.createTextNode("");
	    observer.observe(node, {characterData: true});
	    return function requestCall() {
	        toggle = -toggle;
	        node.data = toggle;
	    };
	}
	
	// The message channel technique was discovered by Malte Ubl and was the
	// original foundation for this library.
	// http://www.nonblocking.io/2011/06/windownexttick.html
	
	// Safari 6.0.5 (at least) intermittently fails to create message ports on a
	// page's first load. Thankfully, this version of Safari supports
	// MutationObservers, so we don't need to fall back in that case.
	
	// function makeRequestCallFromMessageChannel(callback) {
	//     var channel = new MessageChannel();
	//     channel.port1.onmessage = callback;
	//     return function requestCall() {
	//         channel.port2.postMessage(0);
	//     };
	// }
	
	// For reasons explained above, we are also unable to use `setImmediate`
	// under any circumstances.
	// Even if we were, there is another bug in Internet Explorer 10.
	// It is not sufficient to assign `setImmediate` to `requestFlush` because
	// `setImmediate` must be called *by name* and therefore must be wrapped in a
	// closure.
	// Never forget.
	
	// function makeRequestCallFromSetImmediate(callback) {
	//     return function requestCall() {
	//         setImmediate(callback);
	//     };
	// }
	
	// Safari 6.0 has a problem where timers will get lost while the user is
	// scrolling. This problem does not impact ASAP because Safari 6.0 supports
	// mutation observers, so that implementation is used instead.
	// However, if we ever elect to use timers in Safari, the prevalent work-around
	// is to add a scroll event listener that calls for a flush.
	
	// `setTimeout` does not call the passed callback if the delay is less than
	// approximately 7 in web workers in Firefox 8 through 18, and sometimes not
	// even then.
	
	function makeRequestCallFromTimer(callback) {
	    return function requestCall() {
	        // We dispatch a timeout with a specified delay of 0 for engines that
	        // can reliably accommodate that request. This will usually be snapped
	        // to a 4 milisecond delay, but once we're flushing, there's no delay
	        // between events.
	        var timeoutHandle = setTimeout(handleTimer, 0);
	        // However, since this timer gets frequently dropped in Firefox
	        // workers, we enlist an interval handle that will try to fire
	        // an event 20 times per second until it succeeds.
	        var intervalHandle = setInterval(handleTimer, 50);
	
	        function handleTimer() {
	            // Whichever timer succeeds will cancel both timers and
	            // execute the callback.
	            clearTimeout(timeoutHandle);
	            clearInterval(intervalHandle);
	            callback();
	        }
	    };
	}
	
	// This is for `asap.js` only.
	// Its name will be periodically randomized to break any code that depends on
	// its existence.
	rawAsap.makeRequestCallFromTimer = makeRequestCallFromTimer;
	
	// ASAP was originally a nextTick shim included in Q. This was factored out
	// into this ASAP package. It was later adapted to RSVP which made further
	// amendments. These decisions, particularly to marginalize MessageChannel and
	// to capture the MutationObserver implementation in a closure, were integrated
	// back into ASAP proper.
	// https://github.com/tildeio/rsvp.js/blob/cddf7232546a9cf858524b75cde6f9edf72620a7/lib/rsvp/asap.js
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var extend = __webpack_require__(8);
	
	module.exports = function(parent, methods) {
	  if (typeof parent !== 'function') {
	    methods = parent;
	    parent  = Object;
	  }
	
	  var klass = function() {
	    if (!this.initialize) return this;
	    return this.initialize.apply(this, arguments) || this;
	  };
	
	  var bridge = function() {};
	  bridge.prototype = parent.prototype;
	
	  klass.prototype = new bridge();
	  extend(klass.prototype, methods);
	
	  return klass;
	};


/***/ },
/* 8 */
/***/ function(module, exports) {

	'use strict';
	
	module.exports = function(dest, source, overwrite) {
	  if (!source) return dest;
	  for (var key in source) {
	    if (!source.hasOwnProperty(key)) continue;
	    if (dest.hasOwnProperty(key) && overwrite === false) continue;
	    if (dest[key] !== source[key])
	      dest[key] = source[key];
	  }
	  return dest;
	};


/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var asap = __webpack_require__(5);
	
	var PENDING   = 0,
	    FULFILLED = 1,
	    REJECTED  = 2;
	
	var RETURN = function(x) { return x },
	    THROW  = function(x) { throw  x };
	
	var Promise = function(task) {
	  this._state       = PENDING;
	  this._onFulfilled = [];
	  this._onRejected  = [];
	
	  if (typeof task !== 'function') return;
	  var self = this;
	
	  task(function(value)  { resolve(self, value) },
	       function(reason) { reject(self, reason) });
	};
	
	Promise.prototype.then = function(onFulfilled, onRejected) {
	  var next = new Promise();
	  registerOnFulfilled(this, onFulfilled, next);
	  registerOnRejected(this, onRejected, next);
	  return next;
	};
	
	Promise.prototype['catch'] = function(onRejected) {
	  return this.then(null, onRejected);
	};
	
	var registerOnFulfilled = function(promise, onFulfilled, next) {
	  if (typeof onFulfilled !== 'function') onFulfilled = RETURN;
	  var handler = function(value) { invoke(onFulfilled, value, next) };
	
	  if (promise._state === PENDING) {
	    promise._onFulfilled.push(handler);
	  } else if (promise._state === FULFILLED) {
	    handler(promise._value);
	  }
	};
	
	var registerOnRejected = function(promise, onRejected, next) {
	  if (typeof onRejected !== 'function') onRejected = THROW;
	  var handler = function(reason) { invoke(onRejected, reason, next) };
	
	  if (promise._state === PENDING) {
	    promise._onRejected.push(handler);
	  } else if (promise._state === REJECTED) {
	    handler(promise._reason);
	  }
	};
	
	var invoke = function(fn, value, next) {
	  asap(function() { _invoke(fn, value, next) });
	};
	
	var _invoke = function(fn, value, next) {
	  var outcome;
	
	  try {
	    outcome = fn(value);
	  } catch (error) {
	    return reject(next, error);
	  }
	
	  if (outcome === next) {
	    reject(next, new TypeError('Recursive promise chain detected'));
	  } else {
	    resolve(next, outcome);
	  }
	};
	
	var resolve = function(promise, value) {
	  var called = false, type, then;
	
	  try {
	    type = typeof value;
	    then = value !== null && (type === 'function' || type === 'object') && value.then;
	
	    if (typeof then !== 'function') return fulfill(promise, value);
	
	    then.call(value, function(v) {
	      if (!(called ^ (called = true))) return;
	      resolve(promise, v);
	    }, function(r) {
	      if (!(called ^ (called = true))) return;
	      reject(promise, r);
	    });
	  } catch (error) {
	    if (!(called ^ (called = true))) return;
	    reject(promise, error);
	  }
	};
	
	var fulfill = function(promise, value) {
	  if (promise._state !== PENDING) return;
	
	  promise._state      = FULFILLED;
	  promise._value      = value;
	  promise._onRejected = [];
	
	  var onFulfilled = promise._onFulfilled, fn;
	  while (fn = onFulfilled.shift()) fn(value);
	};
	
	var reject = function(promise, reason) {
	  if (promise._state !== PENDING) return;
	
	  promise._state       = REJECTED;
	  promise._reason      = reason;
	  promise._onFulfilled = [];
	
	  var onRejected = promise._onRejected, fn;
	  while (fn = onRejected.shift()) fn(reason);
	};
	
	Promise.resolve = function(value) {
	  return new Promise(function(resolve, reject) { resolve(value) });
	};
	
	Promise.reject = function(reason) {
	  return new Promise(function(resolve, reject) { reject(reason) });
	};
	
	Promise.all = function(promises) {
	  return new Promise(function(resolve, reject) {
	    var list = [], n = promises.length, i;
	
	    if (n === 0) return resolve(list);
	
	    for (i = 0; i < n; i++) (function(promise, i) {
	      Promise.resolve(promise).then(function(value) {
	        list[i] = value;
	        if (--n === 0) resolve(list);
	      }, reject);
	    })(promises[i], i);
	  });
	};
	
	Promise.race = function(promises) {
	  return new Promise(function(resolve, reject) {
	    for (var i = 0, n = promises.length; i < n; i++)
	      Promise.resolve(promises[i]).then(resolve, reject);
	  });
	};
	
	Promise.deferred = Promise.pending = function() {
	  var tuple = {};
	
	  tuple.promise = new Promise(function(resolve, reject) {
	    tuple.resolve = resolve;
	    tuple.reject  = reject;
	  });
	  return tuple;
	};
	
	module.exports = Promise;


/***/ },
/* 10 */
/***/ function(module, exports) {

	'use strict';
	
	module.exports = {
	  isURI: function(uri) {
	    return uri && uri.protocol && uri.host && uri.path;
	  },
	
	  isSameOrigin: function(uri) {
	    return uri.protocol === location.protocol &&
	           uri.hostname === location.hostname &&
	           uri.port     === location.port;
	  },
	
	  parse: function(url) {
	    if (typeof url !== 'string') return url;
	    var uri = {}, parts, query, pairs, i, n, data;
	
	    var consume = function(name, pattern) {
	      url = url.replace(pattern, function(match) {
	        uri[name] = match;
	        return '';
	      });
	      uri[name] = uri[name] || '';
	    };
	
	    consume('protocol', /^[a-z]+\:/i);
	    consume('host',     /^\/\/[^\/\?#]+/);
	
	    if (!/^\//.test(url) && !uri.host)
	      url = location.pathname.replace(/[^\/]*$/, '') + url;
	
	    consume('pathname', /^[^\?#]*/);
	    consume('search',   /^\?[^#]*/);
	    consume('hash',     /^#.*/);
	
	    uri.protocol = uri.protocol || location.protocol;
	
	    if (uri.host) {
	      uri.host     = uri.host.substr(2);
	      parts        = uri.host.split(':');
	      uri.hostname = parts[0];
	      uri.port     = parts[1] || '';
	    } else {
	      uri.host     = location.host;
	      uri.hostname = location.hostname;
	      uri.port     = location.port;
	    }
	
	    uri.pathname = uri.pathname || '/';
	    uri.path = uri.pathname + uri.search;
	
	    query = uri.search.replace(/^\?/, '');
	    pairs = query ? query.split('&') : [];
	    data  = {};
	
	    for (i = 0, n = pairs.length; i < n; i++) {
	      parts = pairs[i].split('=');
	      data[decodeURIComponent(parts[0] || '')] = decodeURIComponent(parts[1] || '');
	    }
	
	    uri.query = data;
	
	    uri.href = this.stringify(uri);
	    return uri;
	  },
	
	  stringify: function(uri) {
	    var string = uri.protocol + '//' + uri.hostname;
	    if (uri.port) string += ':' + uri.port;
	    string += uri.pathname + this.queryString(uri.query) + (uri.hash || '');
	    return string;
	  },
	
	  queryString: function(query) {
	    var pairs = [];
	    for (var key in query) {
	      if (!query.hasOwnProperty(key)) continue;
	      pairs.push(encodeURIComponent(key) + '=' + encodeURIComponent(query[key]));
	    }
	    if (pairs.length === 0) return '';
	    return '?' + pairs.join('&');
	  }
	};


/***/ },
/* 11 */
/***/ function(module, exports) {

	'use strict';
	
	module.exports = {
	  commonElement: function(lista, listb) {
	    for (var i = 0, n = lista.length; i < n; i++) {
	      if (this.indexOf(listb, lista[i]) !== -1)
	        return lista[i];
	    }
	    return null;
	  },
	
	  indexOf: function(list, needle) {
	    if (list.indexOf) return list.indexOf(needle);
	
	    for (var i = 0, n = list.length; i < n; i++) {
	      if (list[i] === needle) return i;
	    }
	    return -1;
	  },
	
	  map: function(object, callback, context) {
	    if (object.map) return object.map(callback, context);
	    var result = [];
	
	    if (object instanceof Array) {
	      for (var i = 0, n = object.length; i < n; i++) {
	        result.push(callback.call(context || null, object[i], i));
	      }
	    } else {
	      for (var key in object) {
	        if (!object.hasOwnProperty(key)) continue;
	        result.push(callback.call(context || null, key, object[key]));
	      }
	    }
	    return result;
	  },
	
	  filter: function(array, callback, context) {
	    if (array.filter) return array.filter(callback, context);
	    var result = [];
	    for (var i = 0, n = array.length; i < n; i++) {
	      if (callback.call(context || null, array[i], i))
	        result.push(array[i]);
	    }
	    return result;
	  },
	
	  asyncEach: function(list, iterator, callback, context) {
	    var n       = list.length,
	        i       = -1,
	        calls   = 0,
	        looping = false;
	
	    var iterate = function() {
	      calls -= 1;
	      i += 1;
	      if (i === n) return callback && callback.call(context);
	      iterator(list[i], resume);
	    };
	
	    var loop = function() {
	      if (looping) return;
	      looping = true;
	      while (calls > 0) iterate();
	      looping = false;
	    };
	
	    var resume = function() {
	      calls += 1;
	      loop();
	    };
	    resume();
	  }
	};


/***/ },
/* 12 */
/***/ function(module, exports) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Event = {
	  _registry: [],
	
	  on: function(element, eventName, callback, context) {
	    var wrapped = function() { callback.call(context) };
	
	    if (element.addEventListener)
	      element.addEventListener(eventName, wrapped, false);
	    else
	      element.attachEvent('on' + eventName, wrapped);
	
	    this._registry.push({
	      _element:   element,
	      _type:      eventName,
	      _callback:  callback,
	      _context:     context,
	      _handler:   wrapped
	    });
	  },
	
	  detach: function(element, eventName, callback, context) {
	    var i = this._registry.length, register;
	    while (i--) {
	      register = this._registry[i];
	
	      if ((element    && element    !== register._element)  ||
	          (eventName  && eventName  !== register._type)     ||
	          (callback   && callback   !== register._callback) ||
	          (context    && context    !== register._context))
	        continue;
	
	      if (register._element.removeEventListener)
	        register._element.removeEventListener(register._type, register._handler, false);
	      else
	        register._element.detachEvent('on' + register._type, register._handler);
	
	      this._registry.splice(i,1);
	      register = null;
	    }
	  }
	};
	
	if (global.onunload !== undefined)
	  Event.on(global, 'unload', Event.detach, Event);
	
	module.exports = {
	  Event: Event
	};
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var array = __webpack_require__(11);
	
	module.exports = function(options, validKeys) {
	  for (var key in options) {
	    if (array.indexOf(validKeys, key) < 0)
	      throw new Error('Unrecognized option: ' + key);
	  }
	};


/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Promise   = __webpack_require__(9);
	
	module.exports = {
	  then: function(callback, errback) {
	    var self = this;
	    if (!this._promise)
	      this._promise = new Promise(function(resolve, reject) {
	        self._resolve = resolve;
	        self._reject  = reject;
	      });
	
	    if (arguments.length === 0)
	      return this._promise;
	    else
	      return this._promise.then(callback, errback);
	  },
	
	  callback: function(callback, context) {
	    return this.then(function(value) { callback.call(context, value) });
	  },
	
	  errback: function(callback, context) {
	    return this.then(null, function(reason) { callback.call(context, reason) });
	  },
	
	  timeout: function(seconds, message) {
	    this.then();
	    var self = this;
	    this._timer = global.setTimeout(function() {
	      self._reject(message);
	    }, seconds * 1000);
	  },
	
	  setDeferredStatus: function(status, value) {
	    if (this._timer) global.clearTimeout(this._timer);
	
	    this.then();
	
	    if (status === 'succeeded')
	      this._resolve(value);
	    else if (status === 'failed')
	      this._reject(value);
	    else
	      delete this._promise;
	  }
	};
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var extend       = __webpack_require__(8),
	    EventEmitter = __webpack_require__(16);
	
	var Publisher = {
	  countListeners: function(eventType) {
	    return this.listeners(eventType).length;
	  },
	
	  bind: function(eventType, listener, context) {
	    var slice   = Array.prototype.slice,
	        handler = function() { listener.apply(context, slice.call(arguments)) };
	
	    this._listeners = this._listeners || [];
	    this._listeners.push([eventType, listener, context, handler]);
	    return this.on(eventType, handler);
	  },
	
	  unbind: function(eventType, listener, context) {
	    this._listeners = this._listeners || [];
	    var n = this._listeners.length, tuple;
	
	    while (n--) {
	      tuple = this._listeners[n];
	      if (tuple[0] !== eventType) continue;
	      if (listener && (tuple[1] !== listener || tuple[2] !== context)) continue;
	      this._listeners.splice(n, 1);
	      this.removeListener(eventType, tuple[3]);
	    }
	  }
	};
	
	extend(Publisher, EventEmitter.prototype);
	Publisher.trigger = Publisher.emit;
	
	module.exports = Publisher;


/***/ },
/* 16 */
/***/ function(module, exports) {

	/*
	Copyright Joyent, Inc. and other Node contributors. All rights reserved.
	Permission is hereby granted, free of charge, to any person obtaining a copy of
	this software and associated documentation files (the "Software"), to deal in
	the Software without restriction, including without limitation the rights to
	use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
	of the Software, and to permit persons to whom the Software is furnished to do
	so, subject to the following conditions:
	
	The above copyright notice and this permission notice shall be included in all
	copies or substantial portions of the Software.
	
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
	SOFTWARE.
	*/
	
	var isArray = typeof Array.isArray === 'function'
	    ? Array.isArray
	    : function (xs) {
	        return Object.prototype.toString.call(xs) === '[object Array]'
	    }
	;
	function indexOf (xs, x) {
	    if (xs.indexOf) return xs.indexOf(x);
	    for (var i = 0; i < xs.length; i++) {
	        if (x === xs[i]) return i;
	    }
	    return -1;
	}
	
	function EventEmitter() {}
	module.exports = EventEmitter;
	
	EventEmitter.prototype.emit = function(type) {
	  // If there is no 'error' event listener then throw.
	  if (type === 'error') {
	    if (!this._events || !this._events.error ||
	        (isArray(this._events.error) && !this._events.error.length))
	    {
	      if (arguments[1] instanceof Error) {
	        throw arguments[1]; // Unhandled 'error' event
	      } else {
	        throw new Error("Uncaught, unspecified 'error' event.");
	      }
	      return false;
	    }
	  }
	
	  if (!this._events) return false;
	  var handler = this._events[type];
	  if (!handler) return false;
	
	  if (typeof handler == 'function') {
	    switch (arguments.length) {
	      // fast cases
	      case 1:
	        handler.call(this);
	        break;
	      case 2:
	        handler.call(this, arguments[1]);
	        break;
	      case 3:
	        handler.call(this, arguments[1], arguments[2]);
	        break;
	      // slower
	      default:
	        var args = Array.prototype.slice.call(arguments, 1);
	        handler.apply(this, args);
	    }
	    return true;
	
	  } else if (isArray(handler)) {
	    var args = Array.prototype.slice.call(arguments, 1);
	
	    var listeners = handler.slice();
	    for (var i = 0, l = listeners.length; i < l; i++) {
	      listeners[i].apply(this, args);
	    }
	    return true;
	
	  } else {
	    return false;
	  }
	};
	
	// EventEmitter is defined in src/node_events.cc
	// EventEmitter.prototype.emit() is also defined there.
	EventEmitter.prototype.addListener = function(type, listener) {
	  if ('function' !== typeof listener) {
	    throw new Error('addListener only takes instances of Function');
	  }
	
	  if (!this._events) this._events = {};
	
	  // To avoid recursion in the case that type == "newListeners"! Before
	  // adding it to the listeners, first emit "newListeners".
	  this.emit('newListener', type, listener);
	
	  if (!this._events[type]) {
	    // Optimize the case of one listener. Don't need the extra array object.
	    this._events[type] = listener;
	  } else if (isArray(this._events[type])) {
	    // If we've already got an array, just append.
	    this._events[type].push(listener);
	  } else {
	    // Adding the second element, need to change to array.
	    this._events[type] = [this._events[type], listener];
	  }
	
	  return this;
	};
	
	EventEmitter.prototype.on = EventEmitter.prototype.addListener;
	
	EventEmitter.prototype.once = function(type, listener) {
	  var self = this;
	  self.on(type, function g() {
	    self.removeListener(type, g);
	    listener.apply(this, arguments);
	  });
	
	  return this;
	};
	
	EventEmitter.prototype.removeListener = function(type, listener) {
	  if ('function' !== typeof listener) {
	    throw new Error('removeListener only takes instances of Function');
	  }
	
	  // does not use listeners(), so no side effect of creating _events[type]
	  if (!this._events || !this._events[type]) return this;
	
	  var list = this._events[type];
	
	  if (isArray(list)) {
	    var i = indexOf(list, listener);
	    if (i < 0) return this;
	    list.splice(i, 1);
	    if (list.length == 0)
	      delete this._events[type];
	  } else if (this._events[type] === listener) {
	    delete this._events[type];
	  }
	
	  return this;
	};
	
	EventEmitter.prototype.removeAllListeners = function(type) {
	  if (arguments.length === 0) {
	    this._events = {};
	    return this;
	  }
	
	  // does not use listeners(), so no side effect of creating _events[type]
	  if (type && this._events && this._events[type]) this._events[type] = null;
	  return this;
	};
	
	EventEmitter.prototype.listeners = function(type) {
	  if (!this._events) this._events = {};
	  if (!this._events[type]) this._events[type] = [];
	  if (!isArray(this._events[type])) {
	    this._events[type] = [this._events[type]];
	  }
	  return this._events[type];
	};


/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Class     = __webpack_require__(7),
	    extend    = __webpack_require__(8),
	    Publisher = __webpack_require__(15),
	    Grammar   = __webpack_require__(18);
	
	var Channel = Class({
	  initialize: function(name) {
	    this.id = this.name = name;
	  },
	
	  push: function(message) {
	    this.trigger('message', message);
	  },
	
	  isUnused: function() {
	    return this.countListeners('message') === 0;
	  }
	});
	
	extend(Channel.prototype, Publisher);
	
	extend(Channel, {
	  HANDSHAKE:    '/meta/handshake',
	  CONNECT:      '/meta/connect',
	  SUBSCRIBE:    '/meta/subscribe',
	  UNSUBSCRIBE:  '/meta/unsubscribe',
	  DISCONNECT:   '/meta/disconnect',
	
	  META:         'meta',
	  SERVICE:      'service',
	
	  expand: function(name) {
	    var segments = this.parse(name),
	        channels = ['/**', name];
	
	    var copy = segments.slice();
	    copy[copy.length - 1] = '*';
	    channels.push(this.unparse(copy));
	
	    for (var i = 1, n = segments.length; i < n; i++) {
	      copy = segments.slice(0, i);
	      copy.push('**');
	      channels.push(this.unparse(copy));
	    }
	
	    return channels;
	  },
	
	  isValid: function(name) {
	    return Grammar.CHANNEL_NAME.test(name) ||
	           Grammar.CHANNEL_PATTERN.test(name);
	  },
	
	  parse: function(name) {
	    if (!this.isValid(name)) return null;
	    return name.split('/').slice(1);
	  },
	
	  unparse: function(segments) {
	    return '/' + segments.join('/');
	  },
	
	  isMeta: function(name) {
	    var segments = this.parse(name);
	    return segments ? (segments[0] === this.META) : null;
	  },
	
	  isService: function(name) {
	    var segments = this.parse(name);
	    return segments ? (segments[0] === this.SERVICE) : null;
	  },
	
	  isSubscribable: function(name) {
	    if (!this.isValid(name)) return null;
	    return !this.isMeta(name) && !this.isService(name);
	  },
	
	  Set: Class({
	    initialize: function() {
	      this._channels = {};
	    },
	
	    getKeys: function() {
	      var keys = [];
	      for (var key in this._channels) keys.push(key);
	      return keys;
	    },
	
	    remove: function(name) {
	      delete this._channels[name];
	    },
	
	    hasSubscription: function(name) {
	      return this._channels.hasOwnProperty(name);
	    },
	
	    subscribe: function(names, subscription) {
	      var name;
	      for (var i = 0, n = names.length; i < n; i++) {
	        name = names[i];
	        var channel = this._channels[name] = this._channels[name] || new Channel(name);
	        channel.bind('message', subscription);
	      }
	    },
	
	    unsubscribe: function(name, subscription) {
	      var channel = this._channels[name];
	      if (!channel) return false;
	      channel.unbind('message', subscription);
	
	      if (channel.isUnused()) {
	        this.remove(name);
	        return true;
	      } else {
	        return false;
	      }
	    },
	
	    distributeMessage: function(message) {
	      var channels = Channel.expand(message.channel);
	
	      for (var i = 0, n = channels.length; i < n; i++) {
	        var channel = this._channels[channels[i]];
	        if (channel) channel.trigger('message', message);
	      }
	    }
	  })
	});
	
	module.exports = Channel;


/***/ },
/* 18 */
/***/ function(module, exports) {

	'use strict';
	
	module.exports = {
	  CHANNEL_NAME:     /^\/(((([a-z]|[A-Z])|[0-9])|(\-|\_|\!|\~|\(|\)|\$|\@)))+(\/(((([a-z]|[A-Z])|[0-9])|(\-|\_|\!|\~|\(|\)|\$|\@)))+)*$/,
	  CHANNEL_PATTERN:  /^(\/(((([a-z]|[A-Z])|[0-9])|(\-|\_|\!|\~|\(|\)|\$|\@)))+)*\/\*{1,2}$/,
	  ERROR:            /^([0-9][0-9][0-9]:(((([a-z]|[A-Z])|[0-9])|(\-|\_|\!|\~|\(|\)|\$|\@)| |\/|\*|\.))*(,(((([a-z]|[A-Z])|[0-9])|(\-|\_|\!|\~|\(|\)|\$|\@)| |\/|\*|\.))*)*:(((([a-z]|[A-Z])|[0-9])|(\-|\_|\!|\~|\(|\)|\$|\@)| |\/|\*|\.))*|[0-9][0-9][0-9]::(((([a-z]|[A-Z])|[0-9])|(\-|\_|\!|\~|\(|\)|\$|\@)| |\/|\*|\.))*)$/,
	  VERSION:          /^([0-9])+(\.(([a-z]|[A-Z])|[0-9])(((([a-z]|[A-Z])|[0-9])|\-|\_))*)*$/
	};


/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Class     = __webpack_require__(7),
	    URI       = __webpack_require__(10),
	    cookies   = __webpack_require__(20),
	    extend    = __webpack_require__(8),
	    Logging   = __webpack_require__(2),
	    Publisher = __webpack_require__(15),
	    Transport = __webpack_require__(21),
	    Scheduler = __webpack_require__(32);
	
	var Dispatcher = Class({ className: 'Dispatcher',
	  MAX_REQUEST_SIZE: 2048,
	  DEFAULT_RETRY:    5,
	
	  UP:   1,
	  DOWN: 2,
	
	  initialize: function(client, endpoint, options) {
	    this._client     = client;
	    this.endpoint    = URI.parse(endpoint);
	    this._alternates = options.endpoints || {};
	
	    this.cookies      = cookies.CookieJar && new cookies.CookieJar();
	    this._disabled    = [];
	    this._envelopes   = {};
	    this.headers      = {};
	    this.retry        = options.retry || this.DEFAULT_RETRY;
	    this._scheduler   = options.scheduler || Scheduler;
	    this._state       = 0;
	    this.transports   = {};
	    this.wsExtensions = [];
	
	    this.proxy = options.proxy || {};
	    if (typeof this._proxy === 'string') this._proxy = {origin: this._proxy};
	
	    var exts = options.websocketExtensions;
	    if (exts) {
	      exts = [].concat(exts);
	      for (var i = 0, n = exts.length; i < n; i++)
	        this.addWebsocketExtension(exts[i]);
	    }
	
	    this.tls = options.tls || {};
	    this.tls.ca = this.tls.ca || options.ca;
	
	    for (var type in this._alternates)
	      this._alternates[type] = URI.parse(this._alternates[type]);
	
	    this.maxRequestSize = this.MAX_REQUEST_SIZE;
	  },
	
	  endpointFor: function(connectionType) {
	    return this._alternates[connectionType] || this.endpoint;
	  },
	
	  addWebsocketExtension: function(extension) {
	    this.wsExtensions.push(extension);
	  },
	
	  disable: function(feature) {
	    this._disabled.push(feature);
	  },
	
	  setHeader: function(name, value) {
	    this.headers[name] = value;
	  },
	
	  close: function() {
	    var transport = this._transport;
	    delete this._transport;
	    if (transport) transport.close();
	  },
	
	  getConnectionTypes: function() {
	    return Transport.getConnectionTypes();
	  },
	
	  selectTransport: function(transportTypes) {
	    Transport.get(this, transportTypes, this._disabled, function(transport) {
	      this.debug('Selected ? transport for ?', transport.connectionType, URI.stringify(transport.endpoint));
	
	      if (transport === this._transport) return;
	      if (this._transport) this._transport.close();
	
	      this._transport = transport;
	      this.connectionType = transport.connectionType;
	    }, this);
	  },
	
	  sendMessage: function(message, timeout, options) {
	    options = options || {};
	
	    var id       = message.id,
	        attempts = options.attempts,
	        deadline = options.deadline && new Date().getTime() + (options.deadline * 1000),
	        envelope = this._envelopes[id],
	        scheduler;
	
	    if (!envelope) {
	      scheduler = new this._scheduler(message, {timeout: timeout, interval: this.retry, attempts: attempts, deadline: deadline});
	      envelope  = this._envelopes[id] = {message: message, scheduler: scheduler};
	    }
	
	    this._sendEnvelope(envelope);
	  },
	
	  _sendEnvelope: function(envelope) {
	    if (!this._transport) return;
	    if (envelope.request || envelope.timer) return;
	
	    var message   = envelope.message,
	        scheduler = envelope.scheduler,
	        self      = this;
	
	    if (!scheduler.isDeliverable()) {
	      scheduler.abort();
	      delete this._envelopes[message.id];
	      return;
	    }
	
	    envelope.timer = global.setTimeout(function() {
	      self.handleError(message);
	    }, scheduler.getTimeout() * 1000);
	
	    scheduler.send();
	    envelope.request = this._transport.sendMessage(message);
	  },
	
	  handleResponse: function(reply) {
	    var envelope = this._envelopes[reply.id];
	
	    if (reply.successful !== undefined && envelope) {
	      envelope.scheduler.succeed();
	      delete this._envelopes[reply.id];
	      global.clearTimeout(envelope.timer);
	    }
	
	    this.trigger('message', reply);
	
	    if (this._state === this.UP) return;
	    this._state = this.UP;
	    this._client.trigger('transport:up');
	  },
	
	  handleError: function(message, immediate) {
	    var envelope = this._envelopes[message.id],
	        request  = envelope && envelope.request,
	        self     = this;
	
	    if (!request) return;
	
	    request.then(function(req) {
	      if (req && req.abort) req.abort();
	    });
	
	    var scheduler = envelope.scheduler;
	    scheduler.fail();
	
	    global.clearTimeout(envelope.timer);
	    envelope.request = envelope.timer = null;
	
	    if (immediate) {
	      this._sendEnvelope(envelope);
	    } else {
	      envelope.timer = global.setTimeout(function() {
	        envelope.timer = null;
	        self._sendEnvelope(envelope);
	      }, scheduler.getInterval() * 1000);
	    }
	
	    if (this._state === this.DOWN) return;
	    this._state = this.DOWN;
	    this._client.trigger('transport:down');
	  }
	});
	
	Dispatcher.create = function(client, endpoint, options) {
	  return new Dispatcher(client, endpoint, options);
	};
	
	extend(Dispatcher.prototype, Publisher);
	extend(Dispatcher.prototype, Logging);
	
	module.exports = Dispatcher;
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 20 */
/***/ function(module, exports) {

	'use strict';
	
	module.exports = {};


/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Transport = __webpack_require__(22);
	
	Transport.register('websocket', __webpack_require__(24));
	Transport.register('eventsource', __webpack_require__(28));
	Transport.register('long-polling', __webpack_require__(29));
	Transport.register('cross-origin-long-polling', __webpack_require__(30));
	Transport.register('callback-polling', __webpack_require__(31));
	
	module.exports = Transport;


/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Class    = __webpack_require__(7),
	    Cookie   = __webpack_require__(20).Cookie,
	    Promise  = __webpack_require__(9),
	    URI      = __webpack_require__(10),
	    array    = __webpack_require__(11),
	    extend   = __webpack_require__(8),
	    Logging  = __webpack_require__(2),
	    Timeouts = __webpack_require__(23),
	    Channel  = __webpack_require__(17);
	
	var Transport = extend(Class({ className: 'Transport',
	  DEFAULT_PORTS: {'http:': 80, 'https:': 443, 'ws:': 80, 'wss:': 443},
	  MAX_DELAY:     0,
	
	  batching:  true,
	
	  initialize: function(dispatcher, endpoint) {
	    this._dispatcher = dispatcher;
	    this.endpoint    = endpoint;
	    this._outbox     = [];
	    this._proxy      = extend({}, this._dispatcher.proxy);
	
	    if (!this._proxy.origin)
	      this._proxy.origin = this._findProxy();
	  },
	
	  close: function() {},
	
	  encode: function(messages) {
	    return '';
	  },
	
	  sendMessage: function(message) {
	    this.debug('Client ? sending message to ?: ?',
	               this._dispatcher.clientId, URI.stringify(this.endpoint), message);
	
	    if (!this.batching) return Promise.resolve(this.request([message]));
	
	    this._outbox.push(message);
	    this._flushLargeBatch();
	
	    if (message.channel === Channel.HANDSHAKE)
	      return this._publish(0.01);
	
	    if (message.channel === Channel.CONNECT)
	      this._connectMessage = message;
	
	    return this._publish(this.MAX_DELAY);
	  },
	
	  _makePromise: function() {
	    var self = this;
	
	    this._requestPromise = this._requestPromise || new Promise(function(resolve) {
	      self._resolvePromise = resolve;
	    });
	  },
	
	  _publish: function(delay) {
	    this._makePromise();
	
	    this.addTimeout('publish', delay, function() {
	      this._flush();
	      delete this._requestPromise;
	    }, this);
	
	    return this._requestPromise;
	  },
	
	  _flush: function() {
	    this.removeTimeout('publish');
	
	    if (this._outbox.length > 1 && this._connectMessage)
	      this._connectMessage.advice = {timeout: 0};
	
	    this._resolvePromise(this.request(this._outbox));
	
	    this._connectMessage = null;
	    this._outbox = [];
	  },
	
	  _flushLargeBatch: function() {
	    var string = this.encode(this._outbox);
	    if (string.length < this._dispatcher.maxRequestSize) return;
	    var last = this._outbox.pop();
	
	    this._makePromise();
	    this._flush();
	
	    if (last) this._outbox.push(last);
	  },
	
	  _receive: function(replies) {
	    if (!replies) return;
	    replies = [].concat(replies);
	
	    this.debug('Client ? received from ? via ?: ?',
	               this._dispatcher.clientId, URI.stringify(this.endpoint), this.connectionType, replies);
	
	    for (var i = 0, n = replies.length; i < n; i++)
	      this._dispatcher.handleResponse(replies[i]);
	  },
	
	  _handleError: function(messages, immediate) {
	    messages = [].concat(messages);
	
	    this.debug('Client ? failed to send to ? via ?: ?',
	               this._dispatcher.clientId, URI.stringify(this.endpoint), this.connectionType, messages);
	
	    for (var i = 0, n = messages.length; i < n; i++)
	      this._dispatcher.handleError(messages[i]);
	  },
	
	  _getCookies: function() {
	    var cookies = this._dispatcher.cookies,
	        url     = URI.stringify(this.endpoint);
	
	    if (!cookies) return '';
	
	    return array.map(cookies.getCookiesSync(url), function(cookie) {
	      return cookie.cookieString();
	    }).join('; ');
	  },
	
	  _storeCookies: function(setCookie) {
	    var cookies = this._dispatcher.cookies,
	        url     = URI.stringify(this.endpoint),
	        cookie;
	
	    if (!setCookie || !cookies) return;
	    setCookie = [].concat(setCookie);
	
	    for (var i = 0, n = setCookie.length; i < n; i++) {
	      cookie = Cookie.parse(setCookie[i]);
	      cookies.setCookieSync(cookie, url);
	    }
	  },
	
	  _findProxy: function() {
	    if (typeof process === 'undefined') return undefined;
	
	    var protocol = this.endpoint.protocol;
	    if (!protocol) return undefined;
	
	    var name   = protocol.replace(/:$/, '').toLowerCase() + '_proxy',
	        upcase = name.toUpperCase(),
	        env    = process.env,
	        keys, proxy;
	
	    if (name === 'http_proxy' && env.REQUEST_METHOD) {
	      keys = Object.keys(env).filter(function(k) { return /^http_proxy$/i.test(k) });
	      if (keys.length === 1) {
	        if (keys[0] === name && env[upcase] === undefined)
	          proxy = env[name];
	      } else if (keys.length > 1) {
	        proxy = env[name];
	      }
	      proxy = proxy || env['CGI_' + upcase];
	    } else {
	      proxy = env[name] || env[upcase];
	      if (proxy && !env[name])
	        console.warn('The environment variable ' + upcase +
	                     ' is discouraged. Use ' + name + '.');
	    }
	    return proxy;
	  }
	
	}), {
	  get: function(dispatcher, allowed, disabled, callback, context) {
	    var endpoint = dispatcher.endpoint;
	
	    array.asyncEach(this._transports, function(pair, resume) {
	      var connType     = pair[0], klass = pair[1],
	          connEndpoint = dispatcher.endpointFor(connType);
	
	      if (array.indexOf(disabled, connType) >= 0)
	        return resume();
	
	      if (array.indexOf(allowed, connType) < 0) {
	        klass.isUsable(dispatcher, connEndpoint, function() {});
	        return resume();
	      }
	
	      klass.isUsable(dispatcher, connEndpoint, function(isUsable) {
	        if (!isUsable) return resume();
	        var transport = klass.hasOwnProperty('create') ? klass.create(dispatcher, connEndpoint) : new klass(dispatcher, connEndpoint);
	        callback.call(context, transport);
	      });
	    }, function() {
	      throw new Error('Could not find a usable connection type for ' + URI.stringify(endpoint));
	    });
	  },
	
	  register: function(type, klass) {
	    this._transports.push([type, klass]);
	    klass.prototype.connectionType = type;
	  },
	
	  getConnectionTypes: function() {
	    return array.map(this._transports, function(t) { return t[0] });
	  },
	
	  _transports: []
	});
	
	extend(Transport.prototype, Logging);
	extend(Transport.prototype, Timeouts);
	
	module.exports = Transport;


/***/ },
/* 23 */
/***/ function(module, exports) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	module.exports = {
	  addTimeout: function(name, delay, callback, context) {
	    this._timeouts = this._timeouts || {};
	    if (this._timeouts.hasOwnProperty(name)) return;
	    var self = this;
	    this._timeouts[name] = global.setTimeout(function() {
	      delete self._timeouts[name];
	      callback.call(context);
	    }, 1000 * delay);
	  },
	
	  removeTimeout: function(name) {
	    this._timeouts = this._timeouts || {};
	    var timeout = this._timeouts[name];
	    if (!timeout) return;
	    global.clearTimeout(timeout);
	    delete this._timeouts[name];
	  },
	
	  removeAllTimeouts: function() {
	    this._timeouts = this._timeouts || {};
	    for (var name in this._timeouts) this.removeTimeout(name);
	  }
	};
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 24 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Class      = __webpack_require__(7),
	    Promise    = __webpack_require__(9),
	    Set        = __webpack_require__(25),
	    URI        = __webpack_require__(10),
	    browser    = __webpack_require__(12),
	    copyObject = __webpack_require__(26),
	    extend     = __webpack_require__(8),
	    toJSON     = __webpack_require__(3),
	    ws         = __webpack_require__(27),
	    Deferrable = __webpack_require__(14),
	    Transport  = __webpack_require__(22);
	
	var WebSocket = extend(Class(Transport, {
	  UNCONNECTED:  1,
	  CONNECTING:   2,
	  CONNECTED:    3,
	
	  batching:     false,
	
	  isUsable: function(callback, context) {
	    this.callback(function() { callback.call(context, true) });
	    this.errback(function() { callback.call(context, false) });
	    this.connect();
	  },
	
	  request: function(messages) {
	    this._pending = this._pending || new Set();
	    for (var i = 0, n = messages.length; i < n; i++) this._pending.add(messages[i]);
	
	    var self = this;
	
	    var promise = new Promise(function(resolve, reject) {
	      self.callback(function(socket) {
	        if (!socket || socket.readyState !== 1) return;
	        socket.send(toJSON(messages));
	        resolve(socket);
	      });
	
	      self.connect();
	    });
	
	    return {
	      abort: function() { promise.then(function(ws) { ws.close() }) }
	    };
	  },
	
	  connect: function() {
	    if (WebSocket._unloaded) return;
	
	    this._state = this._state || this.UNCONNECTED;
	    if (this._state !== this.UNCONNECTED) return;
	    this._state = this.CONNECTING;
	
	    var socket = this._createSocket();
	    if (!socket) return this.setDeferredStatus('failed');
	
	    var self = this;
	
	    socket.onopen = function() {
	      if (socket.headers) self._storeCookies(socket.headers['set-cookie']);
	      self._socket = socket;
	      self._state = self.CONNECTED;
	      self._everConnected = true;
	      self._ping();
	      self.setDeferredStatus('succeeded', socket);
	    };
	
	    var closed = false;
	    socket.onclose = socket.onerror = function() {
	      if (closed) return;
	      closed = true;
	
	      var wasConnected = (self._state === self.CONNECTED);
	      socket.onopen = socket.onclose = socket.onerror = socket.onmessage = null;
	
	      delete self._socket;
	      self._state = self.UNCONNECTED;
	      self.removeTimeout('ping');
	
	      var pending = self._pending ? self._pending.toArray() : [];
	      delete self._pending;
	
	      if (wasConnected || self._everConnected) {
	        self.setDeferredStatus('unknown');
	        self._handleError(pending, wasConnected);
	      } else {
	        self.setDeferredStatus('failed');
	      }
	    };
	
	    socket.onmessage = function(event) {
	      var replies;
	      try { replies = JSON.parse(event.data) } catch (error) {}
	
	      if (!replies) return;
	
	      replies = [].concat(replies);
	
	      for (var i = 0, n = replies.length; i < n; i++) {
	        if (replies[i].successful === undefined) continue;
	        self._pending.remove(replies[i]);
	      }
	      self._receive(replies);
	    };
	  },
	
	  close: function() {
	    if (!this._socket) return;
	    this._socket.close();
	  },
	
	  _createSocket: function() {
	    var url        = WebSocket.getSocketUrl(this.endpoint),
	        headers    = this._dispatcher.headers,
	        extensions = this._dispatcher.wsExtensions,
	        cookie     = this._getCookies(),
	        tls        = this._dispatcher.tls,
	        options    = {extensions: extensions, headers: headers, proxy: this._proxy, tls: tls};
	
	    if (cookie !== '') options.headers['Cookie'] = cookie;
	
	    return ws.create(url, [], options);
	  },
	
	  _ping: function() {
	    if (!this._socket || this._socket.readyState !== 1) return;
	    this._socket.send('[]');
	    this.addTimeout('ping', this._dispatcher.timeout / 2, this._ping, this);
	  }
	
	}), {
	  PROTOCOLS: {
	    'http:':  'ws:',
	    'https:': 'wss:'
	  },
	
	  create: function(dispatcher, endpoint) {
	    var sockets = dispatcher.transports.websocket = dispatcher.transports.websocket || {};
	    sockets[endpoint.href] = sockets[endpoint.href] || new this(dispatcher, endpoint);
	    return sockets[endpoint.href];
	  },
	
	  getSocketUrl: function(endpoint) {
	    endpoint = copyObject(endpoint);
	    endpoint.protocol = this.PROTOCOLS[endpoint.protocol];
	    return URI.stringify(endpoint);
	  },
	
	  isUsable: function(dispatcher, endpoint, callback, context) {
	    this.create(dispatcher, endpoint).isUsable(callback, context);
	  }
	});
	
	extend(WebSocket.prototype, Deferrable);
	
	if (browser.Event && global.onbeforeunload !== undefined)
	  browser.Event.on(global, 'beforeunload', function() { WebSocket._unloaded = true });
	
	module.exports = WebSocket;
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Class = __webpack_require__(7);
	
	module.exports = Class({
	  initialize: function() {
	    this._index = {};
	  },
	
	  add: function(item) {
	    var key = (item.id !== undefined) ? item.id : item;
	    if (this._index.hasOwnProperty(key)) return false;
	    this._index[key] = item;
	    return true;
	  },
	
	  forEach: function(block, context) {
	    for (var key in this._index) {
	      if (this._index.hasOwnProperty(key))
	        block.call(context, this._index[key]);
	    }
	  },
	
	  isEmpty: function() {
	    for (var key in this._index) {
	      if (this._index.hasOwnProperty(key)) return false;
	    }
	    return true;
	  },
	
	  member: function(item) {
	    for (var key in this._index) {
	      if (this._index[key] === item) return true;
	    }
	    return false;
	  },
	
	  remove: function(item) {
	    var key = (item.id !== undefined) ? item.id : item;
	    var removed = this._index[key];
	    delete this._index[key];
	    return removed;
	  },
	
	  toArray: function() {
	    var array = [];
	    this.forEach(function(item) { array.push(item) });
	    return array;
	  }
	});


/***/ },
/* 26 */
/***/ function(module, exports) {

	'use strict';
	
	var copyObject = function(object) {
	  var clone, i, key;
	  if (object instanceof Array) {
	    clone = [];
	    i = object.length;
	    while (i--) clone[i] = copyObject(object[i]);
	    return clone;
	  } else if (typeof object === 'object') {
	    clone = (object === null) ? null : {};
	    for (key in object) clone[key] = copyObject(object[key]);
	    return clone;
	  } else {
	    return object;
	  }
	};
	
	module.exports = copyObject;


/***/ },
/* 27 */
/***/ function(module, exports) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var WS = global.MozWebSocket || global.WebSocket;
	
	module.exports = {
	  create: function(url, protocols, options) {
	    if (typeof WS !== 'function') return null;
	    return new WS(url);
	  }
	};
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Class      = __webpack_require__(7),
	    URI        = __webpack_require__(10),
	    copyObject = __webpack_require__(26),
	    extend     = __webpack_require__(8),
	    Deferrable = __webpack_require__(14),
	    Transport  = __webpack_require__(22),
	    XHR        = __webpack_require__(29);
	
	var EventSource = extend(Class(Transport, {
	  initialize: function(dispatcher, endpoint) {
	    Transport.prototype.initialize.call(this, dispatcher, endpoint);
	    if (!global.EventSource) return this.setDeferredStatus('failed');
	
	    this._xhr = new XHR(dispatcher, endpoint);
	
	    endpoint = copyObject(endpoint);
	    endpoint.pathname += '/' + dispatcher.clientId;
	
	    var socket = new global.EventSource(URI.stringify(endpoint)),
	        self   = this;
	
	    socket.onopen = function() {
	      self._everConnected = true;
	      self.setDeferredStatus('succeeded');
	    };
	
	    socket.onerror = function() {
	      if (self._everConnected) {
	        self._handleError([]);
	      } else {
	        self.setDeferredStatus('failed');
	        socket.close();
	      }
	    };
	
	    socket.onmessage = function(event) {
	      var replies;
	      try { replies = JSON.parse(event.data) } catch (error) {}
	
	      if (replies)
	        self._receive(replies);
	      else
	        self._handleError([]);
	    };
	
	    this._socket = socket;
	  },
	
	  close: function() {
	    if (!this._socket) return;
	    this._socket.onopen = this._socket.onerror = this._socket.onmessage = null;
	    this._socket.close();
	    delete this._socket;
	  },
	
	  isUsable: function(callback, context) {
	    this.callback(function() { callback.call(context, true) });
	    this.errback(function() { callback.call(context, false) });
	  },
	
	  encode: function(messages) {
	    return this._xhr.encode(messages);
	  },
	
	  request: function(messages) {
	    return this._xhr.request(messages);
	  }
	
	}), {
	  isUsable: function(dispatcher, endpoint, callback, context) {
	    var id = dispatcher.clientId;
	    if (!id) return callback.call(context, false);
	
	    XHR.isUsable(dispatcher, endpoint, function(usable) {
	      if (!usable) return callback.call(context, false);
	      this.create(dispatcher, endpoint).isUsable(callback, context);
	    }, this);
	  },
	
	  create: function(dispatcher, endpoint) {
	    var sockets = dispatcher.transports.eventsource = dispatcher.transports.eventsource || {},
	        id      = dispatcher.clientId;
	
	    var url = copyObject(endpoint);
	    url.pathname += '/' + (id || '');
	    url = URI.stringify(url);
	
	    sockets[url] = sockets[url] || new this(dispatcher, endpoint);
	    return sockets[url];
	  }
	});
	
	extend(EventSource.prototype, Deferrable);
	
	module.exports = EventSource;
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Class     = __webpack_require__(7),
	    URI       = __webpack_require__(10),
	    browser   = __webpack_require__(12),
	    extend    = __webpack_require__(8),
	    toJSON    = __webpack_require__(3),
	    Transport = __webpack_require__(22);
	
	var XHR = extend(Class(Transport, {
	  encode: function(messages) {
	    return toJSON(messages);
	  },
	
	  request: function(messages) {
	    var href = this.endpoint.href,
	        self = this,
	        xhr;
	
	    // Prefer XMLHttpRequest over ActiveXObject if they both exist
	    if (global.XMLHttpRequest) {
	      xhr = new XMLHttpRequest();
	    } else if (global.ActiveXObject) {
	      xhr = new ActiveXObject('Microsoft.XMLHTTP');
	    } else {
	      return this._handleError(messages);
	    }
	
	    xhr.open('POST', href, true);
	    xhr.setRequestHeader('Content-Type', 'application/json');
	    xhr.setRequestHeader('Pragma', 'no-cache');
	    xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
	
	    var headers = this._dispatcher.headers;
	    for (var key in headers) {
	      if (!headers.hasOwnProperty(key)) continue;
	      xhr.setRequestHeader(key, headers[key]);
	    }
	
	    var abort = function() { xhr.abort() };
	    if (global.onbeforeunload !== undefined)
	      browser.Event.on(global, 'beforeunload', abort);
	
	    xhr.onreadystatechange = function() {
	      if (!xhr || xhr.readyState !== 4) return;
	
	      var replies    = null,
	          status     = xhr.status,
	          text       = xhr.responseText,
	          successful = (status >= 200 && status < 300) || status === 304 || status === 1223;
	
	      if (global.onbeforeunload !== undefined)
	        browser.Event.detach(global, 'beforeunload', abort);
	
	      xhr.onreadystatechange = function() {};
	      xhr = null;
	
	      if (!successful) return self._handleError(messages);
	
	      try {
	        replies = JSON.parse(text);
	      } catch (error) {}
	
	      if (replies)
	        self._receive(replies);
	      else
	        self._handleError(messages);
	    };
	
	    xhr.send(this.encode(messages));
	    return xhr;
	  }
	}), {
	  isUsable: function(dispatcher, endpoint, callback, context) {
	    var usable = (navigator.product === 'ReactNative')
	              || URI.isSameOrigin(endpoint);
	
	    callback.call(context, usable);
	  }
	});
	
	module.exports = XHR;
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Class     = __webpack_require__(7),
	    Set       = __webpack_require__(25),
	    URI       = __webpack_require__(10),
	    extend    = __webpack_require__(8),
	    toJSON    = __webpack_require__(3),
	    Transport = __webpack_require__(22);
	
	var CORS = extend(Class(Transport, {
	  encode: function(messages) {
	    return 'message=' + encodeURIComponent(toJSON(messages));
	  },
	
	  request: function(messages) {
	    var xhrClass = global.XDomainRequest ? XDomainRequest : XMLHttpRequest,
	        xhr      = new xhrClass(),
	        id       = ++CORS._id,
	        headers  = this._dispatcher.headers,
	        self     = this,
	        key;
	
	    xhr.open('POST', URI.stringify(this.endpoint), true);
	
	    if (xhr.setRequestHeader) {
	      xhr.setRequestHeader('Pragma', 'no-cache');
	      for (key in headers) {
	        if (!headers.hasOwnProperty(key)) continue;
	        xhr.setRequestHeader(key, headers[key]);
	      }
	    }
	
	    var cleanUp = function() {
	      if (!xhr) return false;
	      CORS._pending.remove(id);
	      xhr.onload = xhr.onerror = xhr.ontimeout = xhr.onprogress = null;
	      xhr = null;
	    };
	
	    xhr.onload = function() {
	      var replies;
	      try { replies = JSON.parse(xhr.responseText) } catch (error) {}
	
	      cleanUp();
	
	      if (replies)
	        self._receive(replies);
	      else
	        self._handleError(messages);
	    };
	
	    xhr.onerror = xhr.ontimeout = function() {
	      cleanUp();
	      self._handleError(messages);
	    };
	
	    xhr.onprogress = function() {};
	
	    if (xhrClass === global.XDomainRequest)
	      CORS._pending.add({id: id, xhr: xhr});
	
	    xhr.send(this.encode(messages));
	    return xhr;
	  }
	}), {
	  _id:      0,
	  _pending: new Set(),
	
	  isUsable: function(dispatcher, endpoint, callback, context) {
	    if (URI.isSameOrigin(endpoint))
	      return callback.call(context, false);
	
	    if (global.XDomainRequest)
	      return callback.call(context, endpoint.protocol === location.protocol);
	
	    if (global.XMLHttpRequest) {
	      var xhr = new XMLHttpRequest();
	      return callback.call(context, xhr.withCredentials !== undefined);
	    }
	    return callback.call(context, false);
	  }
	});
	
	module.exports = CORS;
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';
	
	var Class      = __webpack_require__(7),
	    URI        = __webpack_require__(10),
	    copyObject = __webpack_require__(26),
	    extend     = __webpack_require__(8),
	    toJSON     = __webpack_require__(3),
	    Transport  = __webpack_require__(22);
	
	var JSONP = extend(Class(Transport, {
	 encode: function(messages) {
	    var url = copyObject(this.endpoint);
	    url.query.message = toJSON(messages);
	    url.query.jsonp   = '__jsonp' + JSONP._cbCount + '__';
	    return URI.stringify(url);
	  },
	
	  request: function(messages) {
	    var head         = document.getElementsByTagName('head')[0],
	        script       = document.createElement('script'),
	        callbackName = JSONP.getCallbackName(),
	        endpoint     = copyObject(this.endpoint),
	        self         = this;
	
	    endpoint.query.message = toJSON(messages);
	    endpoint.query.jsonp   = callbackName;
	
	    var cleanup = function() {
	      if (!global[callbackName]) return false;
	      global[callbackName] = undefined;
	      try { delete global[callbackName] } catch (error) {}
	      script.parentNode.removeChild(script);
	    };
	
	    global[callbackName] = function(replies) {
	      cleanup();
	      self._receive(replies);
	    };
	
	    script.type = 'text/javascript';
	    script.src  = URI.stringify(endpoint);
	    head.appendChild(script);
	
	    script.onerror = function() {
	      cleanup();
	      self._handleError(messages);
	    };
	
	    return {abort: cleanup};
	  }
	}), {
	  _cbCount: 0,
	
	  getCallbackName: function() {
	    this._cbCount += 1;
	    return '__jsonp' + this._cbCount + '__';
	  },
	
	  isUsable: function(dispatcher, endpoint, callback, context) {
	    callback.call(context, true);
	  }
	});
	
	module.exports = JSONP;
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var extend = __webpack_require__(8);
	
	var Scheduler = function(message, options) {
	  this.message  = message;
	  this.options  = options;
	  this.attempts = 0;
	};
	
	extend(Scheduler.prototype, {
	  getTimeout: function() {
	    return this.options.timeout;
	  },
	
	  getInterval: function() {
	    return this.options.interval;
	  },
	
	  isDeliverable: function() {
	    var attempts = this.options.attempts,
	        made     = this.attempts,
	        deadline = this.options.deadline,
	        now      = new Date().getTime();
	
	    if (attempts !== undefined && made >= attempts)
	      return false;
	
	    if (deadline !== undefined && now > deadline)
	      return false;
	
	    return true;
	  },
	
	  send: function() {
	    this.attempts += 1;
	  },
	
	  succeed: function() {},
	
	  fail: function() {},
	
	  abort: function() {}
	});
	
	module.exports = Scheduler;


/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Class   = __webpack_require__(7),
	    Grammar = __webpack_require__(18);
	
	var Error = Class({
	  initialize: function(code, params, message) {
	    this.code    = code;
	    this.params  = Array.prototype.slice.call(params);
	    this.message = message;
	  },
	
	  toString: function() {
	    return this.code + ':' +
	           this.params.join(',') + ':' +
	           this.message;
	  }
	});
	
	Error.parse = function(message) {
	  message = message || '';
	  if (!Grammar.ERROR.test(message)) return new Error(null, [], message);
	
	  var parts   = message.split(':'),
	      code    = parseInt(parts[0]),
	      params  = parts[1].split(','),
	      message = parts[2];
	
	  return new Error(code, params, message);
	};
	
	// http://code.google.com/p/cometd/wiki/BayeuxCodes
	var errors = {
	  versionMismatch:  [300, 'Version mismatch'],
	  conntypeMismatch: [301, 'Connection types not supported'],
	  extMismatch:      [302, 'Extension mismatch'],
	  badRequest:       [400, 'Bad request'],
	  clientUnknown:    [401, 'Unknown client'],
	  parameterMissing: [402, 'Missing required parameter'],
	  channelForbidden: [403, 'Forbidden channel'],
	  channelUnknown:   [404, 'Unknown channel'],
	  channelInvalid:   [405, 'Invalid channel'],
	  extUnknown:       [406, 'Unknown extension'],
	  publishFailed:    [407, 'Failed to publish'],
	  serverError:      [500, 'Internal server error']
	};
	
	for (var name in errors)
	  (function(name) {
	    Error[name] = function() {
	      return new Error(errors[name][0], arguments, errors[name][1]).toString();
	    };
	  })(name);
	
	module.exports = Error;


/***/ },
/* 34 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var extend  = __webpack_require__(8),
	    Logging = __webpack_require__(2);
	
	var Extensible = {
	  addExtension: function(extension) {
	    this._extensions = this._extensions || [];
	    this._extensions.push(extension);
	    if (extension.added) extension.added(this);
	  },
	
	  removeExtension: function(extension) {
	    if (!this._extensions) return;
	    var i = this._extensions.length;
	    while (i--) {
	      if (this._extensions[i] !== extension) continue;
	      this._extensions.splice(i,1);
	      if (extension.removed) extension.removed(this);
	    }
	  },
	
	  pipeThroughExtensions: function(stage, message, request, callback, context) {
	    this.debug('Passing through ? extensions: ?', stage, message);
	
	    if (!this._extensions) return callback.call(context, message);
	    var extensions = this._extensions.slice();
	
	    var pipe = function(message) {
	      if (!message) return callback.call(context, message);
	
	      var extension = extensions.shift();
	      if (!extension) return callback.call(context, message);
	
	      var fn = extension[stage];
	      if (!fn) return pipe(message);
	
	      if (fn.length >= 3) extension[stage](message, request, pipe);
	      else                extension[stage](message, pipe);
	    };
	    pipe(message);
	  }
	};
	
	extend(Extensible, Logging);
	
	module.exports = Extensible;


/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Class      = __webpack_require__(7),
	    Deferrable = __webpack_require__(14);
	
	module.exports = Class(Deferrable);


/***/ },
/* 36 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Class      = __webpack_require__(7),
	    extend     = __webpack_require__(8),
	    Deferrable = __webpack_require__(14);
	
	var Subscription = Class({
	  initialize: function(client, channels, callback, context) {
	    this._client    = client;
	    this._channels  = channels;
	    this._callback  = callback;
	    this._context   = context;
	    this._cancelled = false;
	  },
	
	  withChannel: function(callback, context) {
	    this._withChannel = [callback, context];
	    return this;
	  },
	
	  apply: function(context, args) {
	    var message = args[0];
	
	    if (this._callback)
	      this._callback.call(this._context, message.data);
	
	    if (this._withChannel)
	      this._withChannel[0].call(this._withChannel[1], message.channel, message.data);
	  },
	
	  cancel: function() {
	    if (this._cancelled) return;
	    this._client.unsubscribe(this._channels, this);
	    this._cancelled = true;
	  },
	
	  unsubscribe: function() {
	    this.cancel();
	  }
	});
	
	extend(Subscription.prototype, Deferrable);
	
	module.exports = Subscription;


/***/ }
/******/ ]);
//# sourceMappingURL=faye-browser.js.map
(function(doc) {

  log = noop; // noOp, remove this line to enable debugging

  var coordinateSystemForElementFromPoint;

  function main(config) {
    config = config || {};

    coordinateSystemForElementFromPoint = navigator.userAgent.match(/OS [1-4](?:_\d+)+ like Mac/) ? "page" : "client";

    var div = doc.createElement('div');
    var dragDiv = 'draggable' in div;
    var evts = 'ondragstart' in div && 'ondrop' in div;

    var needsPatch = !(dragDiv || evts) || /iPad|iPhone|iPod|Android/.test(navigator.userAgent);
    log((needsPatch ? "" : "not ") + "patching html5 drag drop");

    if(!needsPatch) return;

    if(!config.enableEnterLeave) {
      DragDrop.prototype.synthesizeEnterLeave = noop;
    }

    doc.addEventListener("touchstart", touchstart);
  }

  function DragDrop(event, el) {

    this.dragData = {};
    this.dragDataTypes = [];
    this.dragImage = null;
    this.dragImageTransform = null;
    this.dragImageWebKitTransform = null;
    this.el = el || event.target

    log("dragstart");

    this.dispatchDragStart()
    this.createDragImage();

    this.listen()

  }

  DragDrop.prototype = {
    listen: function() {
      var move = onEvt(doc, "touchmove", this.move, this);
      var end = onEvt(doc, "touchend", ontouchend, this);
      var cancel = onEvt(doc, "touchcancel", cleanup, this);

      function ontouchend(event) {
        this.dragend(event, event.target);
        cleanup.call(this);
      }
      function cleanup() {
        log("cleanup");
        this.dragDataTypes = [];
        if (this.dragImage != null) {
          this.dragImage.parentNode.removeChild(this.dragImage);
          this.dragImage = null;
          this.dragImageTransform = null;
          this.dragImageWebKitTransform = null;
        }
        this.el = this.dragData = null;
        return [move, end, cancel].forEach(function(handler) {
          return handler.off();
        });
      }
    },
    move: function(event) {
      var pageXs = [], pageYs = [];
      [].forEach.call(event.changedTouches, function(touch, index) {
        pageXs.push(touch.pageX);
        pageYs.push(touch.pageY);
      });

      var x = average(pageXs) - (parseInt(this.dragImage.offsetWidth, 10) / 2);
      var y = average(pageYs) - (parseInt(this.dragImage.offsetHeight, 10) / 2);
      this.translateDragImage(x, y);

      this.synthesizeEnterLeave(event);
    },
    hideDragImage: function() {
      if (this.dragImage && this.dragImage.style["display"] != "none") {
        this.dragImageDisplay = this.dragImage.style["display"];
        this.dragImage.style["display"] = "none";
      }
    },
    showDragImage: function() {
      if (this.dragImage) {
        this.dragImage.style["display"] = this.dragImageDisplay ? this.dragImageDisplay : "block";
      }
    },
    // We use translate instead of top/left because of sub-pixel rendering and for the hope of better performance
    // http://www.paulirish.com/2012/why-moving-elements-with-translate-is-better-than-posabs-topleft/
    translateDragImage: function(x, y) {
      var translate = " translate(" + x + "px," + y + "px)";

      if (this.dragImageWebKitTransform !== null) {
        this.dragImage.style["-webkit-transform"] = this.dragImageWebKitTransform + translate;
      }
      if (this.dragImageTransform !== null) {
        this.dragImage.style["transform"] = this.dragImageTransform + translate;
      }
    },
    synthesizeEnterLeave: function(event) {
      this.hideDragImage();
      var target = elementFromTouchEvent(this.el,event)
      this.showDragImage();
      if (target != this.lastEnter) {
        if (this.lastEnter) {
          this.dispatchLeave(event);
        }
        this.lastEnter = target;
        if (this.lastEnter) {
          this.dispatchEnter(event);
        }
      }
      if (this.lastEnter) {
        this.dispatchOver(event);
      }
    },
    dragend: function(event) {

      // we'll dispatch drop if there's a target, then dragEnd.
      // drop comes first http://www.whatwg.org/specs/web-apps/current-work/multipage/dnd.html#drag-and-drop-processing-model
      log("dragend");

      if (this.lastEnter) {
        this.dispatchLeave(event);
      }

      this.hideDragImage();
      var target = elementFromTouchEvent(this.el,event)
      this.showDragImage();

      if (target) {
        log("found drop target " + target.tagName);
        this.dispatchDrop(target, event)
      } else {
        log("no drop target")
      }

      var dragendEvt = doc.createEvent("Event");
      dragendEvt.initEvent("dragend", true, true);
      this.el.dispatchEvent(dragendEvt);
    },
    dispatchDrop: function(target, event) {
      var dropEvt = doc.createEvent("Event");
      dropEvt.initEvent("drop", true, true);

      var touch = event.changedTouches[0];
      var x = touch[coordinateSystemForElementFromPoint + 'X'];
      var y = touch[coordinateSystemForElementFromPoint + 'Y'];
      dropEvt.offsetX = x - target.x;
      dropEvt.offsetY = y - target.y;

      dropEvt.dataTransfer = {
        types: this.dragDataTypes,
        getData: function(type) {
          return this.dragData[type];
        }.bind(this)
      };
      dropEvt.preventDefault = function() {
         // https://www.w3.org/Bugs/Public/show_bug.cgi?id=14638 - if we don't cancel it, we'll snap back
      }.bind(this);

      once(doc, "drop", function() {
        log("drop event not canceled");
      },this);

      target.dispatchEvent(dropEvt);
    },
    dispatchEnter: function(event) {

      var enterEvt = doc.createEvent("Event");
      enterEvt.initEvent("dragenter", true, true);
      enterEvt.dataTransfer = {
        types: this.dragDataTypes,
        getData: function(type) {
          return this.dragData[type];
        }.bind(this)
      };

      var touch = event.changedTouches[0];
      enterEvt.pageX = touch.pageX;
      enterEvt.pageY = touch.pageY;

      this.lastEnter.dispatchEvent(enterEvt);
    },
    dispatchOver: function(event) {

      var overEvt = doc.createEvent("Event");
      overEvt.initEvent("dragover", true, true);
      overEvt.dataTransfer = {
        types: this.dragDataTypes,
        getData: function(type) {
          return this.dragData[type];
        }.bind(this)
      };

      var touch = event.changedTouches[0];
      overEvt.pageX = touch.pageX;
      overEvt.pageY = touch.pageY;

      this.lastEnter.dispatchEvent(overEvt);
    },
    dispatchLeave: function(event) {

      var leaveEvt = doc.createEvent("Event");
      leaveEvt.initEvent("dragleave", true, true);
      leaveEvt.dataTransfer = {
        types: this.dragDataTypes,
        getData: function(type) {
          return this.dragData[type];
        }.bind(this)
      };

      var touch = event.changedTouches[0];
      leaveEvt.pageX = touch.pageX;
      leaveEvt.pageY = touch.pageY;

      this.lastEnter.dispatchEvent(leaveEvt);
      this.lastEnter = null;
    },
    dispatchDragStart: function() {
      var evt = doc.createEvent("Event");
      evt.initEvent("dragstart", true, true);
      evt.dataTransfer = {
        setData: function(type, val) {
          this.dragData[type] = val;
          if (this.dragDataTypes.indexOf(type) == -1) {
            this.dragDataTypes[this.dragDataTypes.length] = type;
          }
          return val;
        }.bind(this),
        dropEffect: "move"
      };
      this.el.dispatchEvent(evt);
    },
    createDragImage: function() {
      this.dragImage = this.el.cloneNode(true);
      
      duplicateStyle(this.el, this.dragImage);
      
      this.dragImage.style["opacity"] = "0.5";
      this.dragImage.style["position"] = "absolute";
      this.dragImage.style["left"] = "0px";
      this.dragImage.style["top"] = "0px";
      this.dragImage.style["z-index"] = "999999";
      this.dragImage.style["pointer-events"] = "none";

      var transform = this.dragImage.style["transform"];
      if (typeof transform !== "undefined") {
        this.dragImageTransform = "";
        if (transform != "none") {
          this.dragImageTransform = transform.replace(/translate\(\D*\d+[^,]*,\D*\d+[^,]*\)\s*/g, '');
        }
      }

      var webkitTransform = this.dragImage.style["-webkit-transform"];
      if (typeof webkitTransform !== "undefined") {
        this.dragImageWebKitTransform = "";
        if (webkitTransform != "none") {
          this.dragImageWebKitTransform = webkitTransform.replace(/translate\(\D*\d+[^,]*,\D*\d+[^,]*\)\s*/g, '');
        }
      }

      this.translateDragImage(-9999, -9999);

      doc.body.appendChild(this.dragImage);
    }
  }

  // event listeners
  function touchstart(evt) {
    var el = evt.target;
    do {
      if (el.draggable === true) {
        // If draggable isn't explicitly set for anchors, then simulate a click event.
        // Otherwise plain old vanilla links will stop working.
        // https://developer.mozilla.org/en-US/docs/Web/Guide/Events/Touch_events#Handling_clicks
        if (!el.hasAttribute("draggable") && el.tagName.toLowerCase() == "a") {
          var clickEvt = document.createEvent("MouseEvents");
          clickEvt.initMouseEvent("click", true, true, el.ownerDocument.defaultView, 1,
            evt.screenX, evt.screenY, evt.clientX, evt.clientY,
            evt.ctrlKey, evt.altKey, evt.shiftKey, evt.metaKey, 0, null);
          el.dispatchEvent(clickEvt);
          log("Simulating click to anchor");
        }
        evt.preventDefault();
        new DragDrop(evt,el);
      }
    } while((el = el.parentNode) && el !== doc.body)
  }

  // DOM helpers
  function elementFromTouchEvent(el,event) {
    var touch = event.changedTouches[0];
    var target = doc.elementFromPoint(
      touch[coordinateSystemForElementFromPoint + "X"],
      touch[coordinateSystemForElementFromPoint + "Y"]
    );
    return target
  }

  function onEvt(el, event, handler, context) {
    if(context) handler = handler.bind(context)
    el.addEventListener(event, handler);
    return {
      off: function() {
        return el.removeEventListener(event, handler);
      }
    };
  }

  function once(el, event, handler, context) {
    if(context) handler = handler.bind(context)
    function listener(evt) {
      handler(evt);
      return el.removeEventListener(event,listener);
    }
    return el.addEventListener(event,listener);
  }

  // duplicateStyle expects dstNode to be a clone of srcNode
  function duplicateStyle(srcNode, dstNode) {
    // Is this node an element?
    if (srcNode.nodeType == 1) {
      // Remove any potential conflict attributes
      dstNode.removeAttribute("id");
      dstNode.removeAttribute("class");
      dstNode.removeAttribute("style");
      dstNode.removeAttribute("draggable");

      // Clone the style
      var cs = window.getComputedStyle(srcNode);
      for (var i = 0; i < cs.length; i++) {
        var csName = cs[i];
        dstNode.style.setProperty(csName, cs.getPropertyValue(csName), cs.getPropertyPriority(csName));
      }
    }

    // Do the same for the children
    if (srcNode.hasChildNodes()) {
      for (var i = 0; i < srcNode.childNodes.length; i++) {
        duplicateStyle(srcNode.childNodes[i], dstNode.childNodes[i]);
      }
    }
  }

  // general helpers
  function log(msg) {
    console.log(msg);
  }

  function average(arr) {
    if (arr.length === 0) return 0;
    return arr.reduce((function(s, v) {
      return v + s;
    }), 0) / arr.length;
  }

  function noop() {}

  main(window.iosDragDropShim);


})(document);

/** PBS Kids Trampoline, HTML5
 *
 * Authored by Ivy Nye | inye@pbs.org
 * Designed by Chris Bishop
 * @copyright (c) 2016 PBS Kids Digital
 * @version 2.3.3
 *
 * @namespace Trampoline
 * @example Trampoline.init({app_name: test, parents: true});
 */
var Trampoline = (function() {
  var _APP_NAME = 'PBS Kids Trampoline',
    _APP_VERSION = '2.3.3',
    PBSKidsAppName,
    GUID,
    //Default Modules for init -- object modified by config
    modules = {
      init: false,
      localize: { auto: true },
      splash: true,
      nav: true,
      settings: true,
      language: false,
      moreApps: true,
      restart: false
    },
    _debug =
      false ||
      window.location.hostname.match(
        /^(((?!www(\-tc)?|help\.).+)pbskids\.org)|(localhost:*)|(\d+\.\d+\.\d+\.\d+:8081*)/
      ) ||
      window.location.port.match(/^8081|(\.\d+:8081)/)
        ? true
        : false,
    _log = function(message, args, type, force) {
      if (Trampoline._debug === true || force === true) {
        if (typeof message == 'string' || !!args) {
          message = _APP_NAME + ' ver. ' + _APP_VERSION + ' | ' + message;
        } else {
          args = message;
          message = _APP_NAME + ' ver. ' + _APP_VERSION + ' | ';
        }
        if (typeof console !== 'undefined') {
          if (type == 'error') {
            if (console.error) {
              console.error(message, args);
              return;
            } else if (window.Error) {
              throw new Error(message);
            }
          }
          if (type == 'info' && console.info) {
            console.info(message, args);
            return;
          }
          if (type == 'warn' && console.warn) {
            console.warn(message, args);
            return;
          }
          if (console.log) {
            console.log(message, args);
          }
        } else if (window.debug) {
          window.debug.log.apply(message, args);
        }
      }
    },
    _initConfig,
    _configUA,
    _devOnReady,
    _path = './',
    _resourcePath = '',
    _markupURL = 'trampoline.html', //This location can be set in config 'path'
    _trampolineContainer = document.getElementById('trampoline'),
    //EVENTS
    TRAMPOLINE_READY = new Event('TRAMPOLINE_READY'),
    TRAMPOLINE_REFRESH = new Event('TRAMPOLINE_REFRESH'),
    TRAMPOLINE_ONLINE = new Event('TRAMPOLINE_ONLINE'),
    TRAMPOLINE_OFFLINE = new Event('TRAMPOLINE_OFFLINE'),
    TRAMPOLINE_STATE_CHANGE = new Event('TRAMPOLINE_STATE_CHANGE'),
    TRAMPOLINE_STATE_BACK = new Event('TRAMPOLINE_STATE_BACK'),
    /**
     * Initializes Trampoline from config object
     * @memberof Trampoline
     * @name Trampoline.init
     * @param {Object} configObj Configuration Details
     */
    init = function(configObj) {
      if (!Trampoline.modules.init) {
        Trampoline.util.init();
        Trampoline.state.change({
          to: 'init',
          from: 'uninit'
        });

        Trampoline.events.addEventListener(
          'TRAMPOLINE_STATE_CHANGE',
          function() {
            _log('change state: ', Trampoline.state.current.name);
          }
        );

        Trampoline.events.addEventListener('TRAMPOLINE_STATE_BACK', function() {
          _log('state back: ', Trampoline.state.current.name);
        });

        document.addEventListener('online', _onConnectionResume);
        document.addEventListener('offline', _onConnectionLost);

        _config(configObj);

        var _onTrampolineInject = function() {
          //Init analytics first, Splash page will need it.
          Trampoline.analytics.init(_configUA);
          Trampoline.analytics.dimension(1, 'NO_STATION');

          if (!!Trampoline.modules.splash) {
            Trampoline.state.change({ to: 'splash', from: 'init' });
          } else {
            Trampoline.splash.remove();
            Trampoline.onReady();
            Trampoline.state.change({ to: 'main', from: 'init' });
          }
        };

        _buildMarkup().then(_onTrampolineInject);

        _trampolineContainer.addEventListener(
          'touchmove',
          Trampoline.util.preventDefaultThis
        );

        // Show the build data in debug mode
        // TODO: move this into it's own thing, so it's out of core

        if (!!Trampoline.modules.buildData) {
          if (typeof Trampoline.modules.buildData === 'Object') {
            Trampoline.util.displayBuildData();
          } else {
            Trampoline.events.addEventListener(
              'BUILD_DATA_RETURNED',
              function() {
                Trampoline.util.displayBuildData();
              }
            );
            Trampoline.util.getBuildData();
          }
        }
      } else {
        _log('Trampoline.init was already executed');
      }
    },
    /**
     * Holds and changes truthful States of the Trampoline Views
     * A simple state machine, probably shouldn't even call it that
     * @memberof Trampoline
     * @name Trampoline.state
     */
    state = (function() {
      var change = function(stateObj) {
          var stateObj = stateObj ? stateObj : {},
            toState = stateObj.to || Trampoline.state.last.name || 'init',
            fromState = stateObj.from
              ? stateObj.from
              : Trampoline.state.current.name;

          //If it can change state and has toggleView, do that
          if (toState != Trampoline.state.current.name) {
            //Toggle current state
            if (
              Trampoline.hasOwnProperty(Trampoline.state.current.name) &&
              Trampoline[Trampoline.state.current.name].hasOwnProperty(
                'toggleView'
              )
            ) {
              Trampoline[Trampoline.state.current.name].toggleView();
            }
            //Toggle new state
            if (
              Trampoline.hasOwnProperty(toState) &&
              Trampoline[toState].hasOwnProperty('toggleView')
            ) {
              Trampoline[toState].toggleView();
            }
            //Set current state, add previous state to state.last array
            Trampoline.state.last.push(Trampoline.state.current);
            if (!stateObj.hasOwnProperty('name')) {
              stateObj.name = toState;
            }
            Trampoline.state.current = stateObj;
            Trampoline.events.dispatchEvent(TRAMPOLINE_STATE_CHANGE);
          } else {
            _log('Cannot change to current state', toState);
          }
        },
        //TODO: Do I need a back state? can i just call .back if the stateObj is empty?
        back = function() {
          var toState =
              Trampoline.state.last[Trampoline.state.last.length - 1].name,
            popupsActive = _trampolineContainer
              .querySelector('section.popups')
              .classList.contains('active'),
            gateActive = _trampolineContainer
              .querySelector('section.gate')
              .classList.contains('active');

          //If a popup / parent gate is open, _close_ it (these are not handled by state change, but need to be attached to back button).
          if (!!gateActive) {
            Trampoline.gate.close();
          } else if (!!popupsActive) {
            Trampoline.popups.close();
          } else if (
            toState != Trampoline.state.current.name &&
            toState != 'uninit' &&
            toState != 'init' &&
            toState != 'splash'
          ) {
            //Toggle Last state
            if (
              Trampoline.hasOwnProperty(toState) &&
              Trampoline[toState].hasOwnProperty('toggleView')
            ) {
              Trampoline[toState].toggleView();
            }
            //Toggle Current state.
            if (
              Trampoline.hasOwnProperty(Trampoline.state.current.name) &&
              Trampoline[Trampoline.state.current.name].hasOwnProperty(
                'toggleView'
              )
            ) {
              Trampoline[Trampoline.state.current.name].toggleView();
            }
            //Remove last state from array
            Trampoline.state.current = Trampoline.state.last.pop();
            Trampoline.events.dispatchEvent(TRAMPOLINE_STATE_BACK);
          } else {
            _log('Cannot toggleView of toState', toState);
          }
        },
        current = {
          name: 'uninit'
        },
        last = [];

      return {
        change: change,
        last: last,
        current: current,
        back: back
      };
    })(),
    /**
     * Configure Trampoline based on Parameters
     * @private
     * @memberof Trampoline
     * @param {Object} configObj - JSON configuration parameters
     */
    _config = function(configObj) {
      if (typeof configObj === 'object') {
        for (var obj in configObj) {
          switch (obj.toLowerCase()) {
            case 'app_name':
              if (typeof configObj[obj] === 'string') {
                Trampoline.PBSKidsAppName = configObj[obj];
              } else {
                _log('Could not set App Name', configObj[obj]);
              }
              break;
            /** Google Analytics Config (Object)
             * Recieves a UA String.
             */
            case 'guid':
              if (typeof configObj[obj] === 'string') {
                Trampoline.GUID = configObj[obj];
              } else {
                _log('Error in GUID config', configObj[obj]);
              }
              break;
            case 'ua':
              if (typeof configObj[obj] === 'string') {
                _configUA = configObj[obj];
                Trampoline.analytics.UA = configObj[obj];
              } else {
                _log('Could not set Analytics UA', configObj[obj]);
              }
              break;
            /** AddOn Config (Object)
             * Recieves a Button Object.
             * Obj parameters: Text, Icon, Callback
             */
            case 'addon':
              if (typeof configObj[obj] === 'object') {
                Trampoline.nav.buttons.push(configObj[obj]);
              } else {
                _log('Error in addon object config', configObj[obj]);
              }
              break;
            /** SuperVision Config (object)
             * Defaults to `null`, developer must enable
             */
            case 'supervision':
              if (typeof configObj[obj] === 'object') {
                Trampoline.modules.supervision = configObj[obj];

                Trampoline.nav.notifiers.push({
                  name: 'supervision',
                  icon: 'trophy',
                  heading: 'Hey parents!',
                  instructions: 'See what your kid is learning!',
                  arrow: 'top-right'
                });
              } else {
                _log('Supervision config must return object', configObj[obj]);
              }
              break;
            /** Splash Screen Config (Boolean)
             * Defulats to `true`
             */
            case 'splash':
              if (typeof configObj[obj] === 'boolean') {
                Trampoline.modules.splash = configObj[obj];
              } else if (
                configObj[obj].hasOwnProperty('hide') &&
                typeof configObj[obj].hide == 'boolean'
              ) {
                Trampoline.modules.splash = 'auto-hide-' + configObj[obj].hide;

                //TODO: Modules-- get rid of this Trampoline.splash.config and make Trampoline.modules.splash handle it
                Trampoline.splash.config.hide = configObj[obj].hide;
              } else {
                _log('Error in splash config', configObj[obj]);
              }
              break;
            /** Parents Config
             *  Defaults to `false`
             */
            case 'parents':
              if (
                typeof configObj[obj] === 'boolean' ||
                typeof configObj[obj] === 'object'
              ) {
                Trampoline.modules.parents = configObj[obj];
              } else {
                _log(
                  'Parents config must return Boolean or Object',
                  configObj[obj]
                );
              }
              break;

            case 'settings':
              if (
                typeof configObj[obj] === 'boolean' ||
                typeof configObj[obj] === 'object'
              ) {
                Trampoline.modules.settings = configObj[obj];
              } else {
                _log(
                  'Settings config must return Boolean or Object',
                  configObj[obj]
                );
              }
              break;

            case 'popups':
              if (
                typeof configObj[obj] === 'boolean' ||
                typeof configObj[obj] === 'object'
              ) {
                Trampoline.modules.popups = configObj[obj];
              } else {
                _log(
                  'Popups config must return Boolean or Object',
                  configObj[obj]
                );
              }
              break;

            /** onReady Callback
             *  Defaults to null. Can also listen for TRAMPOLINE_READY event on Trampoline.container
             */
            case 'onready':
              if (typeof configObj[obj] === 'function') {
                _devOnReady = configObj[obj];
              } else {
                _log('onReady in config is not a function', configObj[obj]);
              }
              break;

            case 'moreapps':
              if (typeof configObj[obj] === 'boolean') {
                Trampoline.modules.moreApps = configObj[obj];
              } else {
                _log('MoreApps config must return Boolean', configObj[obj]);
              }
              break;

            case 'nav':
              if (typeof configObj[obj] === 'boolean') {
                Trampoline.modules.nav = configObj[obj];
              } else {
                _log('nav config must return Boolean', configObj[obj]);
              }
              break;

            /** Settings Module Config
             * This is a relic from a tooltip design requiring a settings module.
             * Settings is non-configurable as it will always include localization.
             */
            case 'settingsmodule':
              Trampoline.modules.settings.modules = [];
              for (var key in configObj[obj]) {
                Trampoline.modules.settings.modules.push(configObj[obj][key]);
              }
              break;

            /** Button Config
             * Additional buttons can be added through config.
             * Receives an object array, and adds buttons to the buttonObj and inject to the left of all other buttons.
             * [{text: 'button1', icon:'false', callback:function}, {text: 'button2', icon:'true', callback:function}]
             */
            case 'buttons':
              for (var key in configObj[obj]) {
                _log('add buttons from config: ' + configObj[obj][key]);
                Trampoline.nav.buttons.push(configObj[obj][key]);
              }
              break;
            /** Set file path of Trampoline dist folder (must end in '/')
             */
            case 'path':
              // store path for resource loading.
              _path = configObj[obj];
              _markupURL = _path + 'trampoline.html';
              break;

            /** Set file path of resources, where img lives, dist folder (must end in '/')
             */
            case 'resources':
              _resourcePath = configObj[obj];
              break;

            case 'localize':
              // store path for resource loading.
              if (
                typeof configObj[obj] === 'object' ||
                configObj[obj] === false
              ) {
                Trampoline.modules.localize = configObj[obj];
              } else {
                _log(
                  'Localize config must be an object with either auto or zipCode properties, or false.',
                  configObj[obj]
                );
              }
              break;

            case 'debug':
              if (typeof configObj[obj] === 'boolean') {
                Trampoline._debug = configObj[obj];
                if (Trampoline._debug) {
                  _log = function(message, args, type, force) {
                    if (typeof message == 'string' || !!args) {
                      message =
                        _APP_NAME + ' ver. ' + _APP_VERSION + ' | ' + message;
                    } else {
                      args = message;
                      message = _APP_NAME + ' ver. ' + _APP_VERSION + ' | ';
                    }
                    if (typeof console !== 'undefined') {
                      if (type == 'error') {
                        if (console.error) {
                          console.error(message, args);
                          return;
                        } else if (window.Error) {
                          throw new Error(message);
                        }
                      }
                      if (type == 'info' && console.info) {
                        console.info(message, args);
                        return;
                      }
                      if (type == 'warn' && console.warn) {
                        console.warn(message, args);
                        return;
                      }
                      if (console.log) {
                        console.log(message, args);
                      }
                    } else if (window.debug) {
                      window.debug.log.apply(message, args);
                    }
                  };
                }
              } else if (configObj[obj] === 'build-data') {
                Trampoline.modules.buildData = true;
                Trampoline._debug = true;
                if (Trampoline._debug) {
                  _log = function(message, args, type, force) {
                    if (typeof message == 'string' || !!args) {
                      message =
                        _APP_NAME + ' ver. ' + _APP_VERSION + ' | ' + message;
                    } else {
                      args = message;
                      message = _APP_NAME + ' ver. ' + _APP_VERSION + ' | ';
                    }
                    if (typeof console !== 'undefined') {
                      if (type == 'error')
                        if (console.error) {
                          console.error(message, args);
                          return;
                        } else if (window.Error) throw new Error(message);
                      if (type == 'info' && console.info) {
                        console.info(message, args);
                        return;
                      }
                      if (type == 'warn' && console.warn) {
                        console.warn(message, args);
                        return;
                      }
                      if (console.log) console.log(message, args);
                    } else if (window.debug)
                      window.debug.log.apply(message, args);
                  };
                }
              } else {
                _log('Error in debug config', configObj[obj]);
              }
              _debug = true;
              break;

            case 'offline':
              if (typeof configObj[obj] === 'boolean') {
                if (configObj[obj]) {
                  _log('forcing offline mode');
                  Trampoline.util.isConnected = !configObj[obj];
                }
              } else {
                _log('Error in offline config', configObj[obj]);
              }
              break;
            case 'gate':
              if (typeof configObj[obj] === 'boolean') {
                Trampoline.modules.gate = configObj[obj];
              } else if (typeof configObj[obj] === 'object') {
                Trampoline.modules.gate = configObj[obj];
              } else {
                _log(
                  'Parent Gate config must return Boolean or Object',
                  configObj[obj]
                );
              }
              break;
            case 'captions':
              if (typeof configObj[obj] === 'boolean') {
                Trampoline.modules.captions = configObj[obj];
              } else if (typeof configObj[obj] === 'object') {
                Trampoline.modules.captions = configObj[obj];
              } else {
                _log(
                  'Captions config must return Boolean or Object with options',
                  configObj[obj]
                );
              }
              break;
            case 'language':
              if (typeof configObj[obj] === 'boolean') {
                Trampoline.modules.language = configObj[obj];
              } else {
                _log('Language setting must be Boolean', configObj[obj]);
              }
              break;
            case 'restart':
              if (typeof configObj[obj] === 'boolean') {
                if (configObj[obj]) {
                  _log('quick restart, no splash');
                  Trampoline.modules.restart = true;
                }
              } else {
                _log('Error in offline config', configObj[obj]);
              }
              break;
            default:
              _log('Error in Config Settings', obj + ' not found', false);
          }
        }
      } else {
        _log('config settings not an object', configObj[obj]);
      }
    },
    /**
     * onReady builds main page after configuration and splash screen animation end. Calls configuration onReady callback when complete.
     * @name Trampoline.onReady
     * @memberof Trampoline
     * @todo TODO: Decouple onReady from splash screen end. Main page should build while splash screen is up.
     */
    onReady = function() {
      _log('Trampoline.onReady called');

      //BackButton on Android
      if (Trampoline.util.isAndroid) {
        document.addEventListener('backbutton', Trampoline.state.back, false);
      }

      var moduleInitQueue = [
        {
          prop: 'languages',
          options: {}
        },
        {
          prop: 'nav',
          options: Trampoline.modules.nav
        },
        {
          prop: 'localize',
          options: Trampoline.modules.localize
        },
        {
          prop: 'popups',
          options: Trampoline.modules.popups, // this will only accept custom popups as we are always created
          alwaysCall: true
        },
        {
          prop: 'moreApps',
          options: {
            headless: !Trampoline.modules.nav,
            //TODO: Clear out this option here and in Trampoline.moreApps - now using Trampoline.modules.key which is public
            remove: !Trampoline.modules.moreApps
          },
          needsInternet: true
        },
        {
          prop: 'supervision',
          options: Trampoline.modules.supervision
        },
        {
          prop: 'captions',
          options: Trampoline.modules.captions || false
        },
        {
          prop: 'settings',
          options: Trampoline.modules.settings
        },
        {
          prop: 'parents',
          options: Trampoline.modules.parents
        },
        {
          prop: 'gate',
          options: Trampoline.modules.gate,
          alwaysCall: true
        }
      ];

      var initLoader = buildModuleLoader(moduleInitQueue, 'init');

      initLoader.on(
        'complete',
        function(initLoader) {
          _log('Module resources loaded');

          // call final ready on each module
          for (var i = 0; i < moduleInitQueue.length; i++) {
            var mod = moduleInitQueue[i];
            if (mod.didInit && Trampoline[mod.prop].startup) {
              Trampoline[mod.prop].startup(initLoader.resources);
            }
          }

          //TODO: The modules should return an error if init failed.
          Trampoline.modules.init = true;

          //Lastly, call config onReady.
          if (_devOnReady) {
            _devOnReady();
          }
          Trampoline.events.dispatchEvent(TRAMPOLINE_READY);
        }.bind(this)
      );

      initLoader.load();
    },
    /**
     * This is a handler for the public refresh call. Forces to reset online status and calls _onRefresh if online.
     */
    refresh = function() {
      if (Trampoline.util.isConnected) {
        _onRefresh();
      } else if (navigator.onLine) {
        _onConnectionResume();
        _onRefresh();
      } else {
        document.addEventListener('online', _onRefresh);
      }
    },
    /**
     * Runs the refresh method on modules that require a network connection, in order.
     */
    _onRefresh = function() {
      if (Trampoline.modules.init) {
        var moduleRefreshQueue, refreshLoader;

        document.removeEventListener('online', _onRefresh);

        moduleRefreshQueue = [
          {
            prop: 'analytics',
            options: _configUA
          },
          {
            prop: 'moreApps',
            options: {
              silent: !Trampoline.modules.moreApps
            },
            needsInternet: true
          },
          {
            prop: 'settings',
            options: Trampoline.modules.settings
          },
          {
            prop: 'parents',
            options: Trampoline.modules.parents
          }
        ];

        refreshLoader = buildModuleLoader(moduleRefreshQueue, 'refresh');

        refreshLoader.load(
          function(refreshLoader) {
            //            for( i = 0; i<moduleRefreshQueue.length; i++ ){
            //              mod = moduleRefreshQueue[i];
            //              if( mod.didRefresh && mod.restart && Trampoline[ mod.prop ].startup ){
            //                Trampoline[ mod.prop ].startup( refreshLoader.resources );
            //              }
            //            }
            //TODO: Make sure that all modules completed refresh
            Trampoline.events.dispatchEvent(TRAMPOLINE_REFRESH);
          }.bind(this)
        );
      }
    },
    /**
     * Called when network connection is resumed, updates Modules accordingly
     */
    _onConnectionResume = function() {
      Trampoline.util.isConnected = window.navigator.onLine;
      if (Trampoline.modules.init) {
        _log('on connection resume');
        var moduleConnectionResumeQueue, connectionResumeLoader;

        moduleConnectionResumeQueue = [
          {
            prop: 'supervision',
            options: Trampoline.modules.supervision
          },
          {
            prop: 'parents',
            options: Trampoline.modules.parents
          },
          {
            prop: 'settings',
            options: Trampoline.modules.settings
          }
        ];

        connectionResumeLoader = buildModuleLoader(
          moduleConnectionResumeQueue,
          'connectionResume'
        );

        connectionResumeLoader.load(
          function(connectionResumeLoader) {
            // Queue is done
            Trampoline.events.dispatchEvent(TRAMPOLINE_ONLINE);
          }.bind(this)
        );
      }
    },
    /**
     * Called when connection is lost, and updates Modules accordingly
     */
    _onConnectionLost = function() {
      Trampoline.util.isConnected = window.navigator.onLine;
      if (Trampoline.modules.didInit) {
        _log('on connection lost');
        var moduleConnectionLostQueue, connectionLostLoader;

        moduleConnectionLostQueue = [
          {
            prop: 'supervision',
            options: Trampoline.modules.supervision
          },
          {
            prop: 'parents',
            options: Trampoline.modules.parents
          },
          {
            prop: 'settings',
            options: Trampoline.modules.settings
          }
        ];

        connectionLostLoader = buildModuleLoader(
          moduleConnectionLostQueue,
          'connectionLost'
        );

        connectionLostLoader.load(
          function(connectionLostLoader) {
            Trampoline.events.dispatchEvent(TRAMPOLINE_OFFLINE);
          }.bind(this)
        );
      }
    },
    /**
     * Builds a module loader from queue obj to run a method (i.e. init, resume, connectionLost) on all modules depending on connectivity / config.
     * @param   {Object} moduleQueue The queue of modules, in order
     * @param   {String} method      The method we want to run. When run: puts a didMethod on the module
     * @returns {Object} The loader, see onReady for implementation
     */
    buildModuleLoader = function(moduleQueue, method) {
      _log('building a module loader for: ' + method, moduleQueue);
      var i,
        mod,
        method,
        hasMethod,
        //did + camelCase the method.
        didMethod = 'did' + (method.charAt(0).toUpperCase() + method.slice(1));

      // Checks to see if module has the method, and calls it with options
      // unless there is no network connection <- but still will if alwaysCall = true
      for (i = 0; i < moduleQueue.length; i++) {
        mod = moduleQueue[i];
        hasMethod = true;
        if (mod.needsInternet && !Trampoline.util.isConnected) {
          hasMethod = false;
        }
        if ((mod.options && hasMethod) || mod.alwaysCall) {
          // execute method on the module
          Trampoline[mod.prop][method]
            ? Trampoline[mod.prop][method](mod.options)
            : null;
          mod[didMethod] = true;
        } else {
          // remove the module
          Trampoline[mod.prop].remove ? Trampoline[mod.prop].remove() : null;
          mod[didMethod] = false;
        }
      }

      // Fetch any resources the module needs by querying the module for a list.
      var loader = new Trampoline.util.ResourceLoader();
      // TODO : Need to check for multiple resource requests.
      // Could handle this here - instead of checking for duplicates in templating.
      // Unnecessary -- resource-loader handles duplicates already.
      for (i = 0; i < moduleQueue.length; i++) {
        mod = moduleQueue[i];
        if (mod[didMethod] && Trampoline[mod.prop].listResources) {
          loader.add(Trampoline[mod.prop].listResources());
        }
      }
      return loader;
    },
    /**
     * Injects trampoline.html into the DOM.
     * @private
     * @memberof Trampoline
     * @param {function} callback Callback, returns nothing.
     */
    _buildMarkup = function() {
      return new Promise(function(resolve, reject) {
        _log('Trying to inject trampoline...');
        Trampoline.util
          .fetch(_markupURL)
          .then(function(trampolineMarkup) {
            Trampoline.container.insertAdjacentHTML(
              'beforeend',
              trampolineMarkup
            );
            _log('...Trampoline injected!');
            resolve(trampolineMarkup);
          })
          .catch(function(err) {
            _log('...Trampoline failed to inject! :(', err);
            reject(err);
          });
      });
    };

  // Public Façade
  var facade = {
    init: init,
    state: state,
    onReady: onReady,
    refresh: refresh,
    /**
     * DOM Node containing #Trampoline
     * @memberof Trampoline
     */
    container: _trampolineContainer,

    /**
     * Throwing in a façade which attaches events to Trampoline.container
     * (So we can change things later without breaking the API.)
     */
    events: _trampolineContainer,
    _log: _log,
    _debug: _debug,
    /**
     * Name of Property App
     * @memberof Trampoline
     */
    PBSKidsAppName: PBSKidsAppName,
    GUID: GUID,
    _resourcePath: _resourcePath
  };

  // define these properties as getters as value
  // can change from config at init.
  Object.defineProperties(facade, {
    _path: {
      get: function() {
        return _path;
      }
    },
    _resourcePath: {
      get: function() {
        return _resourcePath;
      }
    },
    modules: {
      get: function() {
        return modules;
      }
    }
  });

  return facade;
})();

if (typeof module != 'undefined' && !!module.exports) {
  module.exports = Trampoline;
}

/**
 * Analytics Module for Trampoline
 * @memberof Trampoline
 * @namespace analytics
 */
(function(Trampoline) {
  Trampoline.analytics = (function() {
    var _log = Trampoline._log,
      _didInit = false,
      _source = null,
      _queue = [],
      UA,
      /**
       * Initializes Analytics if connected. Checks to see if ga obj exists, and initates new tracker for trampoline.
       * @memberof Trampoline.analytics
       * @param {String} configUA App Specific Google Analytics UA Code
       */
      init = function(configUA) {
        if (Trampoline.util.isConnected && !!Trampoline.analytics.UA) {
          if (!!configUA) {
            Trampoline.analytics.UA = configUA;
          }
          _log('Initializing Analytics...', Trampoline.analytics.UA);
          if (window.ga) {
            _source = 'window';
          }
          if (typeof ga == 'undefined') {
            (function(i, s, o, g, r, a, m) {
              i['GoogleAnalyticsObject'] = r;
              (i[r] =
                i[r] ||
                function() {
                  (i[r].q = i[r].q || []).push(arguments);
                }),
                (i[r].l = 1 * new Date());
              (a = s.createElement(o)), (m = s.getElementsByTagName(o)[0]);
              a.async = 1;
              a.src = g;
              m.parentNode.insertBefore(a, m);
            })(
              window,
              document,
              'script',
              'https://www.google-analytics.com/analytics.js',
              'ga'
            );
            _source = 'script';
          }
          if (_source == 'window') {
            window.ga.startTrackerWithId(Trampoline.analytics.UA);
            _log(
              'Created GA tracker instance through universal plugin: window.ga'
            );
          } else {
            ga('create', Trampoline.analytics.UA, 'auto');

            // Disable file protocol and cookie checks, so that the web-based analytics works inside cordova as per
            // http://stackoverflow.com/a/33766727 and
            // https://developers.google.com/analytics/devguides/collection/analyticsjs/tasks#disabling
            if (window.cordova !== undefined) {
              ga('set', 'checkProtocolTask', null); // Disable file protocol checking.
              ga('set', 'checkStorageTask', null); // Disable cookie storage checking.
              ga('set', 'historyImportTask', null); // Disable history checking (requires reading from cookies).
            }

            _log('Created GA tracker instance through js script');
          }
          _didInit = true;
        } else {
          _log(
            'Analytics not available',
            'UA Code: ' + Trampoline.analytics.UA
          );
        }
      },
      refresh = function(options) {
        if (!_didInit) {
          init(options);
        } else {
          _log('analytics.init already completed');
        }
      },
      /**
       * Send a Trampoline event to Google Analytics
       * @memberof Trampoline.analytics
       * @param {String} action   Name of event trigger
       * @param {String} label    Event (open, closed, pass) or Trigger Detail (MoreApps App Name + Badge)
       * @param {String} category Trampoline section *(not used in root level events)
       */
      event = function(action, label, category) {
        if (_didInit && Trampoline.util.isConnected) {
          var _propertyAppTitle = Trampoline.PBSKidsAppName.replace(/ /g, '_'),
            _appCategory = 'Trampoline_' + _propertyAppTitle;

          if (typeof category != 'undefined') {
            _appCategory += '_' + category;
          }

          if (_source === 'script') {
            ga('send', {
              hitType: 'event', // Required.
              eventCategory: _appCategory, // Required.
              eventAction: action, // Required.
              eventLabel: label,
              eventValue: 4
            });
          } else if (_source === 'window') {
            window.ga.trackEvent(_appCategory, action, label);
          }

          _log('send, event, ' + _appCategory + ', ' + action + ', ' + label);
        } else {
          _queue.push({
            type: 'event',
            category: category,
            action: action,
            label: label
          });
        }
      },
      /**
       * Set Custom Dimension
       * @param {number} index     The dimension index/key (1 for stations, leaving configurable for the future)
       * @param {string} dimension The name value of the dimension
       */
      dimension = function(index, dimension) {
        if (_didInit && Trampoline.util.isConnected) {
          if (_source == 'script') {
            ga('set', 'dimension' + index, dimension.toString());
          } else if (_source == 'window') {
            window.ga.addCustomDimension(index, dimension);
          }
          _log('Set ga dimension, ' + index + ' , ' + dimension);
        } else {
          _queue.push({
            type: 'dimension',
            index: index,
            dimension: dimension
          });
        }
      },
      //TODO: Clean this up, we don't actually need it
      _runQueue = function() {
        _log('Running analytics queue');
        for (var i = 0; i < _queue.length; i++) {
          var item = _queue.pop;
          if ((item.type = 'event')) {
            Trampoline.analytics.event(item.category, item.event, item.label);
          } else if ((item.type = 'dimension')) {
            Trampoline.analytics.dimension(item.index, item.dimension);
          }
        }
      };

    return {
      init: init,
      refresh: refresh,
      event: event,
      dimension: dimension,
      UA: UA
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Closed Captions Module for Trampoline
 * @memberof Trampoline
 * @namespace captions
 */
(function(Trampoline) {
  Trampoline.captions = (function() {
    var LOCAL_STORAGE_KEY = 'trampolineCaptions';

    var _trampolineContainer, //Using a scoped var here because we may not be in the start screen anymore
      _captionsContainer,
      _demoIsPlaying = false,
      _log = Trampoline._log,
      CAPTIONS_DISPLAY = new Event('CAPTIONS_DISPLAY'),
      CAPTIONS_DONE = new Event('CAPTIONS_DONE'),
      CAPTIONS_CLEAR = new Event('CAPTIONS_CLEAR'),
      //Caption Defaults. These ar public and can be globally set through Trampoline.captions.defaults
      //Minimum duration for English CC is Adults is 1 second :-/ which is fast , Words should be ~ 3 words / sec.
      /**
       * Defaults for closed caption display
       * @memberof Trampoline.captions
       * @public
       * @param {object} captionObj color, background, border, placement, duration, wordDuration, letterDuration
       */
      defaults = {
        color: 'FFCC00',
        background: 'transparent',
        border: 'none',
        placement: 'bottom',
        duration: 3000,
        wordDuration: 400,
        letterDuration: 100
      },
      /**
       * Initialize Captions module.
       * Injects trampolineCaptions into the document body and sets up a listener.
       * @memberof Trampoline.captions
       * @param {Object} options caption init options (none currently)
       */
      init = function(options) {
        //Inject trampolineCaptions after Trampoline element if it exists, otherwise add it after the last item in the body.
        _trampolineContainer =
          Trampoline.container ||
          document.getElementById('trampoline') ||
          document.body.lastChild();
        _captionsContainer = document.createElement('div');
        _captionsContainer.setAttribute('id', 'trampolineCaptions');
        _trampolineContainer.insertAdjacentElement(
          'afterend',
          _captionsContainer
        );

        Trampoline.events.addEventListener('CAPTIONS_DISPLAY', runQueue);

        // If captions has never been initialized before (first page load), save a default "captions off" state
        if (localStorage.getItem(LOCAL_STORAGE_KEY) === null) {
          localStorage.setItem(LOCAL_STORAGE_KEY, false);
        }

        Trampoline.modules.captions = {
          show: localStorage.getItem(LOCAL_STORAGE_KEY) === 'true',
          timer: false,
          queue: []
        };
      },
      /**
       * Displays Caption on the screen per object properties (text, duration, color, placement, background).
       * Advances to next caption in the queue after timeout.
       * @memberof Trampoline.captions
       * @param {object} captionObj A Caption or an Array or Captions.
       */
      display = function(captionObj) {
        if (!captionObj) {
          _log('Caption not an Object');
          return;
        }
        if (!Trampoline.modules.captions.show) {
          return;
        }

        var text = captionObj.text.replace(/\r?\n|\r/g, '<br>'),
          captionStyle = {
            color: captionObj.color || Trampoline.captions.defaults.color,
            'background-color':
              captionObj.background || Trampoline.captions.defaults.background,
            border: captionObj.border || Trampoline.captions.defaults.border
          },
          captionPlacement =
            captionObj.placement || Trampoline.captions.defaults.placement,
          //Duration is defaulted to ~2.5 words/second, no less than 100ms per letter/number
          // with a min display of 3 seconds
          captionDuration =
            captionObj.duration ||
            Math.max(
              (captionObj.text.split(' ').length +
                captionObj.text.split('/n').length +
                captionObj.text.split('<br>').length) *
                Trampoline.captions.defaults.wordDuration,
              Trampoline.captions.defaults.duration,
              Trampoline.util.countLettersNumbers(text) *
                Trampoline.captions.defaults.letterDuration
            ),
          captionElement = document.createElement('h3');

        //Make sure the container is clear. This should be redundant, as show should never
        //be called unless the previousl captions have been cleared
        //_captionsContainer.innerHTML = '';

        //Trying .removeChild in hopes that it's faster than = '' []
        while (_captionsContainer.firstChild) {
          _captionsContainer.removeChild(_captionsContainer.firstChild);
        }

        captionElement.classList.add(captionPlacement);
        captionElement.innerHTML = text;
        Object.keys(captionStyle).forEach(function(rule) {
          captionElement.style[rule] = captionStyle[rule];
        });

        _captionsContainer.appendChild(captionElement);

        //Clear all timeouts.
        clearTimeout(Trampoline.modules.captions.timer);
        Trampoline.modules.captions.timer = false;
        //Set a new timeout
        Trampoline.modules.captions.timer = setTimeout(next, captionDuration);
      },
      /**
         * Advances caption queue
         * @memberof Trampoline.captions
         * @Private
         
         * @event CAPTIONS_DONE Fires done event when queue is emptied.
         */
      next = function() {
        while (_captionsContainer.firstChild) {
          _captionsContainer.removeChild(_captionsContainer.firstChild);
        }
        if (Trampoline.modules.captions.queue.length === 0) {
          Trampoline.modules.captions.timer = false;
          Trampoline.events.dispatchEvent(CAPTIONS_DONE);
        } else {
          runQueue();
        }
      },
      /**
       * Throws away the current caption, clears the queue and the timeout on advancing the queue
       * @memberof Trampoline.captions
       * @public
       * @event CAPTIONS_CLEAR #Fires after the displayed caption and queue are cleared.
       */
      clear = function() {
        //Setting queue to [] has a tendancy to slowly update object references, 0 is more consistent, although 1ms slower
        Trampoline.modules.captions.queue.length = 0;
        clearTimeout(Trampoline.modules.captions.timer);
        Trampoline.modules.captions.timer = false;
        Trampoline.events.dispatchEvent(CAPTIONS_CLEAR);

        while (_captionsContainer.firstChild) {
          _captionsContainer.removeChild(_captionsContainer.firstChild);
        }
      },
      /**
       * Injects a caption into the queue
       * @memberof Trampoline.captions
       * @public
       * @param {Object} captionObj A single Caption object, or array of Caption objects.
       */
      queue = function(captionObj) {
        if (!captionObj && Trampoline.modules.captions.show) {
          _log('Caption not an object', captionObj);
          return;
        }

        //Append to queue if array, otherwise push single item to queue
        if (Array.isArray(captionObj) && captionObj.length > 1) {
          Array.prototype.push.apply(
            Trampoline.modules.captions.queue,
            captionObj
          );
        } else {
          Trampoline.modules.captions.queue.push(captionObj);
        }

        if (!Trampoline.modules.captions.timer) {
          Trampoline.events.dispatchEvent(CAPTIONS_DISPLAY);
        }
      },
      /**
       * Runs the Queue
       * @memberof Trampoline.captions
       * @private
       */
      runQueue = function() {
        if (Trampoline.modules.captions.queue.length > 0) {
          display(Trampoline.modules.captions.queue.shift());
        }
      },
      /**
       * Runs a Demo of the Captions
       * @memberof Trampoline.captions
       */
      demo = function() {
        if (!_demoIsPlaying) {
          _demoIsPlaying = true;
          Trampoline.captions.queue([
            { text: 'This is a caption sent through trampoline.' },
            { text: '0.4 seconds per word in the caption \n 3 second minimum' },
            { text: 'Hi.', color: '#CCFF33' },
            { text: 'Or set the duration of each caption' },
            { text: 'Hi. Bye.', duration: '1000' },
            {
              text:
                'Fire captions individually, or send an array of several captions.'
            },
            {
              text:
                'They will queue up and emit CAPTIONS_DONE on Trampoline.events when finished.'
            },
            {
              text: 'Put text on a contrasting background.',
              background: 'rgba(255, 0, 0 ,0.6)'
            },
            {
              text: 'Move captions to the top.',
              background: '#FFCC00',
              placement: 'top'
            },
            {
              text:
                "Text is injected as HTML<br><br>so you can <span style='color :#FF00CC; font-family: Colfax-Regular;'><em>do things like this</em></span>.",
              placement: 'bottom',
              background: 'rgba(0, 0, 0, 0.3)'
            },
            { text: 'Overwrite the styles with CSS.' },
            {
              text:
                'Change the duration, color and background defaults globally.'
            }
          ]);
        } else {
          _demoIsPlaying = false;
          Trampoline.captions.clear();
        }
      },
      /**
       * Toggles whether captions are displayed or not.
       * @memberof Trampoline.captions
       */
      toggle = function() {
        if (Trampoline.modules.captions.show === true) {
          clear();
          Trampoline.modules.captions.show = false;
          _log('Captions toggled OFF');
        } else {
          Trampoline.modules.captions.show = true;
          _log('Captions toggled ON');
        }

        localStorage.setItem(
          LOCAL_STORAGE_KEY,
          Trampoline.modules.captions.show
        );
      };
    return {
      init: init,
      defaults: defaults,
      queue: queue,
      clear: clear,
      toggle: toggle,
      demo: demo
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Language translation module for trampoline.
 * @memberof Trampoline
 * @namespace languages
 */
(function(Trampoline) {
  var LANGUAGE_CHANGED = new Event('LANGUAGE_CHANGED');
  var LANGUAGES_LOADED = new Event('LANGUAGES_LOADED');

  Trampoline.languages = (function() {
    var LOCAL_STORAGE_KEY = 'trampolineLanguage';

    var translationTable = {
      en: {},
      es: {}
    };

    var autoTranslateAllElements = function(nodeList) {
      // for all nodes passed, if the node has the a language key, automatically wire up the translation
      var node = null;
      for (var i = 0; i < nodeList.length; i++) {
        node = nodeList[i];

        if (node.dataset && node.dataset.languageKey !== undefined) {
          Trampoline.languages.autoTranslateElement(node);
        }

        // now recurse to any children as well
        autoTranslateAllElements(node.childNodes);
      }
    };

    // create a mutation observer that looks for the trampoline element to get new elements and auto-wire-up translation
    var observer = new MutationObserver(function(mutationsList) {
      mutationsList
        .filter(function(mutationRecord) {
          return mutationRecord.addedNodes instanceof NodeList;
        })
        .forEach(function(mutationRecord) {
          autoTranslateAllElements(mutationRecord.addedNodes);
        });
    });

    // if the trampoline container exists, listen for any new nodes to attach translation listeners
    var trampolineContainer = document.querySelector('#trampoline');
    if (trampolineContainer instanceof Node) {
      observer.observe(trampolineContainer, { childList: true, subtree: true });
    }

    return {
      init: function() {
        Trampoline._log('Languages init');

        var languageLoads = ['en', 'es'].map(function(languageCode) {
          var url =
            Trampoline._resourcePath +
            '/config/languages/' +
            languageCode +
            '.json';

          // fix some issues around formatting the path in non-crosswalk browsers
          url = url
            .replace(new RegExp('/+', 'g'), '/') // remove double slashes
            .replace(new RegExp('^/', 'g'), ''); // remove leading slashes

          return Trampoline.util.fetch(url).then(function(translations) {
            translationTable[languageCode] = JSON.parse(translations);
          });
        });

        Promise.all(languageLoads).then(function() {
          Trampoline.events.dispatchEvent(LANGUAGES_LOADED);
        });
      },

      /**
       * Gets the current configured language in trampoline
       * @return String
       */
      get: function() {
        // if a language was configured manually, use that
        if (localStorage.getItem(LOCAL_STORAGE_KEY) !== null) {
          return localStorage.getItem(LOCAL_STORAGE_KEY);
        }

        // otherwise, return the browser default
        return navigator.language.split('-')[0];
      },

      /**
       * Sets the current language
       * @param {String} newLanguage A language to switch to
       */
      set: function(newLanguage) {
        Trampoline._log('Setting language to ' + newLanguage);

        // persist the new language as an override to their browser's default
        localStorage.setItem(LOCAL_STORAGE_KEY, newLanguage);

        // let everyone know
        Trampoline.events.dispatchEvent(LANGUAGE_CHANGED, newLanguage);
      },

      /**
       * Looks up a key in the translation table and returns a translated string, based on the current configured
       * language, defaulting to English if there is no alternative translation. Returns an empty string if no matching
       * key exists in the translation table
       *
       * @param {String} key The key to look up
       * @return {String} The localized text, if it exists
       */
      translate: function(key) {
        var currentLanguage = Trampoline.languages.get();
        if (translationTable[currentLanguage] === undefined) {
          Trampoline._log(
            'No translation found for current language ' + currentLanguage
          );
          return '';
        }

        if (translationTable[currentLanguage][key] === undefined) {
          Trampoline._log('No translation found for key ' + key);
          return '';
        }

        return translationTable[currentLanguage][key];
      },

      /**
       * Watches a single element and keeps its innerText (or other configured) property up-to-date with the current
       * language. If languageKey and languageProperty are not provided, this method will attempt to read those as data
       * attributes (data-language-key and data-language-property) and use that.
       * @param {Node} element The element to watch
       * @param {String} languageKey The key to use for translation in the look-up table
       * @param {String} languageProperty The property to update. Defaults to "innerText"
       * @return {Object} A reference to the watcher instance, containing a single method "setTranslationKey" which
       *                  allows you to replace the translation key of a watched element on the fly
       */
      autoTranslateElement: function(element, languageKey, languageProperty) {
        // attempt to provide reasonable defaults
        languageKey = languageKey || element.dataset.languageKey;
        languageProperty =
          languageProperty || element.dataset.languageProperty || 'innerText';

        var listener = null;

        var watch = {
          setTranslationKey: function(languageKey) {
            Trampoline.events.removeEventListener('LANGUAGE_CHANGED', listener);
            Trampoline.events.removeEventListener('LANGUAGES_LOADED', listener);

            element[languageProperty] = Trampoline.languages.translate(
              languageKey
            );
            listener = function() {
              element[languageProperty] = Trampoline.languages.translate(
                languageKey
              );
            };
            Trampoline.events.addEventListener('LANGUAGE_CHANGED', listener);
            Trampoline.events.addEventListener('LANGUAGES_LOADED', listener);
          }
        };

        watch.setTranslationKey(languageKey);
        return watch;
      }
    };
  })();
})(Trampoline || {});

/**
 * Station Localization Module for Trampoline
 * (*this has nothing to do with language localization)
 * @memberof Trampoline
 * @namespace localize
 */
(function(Trampoline) {
  Trampoline.localize = (function() {
    var didLocalize = false,
      isLocalizing = false,
      _log = Trampoline._log,
      _stationServicesEndpoint =
        'https://station.services.pbs.org/api/public/v1/stations/',
      stationList = {},
      localStation,
      stationListCount,
      LOCALIZED = new Event('LOCALIZED'),
      STATION_LIST_POPULATED = new Event('STATION_LIST_POPULATED'),
      STATION_IMAGES_POPULATED = new Event('STATION_IMAGES_POPULATED'),
      /**
       * Initializes localization
       */
      init = function() {
        _log('init localization');
        //Setup one-time event listeners
        Trampoline.events.addEventListener(
          'STATION_IMAGES_POPULATED',
          _countStationManagerImageCollection
        );
      },
      /**
       * Hits the PBS localization service AUTO endpoint --> then Sets Localization
       * @memberof Trampoline.localize
       * @param {Function} callback Callback, returns stationList if successful
       * @param {Function} failCallback In the event of failure...
       */
      auto = function(callback, failCallback) {
        var stationListExpiry = Date.now() - 1 * (60 * 60 * 1000); //one hour ago
        Trampoline.localize.isLocalizing = true;
        //Make sure station list is populated. Populate station list
        if (!Trampoline.localize.stationList.length) {
          Trampoline.util
            .getLocalStorage('trampolineStationList', stationListExpiry)
            .then(function(lsStationList) {
              Trampoline.localize.stationList = JSON.parse(lsStationList);
              Trampoline.localize.didLocalize = 'localstorage';
              Trampoline.localize.isLocalizing = false;
              Trampoline.events.dispatchEvent(LOCALIZED);
              Trampoline.events.dispatchEvent(STATION_LIST_POPULATED);
              return;
            })
            .catch(function(err) {
              //Get a station list from Auto localization endpoint
              Trampoline.util
                .fetch('https://localization.services.pbs.org/localize/auto/')
                .then(function(data) {
                  if (!callback) {
                    callback = null;
                  }
                  _stationListFromAutoLocalizeData(data, callback);
                  Trampoline.localize.isLocalizing = false;
                  return;
                })
                .catch(function(data) {
                  _log('Failed to autolocalize');
                  console.log(data.error);
                  Trampoline.localize.isLocalizing = false;
                  if (typeof failCallback === 'function') {
                    _log('Resorting to fail callback', data.error);
                    failCallback();
                  }
                });
            });
        }
      },
      /**
       * Hit the PBS localization service ZIPCODE endpoint -> then Sets Localization
       * @memberof Trampoline.localize
       * @param {String}   zip          The Zipcode
       * @param {Function} callback     Callback that gets passed through several functions, ends with setting the stationList obj if succesful
       * @param {Function} failCallback In the event of failure...
       */
      zipcode = function(zip, callback, failCallback) {
        Trampoline.localize.isLocalizing = true;
        Trampoline.util
          .fetch(
            'https://localization.services.pbs.org/localize/zipcode/' +
              zip +
              '/'
          )
          .then(function(data) {
            if (!callback) {
              callback = null;
            }
            Trampoline.localize.isLocalizing = false;
            _stationListFromZipcodeLocalizeData(data, callback);
          })
          .catch(function(data) {
            _log('Failed to localize from zipcode');
            if (typeof failCallback === 'function') {
              Trampoline.localize.isLocalizing = false;
              _log('Resorting to fail callback', data.error);
              failCallback();
            }
          });
      },
      /**
       * Takes Auto Localization Data and hits Station Manager Endpoint to return more Station specific data.
       * @private
       * @memberof Trampoline.localize
       * @param {String}   localizedJSON AutoLocalization JSON
       * @param {function} callback      Callback passed in by localize.auto
       */
      _stationListFromAutoLocalizeData = function(localizedStr, callback) {
        Trampoline._log(
          'station callsigns retrieved by auto localization',
          callback
        );

        var localizedJSON = JSON.parse([localizedStr]),
          stationsObj = Object.keys(localizedJSON.stations),
          _setAutoLocalizationCallback = function(data) {
            _handleStationManagerData(data, callback);
          };

        if (stationsObj.length > 0) {
          Trampoline.localize.didLocalize = 'auto';
          //Clear the current stationlist
          Trampoline.localize.stationList = {};
          stationListCount = 0;
          for (var i = 0; i < stationsObj.length; i++) {
            var stationCallsign = stationsObj[i].toUpperCase();

            Trampoline.localize.stationList[stationCallsign] = {};

            //Get station image from station manager data
            _getStationManagerDataFromCallSign(
              stationCallsign,
              _setAutoLocalizationCallback
            );
          }
        }
      },
      /**
       * Takes Zipcode Localization Data and hits Station Manager Endpoint to return more Station specific data.
       * @private
       * @memberof Trampoline.localize
       * @param {String}   localizedJSON ZipcodeLocalization JSON
       * @param {Function} callback     Callback passed in by localize.zipcode
       */
      _stationListFromZipcodeLocalizeData = function(localizedStr, callback) {
        _log('station callsigns retrieved from zipcode');

        var localizedJSON = JSON.parse([localizedStr]),
          stationsObj = localizedJSON.stations,
          _setZipcodeLocalizationCallback = function(data) {
            _handleStationManagerData(data, callback);
          };

        if (stationsObj.length > 0) {
          Trampoline.localize.didLocalize = 'zipcode';

          //Clear the current stationlist
          Trampoline.localize.stationList = {};
          stationListCount = 0;

          //Go through the stationObject and add add each station to the stationList obj.
          for (var i = 0; i < stationsObj.length; i++) {
            var stationCallsign = stationsObj[i].callsign.toUpperCase();
            Trampoline.localize.stationList[stationCallsign] = {};
            //Asynchronousely fetch detailed station data from the Station Manager
            _getStationManagerDataFromCallSign(
              stationCallsign,
              _setZipcodeLocalizationCallback
            );
          }
        }
      },
      /**
       * Retrieves station details from station manager
       * @private
       * @memberof localize
       * @param {String}   callSign  Accepts a list of call signs
       * @param {function} onSuccess Success Callback
       * @param {function} onFail    Fail Callback
       */
      _getStationManagerDataFromCallSign = function(
        callSign,
        onSuccess,
        onFail
      ) {
        Trampoline.util
          .fetch(_stationServicesEndpoint + '?call_sign=' + callSign)
          .then(function(stationManagerStr) {
            var stationData = JSON.parse(stationManagerStr);

            if (stationData.data.length <= 0) {
              _log('Station Manager returned empty', callSign);
              delete Trampoline.localize.stationList[callSign];
            } else {
              onSuccess(stationManagerStr);
            }
          })
          .catch(function(data) {
            onFail(data);
          });
      },
      /**
       * Counts station manager data as it arrives, and fires STATION_LIST_POPULATED when all stations have been populated.
       * @private
       */
      _countStationManagerImageCollection = function() {
        stationListCount++;
        if (
          stationListCount >=
          Object.keys(Trampoline.localize.stationList).length
        ) {
          Trampoline.util.setLocalStorage(
            'trampolineStationList',
            JSON.stringify(Trampoline.localize.stationList)
          );
          Trampoline.events.dispatchEvent(STATION_LIST_POPULATED);
        }
      },
      /**
       * Parses station manager data and keys it to the stationList
       * @private
       * @memberof Trampoline.localize
       * @param {String}   stationManagerStr Data returned from Station Manager API
       * @param {function} callback          Callback, returns Station Image
       */
      _handleStationManagerData = function(stationManagerStr, callback) {
        var stationJSON = JSON.parse(stationManagerStr),
          stationData =
            stationJSON.data.length > 0 ? stationJSON.data[0].attributes : null;

        function _handleStationManagerImages(imageData) {
          Trampoline.localize.stationList[
            stationData.call_sign
          ].images = imageData;
          Trampoline.events.dispatchEvent(STATION_IMAGES_POPULATED);
        }

        if (!!stationData) {
          if (!!Trampoline.localize.stationList[stationData.call_sign]) {
            Trampoline.localize.stationList[stationData.call_sign].donate_url =
              stationData.donate_url;
            Trampoline.localize.stationList[stationData.call_sign].tvss_url =
              stationData.tvss_url;
            Trampoline.localize.stationList[
              stationData.call_sign
            ].full_common_name = stationData.full_common_name;
            Trampoline.localize.stationList[stationData.call_sign].callsign =
              stationData.call_sign;
            _parseStationManagerImages(
              stationData,
              _handleStationManagerImages
            );

            //Fire localized event if this is the first station in the list
            if (
              stationData.call_sign ==
              Object.keys(Trampoline.localize.stationList)[0]
            ) {
              var _autoLocalStation =
                Trampoline.localize.stationList[stationData.call_sign];
              Trampoline.util.setLocalStorage(
                'trampolineAutoLocalStation',
                JSON.stringify(_autoLocalStation)
              );
              Trampoline.events.dispatchEvent(LOCALIZED);
            }
          }
        } else {
          _log('No station data :', stationJSON);
          //TODO: remove this from the stationlist.
          //StationList.indexOf[]
        }
      },
      /**
       * Parse Station Specific Array of Image data from Station Manager Response
       * @private
       * @memberof Trampoline.localize
       * @param   {String} stationManagerStr Station Manager Response Data
       * @returns {Object} parsed and keyed Station Images
       */
      _parseStationManagerImages = function(stationData, callback) {
        var stationImagesObj = stationData.images,
          stationImages = {};

        for (var i = 0; i < stationImagesObj.length; i++) {
          stationImages[stationImagesObj[i].profile] = stationImagesObj[i].url;
        }
        callback(stationImages);
      },
      /**
       * Fetches the station image from the callsign specific data stored in the stationList obj.
       * Throws event on success/fail for error handling.
       * @param   {Object}   callsgn  Station Callsign
       * @param   {string}   logoType Which logo (color-logo, black-logo, white-logo)
       * @param   {function} callback A Callback
       * @returns {obj}      Loaded image object
       * @event GET_STATION_IMAGE# {status: true/false, data: stationListItem}
       */
      getStationImage = function(
        stationListItem,
        logoType,
        callback,
        resizeWidth,
        resizeHeight
      ) {
        var stationImageURL = stationListItem.images[logoType],
          GET_STATION_IMAGE;

        resizeWidth = resizeWidth || null;
        resizeHeight = resizeHeight || null;

        if (stationImageURL) {
          if (resizeWidth || resizeHeight) {
            _log('resizing station image');
            stationImageURL = Trampoline.util.resizeITS(
              stationImageURL,
              resizeWidth,
              resizeHeight
            );
          }
          Trampoline.localize.localStation = stationListItem;
          Trampoline.util
            .getImage(stationImageURL)
            .then(function(stationLogo) {
              stationLogo.setAttribute(
                'data-callsign',
                stationListItem.callsign
              );
              callback(stationLogo);

              GET_STATION_IMAGE = new CustomEvent('GET_STATION_IMAGE', {
                detail: { status: true, data: stationListItem }
              });
              Trampoline.events.dispatchEvent(GET_STATION_IMAGE);
            })
            .catch(function(error) {
              _log('Failed to load ' + stationImageURL);
              _log(error);
            });
        } else if (logoType != 'color-logo') {
          _log('Could not retrieve specified station image, trying color-logo');
          getStationImage(stationListItem, 'color-logo', callback);
        } else {
          _log('Could not retrieve specified station image');
          GET_STATION_IMAGE = new CustomEvent('GET_STATION_IMAGE', {
            detail: { status: false, data: stationListItem }
          });
          Trampoline.events.dispatchEvent(GET_STATION_IMAGE);
        }
      },
      setLocalStation = function(callsign) {
        var _localStation = Trampoline.localize.stationList[callsign];

        //Set everything to the new sation.
        Trampoline.localize.localStation =
          Trampoline.localize.stationList[callsign];
        Trampoline.localize.localStation.callsign = callsign;
        Trampoline.util.setLocalStorage(
          'trampolineLocalStation',
          JSON.stringify(_localStation)
        );

        //Update the Analytics Dimension
        Trampoline.analytics.dimension(1, callsign);

        Trampoline.localize.localStation = _localStation;
        Trampoline.events.dispatchEvent(LOCALIZED);
      };

    return {
      init: init,
      auto: auto,
      zipcode: zipcode,
      didLocalize: didLocalize,
      isLocalizing: isLocalizing,
      /**
       * Array of station data based on localization
       * @memberof Trampoline.localize
       */
      stationList: stationList,
      localStation: localStation,
      getStationImage: getStationImage,
      setLocalStation: setLocalStation
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * PBS Kids Super Vision Module for Trampoline
 * @memberof Trampoline
 * @namespace supervision
 */
(function(Trampoline) {
  Trampoline.nav = (function() {
    var _didInit = false,
      _log = Trampoline._log,
      NAV_READY = new Event('NAV_READY'),
      buttons = [],
      notifiers = [],
      /**
       * Builds Nav from Button Array in reverse order.
       * @private
       * @memberof Trampoline
       */
      init = function() {
        //TODO: Make sure that this runs properly through the module init
        if (
          !!Trampoline.modules.nav &&
          !Trampoline.container.querySelector('.main nav')
        ) {
          var trampolineMain = document.createElement('div'),
            trampolineNav = document.createElement('nav'),
            trampolineNavUL = document.createElement('ul');

          trampolineMain.classList.add('main');

          trampolineNav.appendChild(trampolineNavUL);
          trampolineMain.appendChild(trampolineNav);
          Trampoline.container.appendChild(trampolineMain);

          //TODO: NAV INIT here! Setup button and notifier objects
          _buildNav();
          _buildNotifiers();
        }
      },
      _buildNav = function() {
        var navObject = Trampoline.modules;
        // Build Defaults
        if (!!navObject.parents) {
          Trampoline.nav.buttons.push({
            languageKey: 'grownups',
            icon: 'parents',
            state: 'parents'
          });
        }

        //Settings Not Always True (that amazon kiddos thing or whatever)
        if (!!navObject.settings) {
          Trampoline.nav.buttons.push({
            languageKey: 'settings',
            icon: 'settings',
            state: 'settings'
          });
        }

        if (typeof navObject.supervision == 'object') {
          Trampoline.nav.buttons.push({
            icon: 'supervision',
            state: 'supervision'
          });
        }

        for (var i = Trampoline.nav.buttons.length - 1; i >= 0; i--) {
          _addButton(Trampoline.nav.buttons[i]);
        }
      },
      /**
       * Adds a buttons to the nav.
       * @private
       * @memberof Trampoline
       * @param {Object} buttonObj Named object with text, icon(optional) and callback(required)
       */
      _addButton = function(buttonObj) {
        var _buttonContainer = document.querySelector('.main nav ul'),
          _newButton = document.createElement('li');

        //Define Icon
        if (buttonObj.icon) {
          if (
            buttonObj.languageKey === undefined &&
            buttonObj.text === undefined
          ) {
            _newButton.classList.add(
              'button',
              'no-text',
              buttonObj.icon.toLowerCase()
            );
          } else {
            _newButton.classList.add(buttonObj.icon.toLowerCase(), 'button');
          }
          _newButton.innerHTML += '<div class="icon"></div>';
        } else {
          _newButton.classList.add('add-on', 'button');
          if (!buttonObj.hasOwnProperty('icon')) {
            _newButton.innerHTML += '<div class="icon"></div>';
          }
        }

        //Set Text
        if (buttonObj.languageKey) {
          var buttonTextContainer = document.createElement('h2');
          buttonTextContainer.dataset.languageKey = buttonObj.languageKey;
          _newButton.appendChild(buttonTextContainer);
        } else if (buttonObj.text) {
          _newButton.innerHTML += '<h2>' + buttonObj.text + '</h2>';
        }

        //Add Event Listener
        _log('Adding button:', buttonObj);
        _newButton.addEventListener(Trampoline.util.tapEvent, function(e) {
          e.preventDefault();
          Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
          if (buttonObj.hasOwnProperty('callback')) {
            buttonObj.callback();
          } else if (
            buttonObj.hasOwnProperty('state') &&
            Trampoline.state.current.name == 'main'
          ) {
            Trampoline.state.change({
              to: buttonObj.state
            });
          } else {
            _log(buttonObj[0] + ' : neither Callback nor State defined');
          }
        });

        _buttonContainer.insertBefore(_newButton, _buttonContainer.firstChild);
      },
      /**
       * Builds notifiers from array
       * @param {Array} _notifierArr All the notifiers
       */
      _buildNotifiers = function() {
        var _notifierArr = Trampoline.nav.notifiers;
        if (
          Trampoline.modules.hasOwnProperty('notifiers') &&
          Trampoline.modules.notifiers.length > 0
        ) {
          for (var i = 0; i < _notifierArr.length; i++) {
            _addNotifier(_notifierArr[i]);
          }
        }
      },
      /**
       * Creates a notifier and inserts it into #Trampoline.main
       * @param {Object} notifierObj The notifier, with properties. (icon, heading, instruction, arrow)
       */
      _addNotifier = function(notifierObj) {
        var _newContent = '';
        // TODO: Figure out where this needs to be set
        var _resourcePath = '';

        if (notifierObj.hasOwnProperty('icon')) {
          _newContent +=
            '<div class="icon"><img src="' +
            _resourcePath +
            'img/icons/badges/badge-' +
            notifierObj.icon +
            '.svg" /></div>';
        }
        if (notifierObj.hasOwnProperty('heading')) {
          _newContent +=
            '<div class="heading"><h2>' + notifierObj.heading + '</h2></div>';
        }

        if (notifierObj.hasOwnProperty('instructions')) {
          _newContent +=
            '<div class="instructions"><h3>' +
            notifierObj.instructions +
            '</h3></div>';
        }
        if (notifierObj.hasOwnProperty('arrow')) {
          _newContent +=
            '<div class="arrow"><img src="' +
            _resourcePath +
            'img/icons/arrow-' +
            notifierObj.arrow +
            '.svg" /></div>';
        }

        // Create the notifier and into .main if there is content (but before the nav).
        if (!!_newContent) {
          var _trampolineMain = Trampoline.container.querySelector('.main'),
            _newNotifier = document.createElement('div');

          _newNotifier.classList.add('notifier');
          _newNotifier.setAttribute('id', notifierObj.name + '-notifier');
          _newNotifier.innerHTML =
            '<div class="notifier-container">' + _newContent + '</div>';
          _trampolineMain.insertBefore(
            _newNotifier,
            _trampolineMain.firstChild
          );
        }
      };

    return {
      init: init,
      buttons: buttons,
      notifiers: notifiers
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * @memberof Trampoline
 * @namespace util
 */
(function(Trampoline) {
  var Trampoline = typeof window === 'undefined' ? {} : window.Trampoline;

  /**
   * The main constructor. Creates a ResourceLoader instance.
   * @class ResourceLoader
   * @memberof Trampoline.util
   */
  function ResourceLoader() {
    this.resources = {};
    this.listeners = {};
    this.loadQueue = [];
  }

  /**
   * Helper method to log things. Uses the trampoline logging system, but prefixes so we can filter things.
   *
   * @param {string} message The message to log
   */
  ResourceLoader.prototype.log = function(message) {
    Trampoline._log('Resource Loader | ' + message);
  };

  /**
   * Adds an item to the queue to be loaded
   *
   * @param {string} resource A URL for Trampoline to fetch as part of this load sequence
   */
  ResourceLoader.prototype.add = function(resource) {
    if (resource instanceof Array) {
      resource.forEach(
        function(item) {
          this.add(item);
        }.bind(this)
      );
      return;
    }

    this.loadQueue.push(resource);
  };

  /**
   * Registers an event listener to this resource loader
   *
   * @param {string} eventName The event to listen to
   * @param {Function} callback A callback to invoke when the event occurs
   */
  ResourceLoader.prototype.on = function(eventName, callback) {
    this.listeners[eventName] = this.listeners[eventName] || [];
    this.listeners[eventName].push(callback);
  };

  /**
   * Starts the load process, emitting a "complete" event when everything finishes up. Also returns a promise to notify
   * completion
   *
   * @emits complete
   * @return {Promise}
   */
  ResourceLoader.prototype.load = function() {
    this.log('Starting resource load for ' + JSON.stringify(this.loadQueue));
    var promises = this.loadQueue.map(
      function(item) {
        return this.attemptLoad(item);
      }.bind(this)
    );

    return Promise.all(promises).then(
      function(results) {
        this.log('Resources finished');
        this.trigger('complete', this);
      }.bind(this)
    );
  };

  /**
   * Triggers an event on the ResourceLoader instance.
   *
   * @param {string} eventName The event name to trigger
   * @param {Object} data The data to pass along to listeners
   */
  ResourceLoader.prototype.trigger = function(eventName, data) {
    if (this.listeners[eventName]) {
      this.listeners[eventName].forEach(function(listener) {
        listener(data);
      });
    }
  };

  /**
   * Attempts to load a resource that was added to the queue
   *
   * @param {string} item The item to attempt to load
   * @return {Promise}
   */
  ResourceLoader.prototype.attemptLoad = function(item) {
    return Trampoline.util
      .fetch(item)
      .catch(
        function(err) {
          // log the error, but swallow for now
          this.log('Failed to load ' + item, err);
          return '';
        }.bind(this)
      )
      .then(
        function(result) {
          this.resources[item] = result;
        }.bind(this)
      );
  };

  // delcare the util module if it doesn't exist
  Trampoline.util = Trampoline.util || {};

  // attach the resource loader onto the util module
  Trampoline.util.ResourceLoader = ResourceLoader;
})(Trampoline || {});

(function(Trampoline) {
  Trampoline.sha256 = (function() {
    // A SHA256 implementation (by Angel Marin and Paul Johnston)
    function SHA256(s) {
      var chrsz = 8;
      var hexcase = 0;

      function safe_add(x, y) {
        var lsw = (x & 0xffff) + (y & 0xffff);
        var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
        return (msw << 16) | (lsw & 0xffff);
      }

      function S(X, n) {
        return (X >>> n) | (X << (32 - n));
      }
      function R(X, n) {
        return X >>> n;
      }
      function Ch(x, y, z) {
        return (x & y) ^ (~x & z);
      }
      function Maj(x, y, z) {
        return (x & y) ^ (x & z) ^ (y & z);
      }
      function Sigma0256(x) {
        return S(x, 2) ^ S(x, 13) ^ S(x, 22);
      }
      function Sigma1256(x) {
        return S(x, 6) ^ S(x, 11) ^ S(x, 25);
      }
      function Gamma0256(x) {
        return S(x, 7) ^ S(x, 18) ^ R(x, 3);
      }
      function Gamma1256(x) {
        return S(x, 17) ^ S(x, 19) ^ R(x, 10);
      }

      function core_sha256(m, l) {
        var K = new Array(
          0x428a2f98,
          0x71374491,
          0xb5c0fbcf,
          0xe9b5dba5,
          0x3956c25b,
          0x59f111f1,
          0x923f82a4,
          0xab1c5ed5,
          0xd807aa98,
          0x12835b01,
          0x243185be,
          0x550c7dc3,
          0x72be5d74,
          0x80deb1fe,
          0x9bdc06a7,
          0xc19bf174,
          0xe49b69c1,
          0xefbe4786,
          0xfc19dc6,
          0x240ca1cc,
          0x2de92c6f,
          0x4a7484aa,
          0x5cb0a9dc,
          0x76f988da,
          0x983e5152,
          0xa831c66d,
          0xb00327c8,
          0xbf597fc7,
          0xc6e00bf3,
          0xd5a79147,
          0x6ca6351,
          0x14292967,
          0x27b70a85,
          0x2e1b2138,
          0x4d2c6dfc,
          0x53380d13,
          0x650a7354,
          0x766a0abb,
          0x81c2c92e,
          0x92722c85,
          0xa2bfe8a1,
          0xa81a664b,
          0xc24b8b70,
          0xc76c51a3,
          0xd192e819,
          0xd6990624,
          0xf40e3585,
          0x106aa070,
          0x19a4c116,
          0x1e376c08,
          0x2748774c,
          0x34b0bcb5,
          0x391c0cb3,
          0x4ed8aa4a,
          0x5b9cca4f,
          0x682e6ff3,
          0x748f82ee,
          0x78a5636f,
          0x84c87814,
          0x8cc70208,
          0x90befffa,
          0xa4506ceb,
          0xbef9a3f7,
          0xc67178f2
        );
        var HASH = new Array(
          0x6a09e667,
          0xbb67ae85,
          0x3c6ef372,
          0xa54ff53a,
          0x510e527f,
          0x9b05688c,
          0x1f83d9ab,
          0x5be0cd19
        );
        var W = new Array(64);
        var a, b, c, d, e, f, g, h, i, j;
        var T1, T2;

        m[l >> 5] |= 0x80 << (24 - (l % 32));
        m[(((l + 64) >> 9) << 4) + 15] = l;

        for (var i = 0; i < m.length; i += 16) {
          a = HASH[0];
          b = HASH[1];
          c = HASH[2];
          d = HASH[3];
          e = HASH[4];
          f = HASH[5];
          g = HASH[6];
          h = HASH[7];

          for (var j = 0; j < 64; j++) {
            if (j < 16) W[j] = m[j + i];
            else
              W[j] = safe_add(
                safe_add(
                  safe_add(Gamma1256(W[j - 2]), W[j - 7]),
                  Gamma0256(W[j - 15])
                ),
                W[j - 16]
              );

            T1 = safe_add(
              safe_add(safe_add(safe_add(h, Sigma1256(e)), Ch(e, f, g)), K[j]),
              W[j]
            );
            T2 = safe_add(Sigma0256(a), Maj(a, b, c));

            h = g;
            g = f;
            f = e;
            e = safe_add(d, T1);
            d = c;
            c = b;
            b = a;
            a = safe_add(T1, T2);
          }

          HASH[0] = safe_add(a, HASH[0]);
          HASH[1] = safe_add(b, HASH[1]);
          HASH[2] = safe_add(c, HASH[2]);
          HASH[3] = safe_add(d, HASH[3]);
          HASH[4] = safe_add(e, HASH[4]);
          HASH[5] = safe_add(f, HASH[5]);
          HASH[6] = safe_add(g, HASH[6]);
          HASH[7] = safe_add(h, HASH[7]);
        }
        return HASH;
      }

      function str2binb(str) {
        var bin = Array();
        var mask = (1 << chrsz) - 1;
        for (var i = 0; i < str.length * chrsz; i += chrsz) {
          bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (24 - (i % 32));
        }
        return bin;
      }

      function Utf8Encode(string) {
        string = string.replace(/\r\n/g, '\n');
        var utftext = '';

        for (var n = 0; n < string.length; n++) {
          var c = string.charCodeAt(n);

          if (c < 128) {
            utftext += String.fromCharCode(c);
          } else if (c > 127 && c < 2048) {
            utftext += String.fromCharCode((c >> 6) | 192);
            utftext += String.fromCharCode((c & 63) | 128);
          } else {
            utftext += String.fromCharCode((c >> 12) | 224);
            utftext += String.fromCharCode(((c >> 6) & 63) | 128);
            utftext += String.fromCharCode((c & 63) | 128);
          }
        }

        return utftext;
      }

      function binb2hex(binarray) {
        var hex_tab = hexcase ? '0123456789ABCDEF' : '0123456789abcdef';
        var str = '';
        for (var i = 0; i < binarray.length * 4; i++) {
          str +=
            hex_tab.charAt(
              (binarray[i >> 2] >> ((3 - (i % 4)) * 8 + 4)) & 0xf
            ) + hex_tab.charAt((binarray[i >> 2] >> ((3 - (i % 4)) * 8)) & 0xf);
        }
        return str;
      }

      s = Utf8Encode(s);
      return binb2hex(core_sha256(str2binb(s), s.length * chrsz));
    }

    return {
      digest: function(string) {
        Trampoline._log('SHA256(' + string + ')');
        return SHA256(string);
      }
    };
  })();
})(Trampoline || {});

/**
 * Sponsorship Module for Trampoline
 * @memberof Trampoline
 * @namespace sponsorship
 */
(function(Trampoline) {
  Trampoline.sponsor = (function() {
    var _log = Trampoline._log,
      /**
       * Initialize Sponsorship module
       * @memberof Trampoline.sponsor
       */
      init = function(sponsorObj) {
        _log('init sponsorship');
      };

    return {
      init: init
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Templating Module for Trampoline
 * @memberof Trampoline
 * @namespace templating
 */
(function(Trampoline) {
  Trampoline.templating = (function() {
    var _log = Trampoline._log,
      _convertToPath = function(template) {
        return Trampoline._path + 'templates/' + template + '.html';
      },
      _traverseElement = function(element, operator) {
        operator(element);

        for (var i = 0; i < element.children.length; i++) {
          _traverseElement(element.children[i], operator);
        }
      },
      /**
       * Lists resources for template
       * @param   {Object} templateConfig   configObj
       * @param   {Object} defaultTemplates List of defaults
       * @returns {Object}  templates        All Templates to be rendered with configs
       */
      _listResourcesForConfig = function(templateConfig, defaultTemplates) {
        // Fetch the list of templates in the default templates.
        var templates = defaultTemplates.map(function(obj) {
          return obj.template;
        });

        // check supplied custom config and add additional and remove defaults if needed.
        if (typeof templateConfig === 'object') {
          if (!templateConfig.includeDefaults) {
            templates.splice(0);
          }
          if (templateConfig.customPanels) {
            templates = templates.concat(
              templateConfig.customPanels.map(function(obj) {
                return obj.template;
              })
            );
          }
        }

        // convert this list of template to a list of file paths
        // of html template files to load.
        var hash = {};
        templates.forEach(function(str) {
          hash[str] = str;
        });

        templates.splice(0);
        for (var key in hash) {
          templates.push(_convertToPath(key));
        }

        return templates;
      },
      /**
       * Takes a set of template configs and default templates along with
       * loaded html template files ( resources ) and returns a list
       * of DOM elements customised and ready to insert into the DOM.
       * @returns {Object} DOM Fragments (Elements)
       */
      _buildTemplates = function(templateConfig, defaultTemplates, resources) {
        var templates = defaultTemplates.slice(0);
        if (typeof templateConfig === 'object') {
          if (!templateConfig.includeDefaults) {
            templates.splice(0);
          }
          if (templateConfig.customPanels) {
            templates = templates.concat(templateConfig.customPanels);
          }
        }

        var elements = [];
        var template, resource;
        for (var i = 0; i < templates.length; i++) {
          template = templates[i];

          // fetch html template resource.
          resource = resources[_convertToPath(template.template)];

          if (!resource) {
            throw new Error(
              'No resource found for template :',
              template.template
            );
          }

          // build template.
          elements.push(
            _buildTemplate(('000' + i).slice(-3), resource, template)
          );
        }

        return elements;
      },
      /**
       * [[Description]]
       */
      _buildTemplate = function(id, resource, config) {
        var fragment = document.createDocumentFragment();
        var temporaryContainer = document.createElement('div');
        temporaryContainer.innerHTML = resource;
        var root = temporaryContainer.firstElementChild;

        if (!root) {
          console.error('Problem using template with id : ', config.template);
          throw new Error(
            'Template error with template id :' + config.template
          );
          return;
        }
        // target elements ( those with ids )
        var elements = [];
        var hash = {};

        _traverseElement(root, function(ele) {
          if (ele.id) {
            elements.push(ele);
            hash[ele.id] = ele;
          }
        });

        // assign labels
        var key, ele;
        var labels = config.labels || {};
        for (key in labels) {
          ele = hash[key];
          if (ele) {
            ele.innerText = labels[key];
          } else {
            console.error(
              'Problem assigning label to template element with id :',
              key,
              ' - ' + config.template
            );
          }
        }

        // add css classes
        var classes = config.classList || {};
        var cls;
        for (key in classes) {
          ele = hash[key];
          if (ele) {
            cls = classes[key];
            if (typeof cls === 'string') {
              ele.classList.add(cls);
            } else if (cls instanceof Array) {
              ele.classList.add.apply(ele.classList, cls);
            } else {
              console.error(
                'Problem assigning supplied css class values to element id :',
                key,
                ' - ' + config.template
              );
            }
          } else {
            console.error(
              'Problem assigning css classes to template element with id :',
              key,
              ' - ' + config.template
            );
          }
        }

        // bind events
        var events = config.events || {};
        var args, eventType, targetId;
        for (key in events) {
          args = key.split('_');
          targetId = args[0];
          eventType = args[1];
          ele = hash[targetId];

          if (ele) {
            if (eventType === 'pointer') {
              // TODO : 'pointer' event type
              // handles both desktop and mobile pointer support??
            } else {
              ele.addEventListener(eventType, events[key]);
            }
          } else {
            console.error(
              'Problem assigning event to template element with id :',
              targetId,
              ' - ' + config.template
            );
          }
        }

        // finally, make ids unique before
        // inserting into main document.

        for (var i = 0; i < elements.length; i++) {
          ele = elements[i];
          ele.id = ele.id + '_' + id;
        }

        fragment.appendChild(root);

        // assign the id to the root element.
        if (config.id) {
          root.id = config.id;
        }

        if (config.onBuildComplete) {
          var contentAreas = root.querySelectorAll('*[data-content]');
          config.onBuildComplete(root, contentAreas, '_' + id);
        }

        return fragment;
      };

    return {
      listResourcesForConfig: _listResourcesForConfig,
      buildTemplates: _buildTemplates,
      buildTemplate: _buildTemplate
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * @memberof Trampoline
 * @namespace util
 */
(function(Trampoline) {
  var showDataEndpoint = 'https://pbskids.org/api/trampoline/v1/shows',
    allShowsData,
    //showDataEndpoint = 'https://cms.pbskids.org/api/catalog/shows',
    //TODO: Update this Query to include sponsorship information
    //showDataQuery    = '?with=short_description&with=min_age&with=max_age&with=google_analytics_id&with=tier_group&include=curriculum',
    _log = Trampoline._log,
    currentTouches = [],
    BUILD_DATA_RETURNED = new Event('BUILD_DATA_RETURNED'),
    //scoped functions that need to wait for Trampolin.util.init below.
    isConnected,
    init = function() {
      // set the installation id if it's not set already
      getLocalStorage('installation_id').catch(function() {
        var openTime = Date.now();

        var buf = new Uint8Array(8);
        var randomId = '';
        window.crypto.getRandomValues(buf);
        buf.forEach(function(singleByte) {
          randomId += singleByte.toString(16);
          if (singleByte < 16) {
            randomId += '0';
          }
        });

        var installationId = Trampoline.sha256.digest(
          openTime + '_' + randomId
        );
        _log('Writing hashed installation id ' + installationId);
        return setLocalStorage('installation_id', installationId);
      });

      Trampoline.util.isConnected = /**
       * Self Executing function which checks for internet availability (on load only).
       * @memberof Trampoline.util
       * @returns {Boolean}
       */ (function(checkURL) {
        if (
          !!window.cordova &&
          typeof navigator.connection != 'undefined' &&
          typeof navigator.connection.type != 'undefined'
        ) {
          var cordovaOnline =
            navigator.connection.type == 'Connection.NONE' ? false : true;

          return cordovaOnline;
        } else if (!!window.navigator.onLine) {
          return window.navigator.onLine;
        }
      })();

      Trampoline.util.tapEvent = (function() {
        //return mobileCheck() ? 'touchstart' : 'click';
        return document.documentElement.hasOwnProperty('ontouchstart')
          ? 'touchstart'
          : 'click';
      })();
    },
    /**
     * XHR Data Fetch
     * @memberof Trampoline.util
     * @param {String}   url       Data URI
     * @param {function} onSuccess Success callback
     * @param {function} onFail    Fail callback
     * @param {Object}   options   Options to provide to the request
     * @param {Object}   options.header A key-value set of headers to add to the request.
     * @param {Object}   options.timeout A timeout in milliseconds before marking the request as failing
     * @param {Object}   options.data Form data to provide in the request
     * @param {String}   options.method The HTTP Verb to send the request as
     *
     */
    fetch = function(url, options) {
      return new Promise(function(resolve, reject) {
        options = options || {};

        //TODO: Finish writing local storage?.
        var maxWaitTime = options.timeout || 2000,
          headers = options.headers || {},
          data = options.data || {},
          method = options.method ? options.method.toUpperCase() : 'GET',
          xhr = new window.XMLHttpRequest(),
          expiry = options.hasOwnProperty('expired')
            ? options.expired
            : Date.now() - 1000 * 60 * 60 * 24 * 7,
          noResponseTimer = window.setTimeout(function() {
            xhr.abort();
            getLocalStorage(url, expiry)
              .catch(function(error) {
                reject(error, xhr);
                return;
              })
              .then(function(localStorageData) {
                resolve(localStorageData, xhr);
                return;
              });
          }, maxWaitTime);

        // headers['Access-Control-Allow-Origin'] = '*.pbskids.org/*, pbskids.org/**, */google-analytics.com/**, *.pbs.org/*';

        xhr.onreadystatechange = function() {
          if (xhr.readyState != 4) {
            return;
          }

          if (xhr.status == 200 || (xhr.status === 0 && xhr.responseText)) {
            window.clearTimeout(noResponseTimer);
            Trampoline.util.setLocalStorage(url, xhr.responseText);
            resolve(xhr.responseText, xhr);
            return;
          } else {
            getLocalStorage(url, expiry)
              .then(function(localStorageData) {
                _log('Fetch failed. Local storage succeeded!');
                resolve(localStorageData, xhr);
                return;
              })
              .catch(function(localStorageError) {
                reject(new Error('Fetch failed, along with localStorage'), xhr);
                return;
              });
          }
        };

        //TODO: clean up these dangling Vars

        // build a query string for the end
        var queryString = Object.keys(data)
          .map(function(key) {
            return (
              encodeURIComponent(key) + '=' + encodeURIComponent(data[key])
            );
          })
          .join('&');

        var getURL = url;
        if (queryString !== '') {
          getURL = url + '?' + queryString;
        }

        if (method === 'GET') {
          xhr.open('GET', getURL);
        } else if (method === 'POST') {
          xhr.open('POST', url);
          headers['Content-type'] = 'application/x-www-form-urlencoded';
        }

        // Attach headers
        Object.keys(headers).forEach(function(key) {
          _log('setting header: ' + key + ' : ' + headers[key]);
          xhr.setRequestHeader(key, headers[key]);
        });

        if (method === 'GET') {
          xhr.send();
        } else if (method === 'POST') {
          xhr.send(queryString);
        }
      });
    },
    /**
     * Set to Local Storage
     * @memberof util
     * @param {string} key        Named key for local storage
     * @param {object} dataObject Data to store
     */
    setLocalStorage = function(key, dataObject) {
      if (
        window.hasOwnProperty('localStorage') &&
        window.localStorage !== null
      ) {
        window.localStorage.setItem(
          key,
          JSON.stringify({
            data: dataObject,
            timestamp: Date.now()
          })
        );
      } else {
        _log('Error: Local Storage Not Available');
      }
    },
    /**
     * Get from Local Storage
     * @memberof! util
     * @param   {string} key Named key of local storage
     * @param   {string} Expiration Date - returns anything stored after this date
     * @returns {String} Data retrieved from local storage
     * TODO: Promisify this
     */
    getLocalStorage = function(key, expiry) {
      return new Promise(function(resolve, reject) {
        if (
          window.hasOwnProperty('localStorage') &&
          window.localStorage !== null
        ) {
          var localStorageStr = window.localStorage.getItem(key),
            localStorageObject = JSON.parse(localStorageStr),
            localStorageExpiration = !!expiry ? Date.parse(expiry) : Date.now();

          //If the local storage is old, convert it to new local storage and re-retrieve
          if (
            !!localStorageObject &&
            !localStorageObject.hasOwnProperty('data')
          ) {
            Trampoline.util.setLocalStorage(key);
            localStorageObject = window.localStorage.getItem(key);
          }

          // Return null if expired
          if (!!expiry) {
            if (
              localStorageObject.hasOwnProperty('timestamp') &&
              localStorageExpiration < Date.parse(localStorageObject.timestamp)
            ) {
              reject(new Error('LocalStorage Data Expired'));
              return;
            }
          }

          if (
            !!localStorageObject &&
            localStorageObject.hasOwnProperty('data')
          ) {
            resolve(localStorageObject.data);
            return;
          } else {
            reject(new Error('Local storage not found for: ' + key));
            return;
          }
        } else {
          _log('Error: Local Storage Not Available');
          reject(new Error('LocalStorage Error'));
          return;
        }
      });
    },
    /**
     * Returns a show from the show data endpoint.
     * @param   {String} showGUID The GUID of the show
     * @param   {String} callback A function which accepts the data as an argument
     * @event SHOW_DATA_RETURNED #The show data is returned to e.target.data
     */
    getShowData = function(showGUID, callback) {
      var showDataExpiration = new Date(new Date() - 1000 * 60 * 60 * 24 * 7),
        /**
         * Return a single show data obj
         * @private
         * @param   {Object} allShowDataJSON The data in json form
         * @returns {Object} The show object
         */
        _returnShowData = function(allShowData) {
          var SHOW_DATA_RETURNED, i;

          if (showGUID) {
            for (i = 0; i < allShowData.length; i++) {
              if (allShowData[i].guid == showGUID) {
                SHOW_DATA_RETURNED = new Event('SHOW_DATA_RETURNED', {
                  data: allShowData[i]
                });
                _log('show data : ', allShowData[i]);
                Trampoline.events.dispatchEvent(SHOW_DATA_RETURNED);
                if (callback) {
                  callback(allShowData[i]);
                }
                return allShowData[i];
              }
              _log('Error retrieving Show ID');
              SHOW_DATA_RETURNED = new Event('SHOW_DATA_RETURNED', {
                data: null
              });
              if (callback) {
                callback(null);
              }
              Trampoline.events.dispatchEvent(SHOW_DATA_RETURNED);
            }
          }
        };

      getLocalStorage('trampoline_allShowsData', showDataExpiration)
        .catch(function() {
          return Trampoline.util.fetch(showDataEndpoint);
        })
        .then(function(allShowsDataJSON) {
          allShowsData =
            typeof allShowsDataJSON == 'string'
              ? JSON.parse(allShowsDataJSON)
              : allShowsDataJSON;

          if (!!allShowsData[0] && allShowsData[0].hasOwnProperty('guid')) {
            Trampoline.util.setLocalStorage(
              'trampoline_allShowsData',
              allShowsData
            );
            _returnShowData(allShowsData);
          }
        })
        .catch(function() {
          _log('No show data, or data empty');
          return {};
        });
    },
    /**
     * Add sticky class on scroll
     * @memberof! Trampoline.util
     * @param {Object} element         DOM Node to make sticky
     * @param {Object} scrollingParent Parent object that will scroll
     */
    makeSticky = function(element, scrollingParent) {
      var top = element.offsetTop;
      scrollingParent.onscroll = function() {
        var y = scrollingParent.scrollTop;
        if (y > top) {
          element.classList.add('sticky');
        } else {
          element.classList.remove('sticky');
        }
      };
    },
    /**
     * Scroll to top based on window height and scroll distance
     * @memberof! Trampoline.util
     * @param   {Object} element DOM Node to scroll
     * @param   {Number} time    Time in MS
     * @returns {object} I honestly don't remember what this is for
     */
    scrollToTop = function(element, time) {
      var _currentSpeed,
        _animateFrame = (function() {
          var action =
            window.requestAnimationFrame ||
            window.webkitRequestAnimationFrame ||
            window.mozRequestAnimationFrame ||
            window.oRequestAnimationFrame ||
            window.msRequestAnimationFrame ||
            function(callback) {
              window.setTimeout(callback, 1000 / 60);
            };
          return function(runner) {
            action.call(window, runner);
          };
        })(),
        _scrollTop = function(element, nextFrame) {
          if (nextFrame === null) {
            var isNull;
            isNull =
              element.scrollY !== null ? element.scrollY : element.scrollTop;
            return isNull;
          } else if (nextFrame <= 0) {
            element.scrollTo ? element.scrollTo(0, 0) : (element.scrollTop = 0);
            return 0;
          } else {
            element.scrollTo
              ? element.scrollTo(0, nextFrame)
              : (element.scrollTop = nextFrame);
            return nextFrame;
          }
        },
        _speedConduct = function(originSpeed, time, cur, total) {
          if (total === 0) {
            return 0;
          }
          var _INIT_SPEED = 2;
          return (
            originSpeed * Math.sin((Math.PI * (total - cur)) / total) +
            _INIT_SPEED
          );
        },
        _originY = _scrollTop(element),
        _currentY = _originY,
        _originSpeed = _originY / (time / 60);

      (function _operate() {
        _currentSpeed = _speedConduct(_originSpeed, time, _currentY, _originY);
        _currentY -= _currentSpeed;
        if (_scrollTop(element, _currentY) !== 0) {
          _animateFrame(_operate);
        }
      })();
    },
    /**
     * Replace line breaks and spaces with underscores
     * @memberof! Trampoline.util
     * @param   {String} string String to run regex on
     * @returns {string} Returns empty string if a string is not supplied
     */
    underscore = function(string) {
      return typeof string === 'string' ? string.replace(/\n| /g, '_') : '';
    },
    /**
     * Gets an image from a remote location
     * @memberof Trampoline.util
     * @param {String} url The url to fetch
     * @return {Promise<Image>} A promise that resolves to the loaded image
     */
    getImage = function(url) {
      return new Promise(function(resolve, reject) {
        var img = new Image();
        img.addEventListener('load', function() {
          resolve(img);
        });
        img.addEventListener('error', function(event) {
          reject(event);
        });
        img.src = url;
      });
    },
    /**
     * Changes URI to return resized image.pbs.org images with the Image Transformation Service
     * @memberof! Trampoline.util
     * @param   {String} imageURI The image Location
     * @param   {String} resizeW  New Width
     * @param   {String} resizeH  New Height
     * @returns {String} Configured URI, or original if conditions not met.
     */
    resizeITS = function(imageURI, resizeW, resizeH, newExt) {
      _log('trying to resize image with ITS');
      if (!!imageURI && imageURI.indexOf('image.pbs.org') > -1) {
        var resizedURI = imageURI + '.resize.',
          extension = newExt || /(?:\.([^.]+))?$/.exec(imageURI)[0];

        if (!!resizeW || !!resizeH) {
          if (!!resizeW) {
            resizedURI += resizeW + 'x';
            if (!!resizeH) {
              resizedURI += resizeH;
            }
          } else if (!!resizeH) {
            resizedURI += 'x' + resizeH;
          }
          return (resizedURI += extension);
        } else {
          _log('Neither resize Width or Height Specified');
          return imageURI;
        }
      } else {
        _log('Image Transormation Service not available on given URI');
        return imageURI;
      }
    },
    /**
     * Check to see if Cordova App
     * @memberof Trampoline.util
     * @name isCordova
     * @returns {bool}
     */

    isCordova = function() {
      var namespace = !!window.cordova;
      return namespace;
    },
    /**
     * Function to see if this an iOS device
     * @memberof! Trampoline.util
     * @returns {Boolean} Returns true only if iOS
     */
    isiOS = function() {
      var iosUA = !!isCordova.call()
        ? /iOS|iPhone|iPad|iPod|apple-tablet/i.test(window.device.platform)
        : /iPhone|iPad|iPod|apple-tablet/i.test(window.navigator.userAgent);
      return iosUA || false;
    },
    /**
     * Function to see if this an Amazon device
     * @memberof! Trampoline.util
     * @returns {Boolean} Returns true only if Amazon / Silky
     */
    isAmazon = function() {
      var silkyUA = !!isCordova.call()
        ? /Amazon/i.test(window.device.platform)
        : /silk|kindlefire/gi.test(window.navigator.userAgent);
      return silkyUA || false;
    },
    /**
     * Function to see if this an Android device
     * @memberof! Trampoline.util
     * @returns {Boolean} Returns true only if Android
     */

    isAndroid = function() {
      var androidUA = !!isCordova.call()
        ? /Android/i.test(window.device.platform)
        : /Android/i.test(window.navigator.userAgent);
      return androidUA || false;
    },
    /**
     * Random number generator
     * @memberof Trampoline.util
     * @param   {Number} min Lower threshold
     * @param   {Number} max Upper threshold
     * @returns {Number} Random integer between min and max
     */
    randomInt = function(min, max) {
      return Math.floor(Math.random() * (max - min + 1)) + min;
    },
    //TODO: Promisify
    getBuildData = function() {
      var _onSuccess = function(buildString) {
          Trampoline.modules.buildData = JSON.parse(buildString);
          _log('Build data returned');
          Trampoline.events.dispatchEvent(BUILD_DATA_RETURNED);
        },
        _onFail = function() {
          Trampoline.modules.buildData = false;
          _log('Could not set build data');
        };

      fetch('build-data.json', _onSuccess, _onFail);
    },
    displayBuildData = function() {
      //TODO: Inject the styles here, not in the LESS.
      var _buildData = Trampoline.modules.buildData,
        _buildDataContainer = document.createElement('section');

      _buildDataContainer.setAttribute('id', 'trampoline-debug-data');
      _buildDataContainer.innerHTML =
        '<div class="build-data">' +
        'PBS Kids Trampoline ' +
        _buildData.tag +
        '<br>' +
        _buildData.branch +
        '  #' +
        _buildData.hash +
        '<br>' +
        _buildData.date +
        ' ' +
        _buildData.time +
        '</div>';

      document.getElementById('trampoline').appendChild(_buildDataContainer);
    },
    /**
     * Random selection of items from an array
     * @param   {Array}  array    The original array reference
     * @param   {number} numItems Number of items to retun
     * @returns {Array}     An array of randomly pop'd items from the array (no duplicates).
     */
    randomArraySelection = function(array, numItems) {
      var _itemArray = [],
        _randomArray = [];

      Array.prototype.push.apply(_itemArray, array);

      while (_itemArray.length > 0 && _randomArray.length < numItems) {
        var _randomItemIndex = Trampoline.util.randomInt(
            0,
            _itemArray.length - 1
          ),
          _randomItem = _itemArray[_randomItemIndex];

        _randomArray.push(_itemArray[_randomItemIndex]);
        _itemArray.splice(_randomItemIndex, 1);
      }

      return _randomArray;
    },
    /**
     * Add an animation class to an element, then remove the class when animation is complete
     * @param {Object} node      The element
     * @param {Str}    animation The animation CSS class (See animation.less)
     */
    toggleAnimation = function(node, startAnimation, exitAnimation) {
      //TODO: move functions out of if block
      function whichAnimationEvent() {
        var t,
          el = document.createElement('fakeelement'),
          animations = {
            animation: 'animationend',
            WebkitAnimation: 'webkitAnimationEnd'
          };
        for (t in animations) {
          if (el.style[t] !== undefined) {
            return animations[t];
          }
        }
      }

      function exitAnimEvent(e) {
        e.target.removeEventListener(animationEvent, exitAnimEvent);
        if (e.target.classList.contains(startAnimation)) {
          e.target.classList.remove(startAnimation);
          //Add the new exit event listener and animation
          e.target.addEventListener(animationEvent, removeAnimEvent, false);
          node.classList.add(exitAnimation);
        }
      }

      function removeAnimEvent(e) {
        e.target.removeEventListener(animationEvent, removeAnimEvent);
        if (e.target.classList.contains(startAnimation)) {
          e.target.classList.remove(startAnimation);
        } else if (e.target.classList.contains(exitAnimation)) {
          e.target.classList.remove(exitAnimation);
        }
      }

      if (
        !node.classList.contains(startAnimation) &&
        !node.classList.contains(exitAnimation)
      ) {
        var animationEvent = whichAnimationEvent();

        //Black Magic to trigger a repaint if restarting the animation (ﾉ◕ヮ◕)ﾉ*:･ﾟ✧
        //node.offsetWidth = node.offsetWidth;

        if (!!exitAnimation) {
          node.addEventListener(animationEvent, exitAnimEvent, false);
        } else {
          node.addEventListener(animationEvent, removeAnimEvent, false);
        }

        node.classList.add(startAnimation);
      }
    },
    /**
     * Injects contents of .svg into DOM Node with xhr request, so that it can be manipulated with CSS and JS.
     * @private
     * @memberof Trampoline
     * @todo TODO: Finish inject SVG function
     * @param {object}   node   DOM Node
     * @param {string}   url    SVG Location
     * @param {function} onFail Callback in the event that the SVG is unreachable
     *
     */
    injectSVG = function(node, url, onFail) {
      Trampoline.util
        .fetch(url)
        .then(function(svgData) {
          node.innerHTML = svgData;
        })
        .catch(function() {
          _log('Failed to inject SVG');
          if (typeof onFail == 'function') {
            onFail();
          }
        });
    },
    mobileCheck = function() {
      var check = false;
      (function(a) {
        if (
          /(android|ipad|playbook|silk|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(
            a
          ) ||
          /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(
            a.substr(0, 4)
          )
        )
          check = true;
      })(navigator.userAgent || navigator.vendor || window.opera);
      return check;
    },
    //tapEvent is self defined and init'ed above
    tapEvent = (function() {
      //return mobileCheck() ? 'touchstart' : 'click';
      return document.documentElement.hasOwnProperty('ontouchstart')
        ? 'touchstart'
        : 'click';
    })(),
    tapEnterExit = function(node, onTapEnter, onTapExit) {
      //TODO: make this check more robust
      var startEvent = mobileCheck() ? 'touchstart' : 'mousedown',
        endEvent = mobileCheck() ? 'touchend' : 'mouseup';

      function handleStartEvent(e) {
        e.target.addEventListener(endEvent, onTapExit);
      }

      //handle the start tap
      node.addEventListener(startEvent, handleStartEvent);
    },
    styleSheet = (function() {
      var stylesheets = document.styleSheets[document.styleSheets.length - 1],
        trampolineStyleSheet;

      for (var i = 0; i < document.styleSheets.length; i++) {
        if (
          document.styleSheets[i].href &&
          document.styleSheets[i].href.indexOf('trampoline.css')
        ) {
          trampolineStyleSheet = document.styleSheets[i];
          break;
        }
      }
      return trampolineStyleSheet;
    })(),
    handleSwipeTouchStart = function(startEvent) {
      var touchstartX = startEvent.changedTouches[0].clientX,
        touchstartY = startEvent.changedTouches[0].clientY;

      function swipeTouchEndCallback(endEvent) {
        startEvent.target.removeEventListener(
          'touchend',
          swipeTouchEndCallback
        );
        handleSwipeTouchEnd(endEvent, touchstartX, touchstartY);
      }

      startEvent.target.addEventListener('touchend', swipeTouchEndCallback);
    },
    handleSwipeTouchEnd = function(endEvent, touchstartX, touchstartY) {
      var swipeEvent,
        dX = touchstartX - endEvent.changedTouches[0].clientX,
        dY = touchstartY - endEvent.changedTouches[0].clientY,
        acceptableDistanceX = screen.width * 0.05,
        acceptableDistanceY = screen.height * 0.1;

      //old version of distance that's relative to screen diagonal
      //acceptableDistance = 0.3 * Math.sqrt(screen.width*screen.width + screen.height*screen.height);

      if (Math.abs(dY) > Math.abs(dX) && Math.abs(dX) / Math.abs(dY) < 1) {
        //Swiped Vert
        if (Math.abs(dY) > acceptableDistanceY) {
          swipeEvent = dY > 0 ? 'TRAMPOLINE_SWIPE_UP' : 'TRAMPOLINE_SWIPE_DOWN';
        }
      } else if (
        Math.abs(dY) < Math.abs(dX) &&
        Math.abs(dY) / Math.abs(dX) < 1
      ) {
        //Swiped Horz
        if (Math.abs(dX) > acceptableDistanceX) {
          swipeEvent =
            dX > 0 ? 'TRAMPOLINE_SWIPE_LEFT' : 'TRAMPOLINE_SWIPE_RIGHT';
        }
      }

      if (!!swipeEvent) {
        var SWIPE_EVENT = new CustomEvent(swipeEvent, {
          detail: { touchEndEvent: endEvent, dX: dX, dY: dY }
        });

        Trampoline.events.dispatchEvent(SWIPE_EVENT);
      }
    },
    /**
     * Copies the touch event
     * @param   {object} touch touchevent
     * @returns {object} object with params from touchevent
     */
    copyTouchEvent = function(touch) {
      return {
        identifier: touch.identifier,
        pageX: touch.pageX,
        pageY: touch.pageY,
        clientX: touch.clientX,
        clientY: touch.clientY
      };
    },
    /**
     * Touchevent pull down from to - panel will close, translate3D attached to touchmove for UX feedback
     * TODO: Write in conditions to accept dX value
     * @param   {object}         pullElement the panel to move
     * @param   {object}         options {dY, dX, scrollParent, parentElement}
     */
    addSwipePull = function(pullElement, options) {
      var startTouch = {},
        triggerDistanceY = screen.height * 0.0,
        direction = parseFloat(options.dY) < 0 ? -1 : 1,
        acceptableDistanceY = !!options.dY ? screen.height * options.dY : false,
        acceptableDistanceX = !!options.dX ? screen.width * options.dX : false,
        _scrollParent = !!options.scrollParent ? options.scrollParent : false,
        _parentElement = !!options.parentElement
          ? options.parentElement
          : pullElement,
        startTransformMatrix;

      pullElement.addEventListener('touchstart', _handlePullTouchStart, false);
      var startTransformMatrixStr;

      function _handlePullTouchStart(e) {
        if (!!_scrollParent && _scrollParent.scrollTop > 0) {
          // Quit it. Touchstart on scroll that is not at the top
          return;
        }

        // Attempt to get the current parent's transform. Some browsers are prefixed, so we have to check webkitTransform too.
        var transform = 'matrix(1, 0, 0, 1, 0, 0)';
        var computedStyle = window.getComputedStyle(_parentElement);
        if (computedStyle.transform) {
          transform = computedStyle.transform;
        } else if (computedStyle.webkitTransform) {
          transform = computedStyle.webkitTransform;
        }
        startTransformMatrixStr = Trampoline.util.matrixStrToArr(transform);

        //TODO: capture more than just the first touch
        startTouch = Trampoline.util.copyTouchEvent(e.changedTouches[0]);
        pullElement.addEventListener('touchmove', _handlePullTouchMove, false);
        pullElement.addEventListener('touchend', _handlePullTouchEnd, false);
      }

      function _handlePullTouchMove(e) {
        var changedTouches = e.changedTouches;

        for (var i = 0; i < changedTouches.length; i++) {
          if (changedTouches[i].identifier == startTouch.identifier) {
            //You got the touch! (You got the power!)
            var move_dY = startTouch.clientY - changedTouches[i].clientY,
              updatedTransformMatrix = startTransformMatrixStr.slice();

            if (
              direction < 0
                ? move_dY < triggerDistanceY
                : move_dY > triggerDistanceY
            ) {
              if (!!_scrollParent) {
                if (!_scrollParent.classList.contains('pulled')) {
                  _scrollParent.classList.add('pulled');
                }
                _scrollParent.scrollTop = 0;
              }
              //Update the Transformation based on any Transform already applied to this
              //TODO: add dX to this.
              updatedTransformMatrix[5] += -move_dY;
              _parentElement.style.transform =
                'matrix(' + updatedTransformMatrix.toString() + ')';
            }

            if (
              direction < 0
                ? move_dY < 2 * acceptableDistanceY
                : move_dY > 2 * acceptableDistanceY
            ) {
              _handlePullTouchEnd(e);
            }
          }
        }
      }

      function _handlePullTouchEnd(e) {
        var endTouch = Trampoline.util.copyTouchEvent(e.changedTouches[0]),
          dX = startTouch.clientX - endTouch.clientX,
          dY = startTouch.clientY - endTouch.clientY;

        if (startTouch.identifier == endTouch.identifier) {
          // Remove the listeners
          pullElement.removeEventListener(
            'touchmove',
            _handlePullTouchMove,
            false
          );
          pullElement.removeEventListener(
            'touchend',
            _handlePullTouchEnd,
            false
          );
          if (!!_scrollParent) {
            _scrollParent.classList.remove('pulled');
          }

          _parentElement.style.transform = '';
          // The drag has ended and meets acceptable distance in correct direction
          // double check that the scroll is at the top toggle the view, if scrollParent is provided.
          // resolves to: callback || state.change || state.back

          if (Math.abs(dX / dY) < 1) {
            //Vertical Swipe -- check scroll top only on swipe down
            if (
              !!acceptableDistanceY &&
              (direction < 0
                ? dY <= acceptableDistanceY &&
                  !!_scrollParent &&
                  _scrollParent.scrollTop <= 0
                : dY >= acceptableDistanceY)
            ) {
              if (!!options.callback && typeof options.callback == 'function') {
                _log(
                  'Swipe Pull ' + (direction > 0 ? 'Up' : 'Down') + ', Callback'
                );
                options.callback.call();
              } else {
                //No callback function, change state
                _log(
                  'Swipe Pull ' +
                    (direction > 0 ? 'Up' : 'Down') +
                    ', To state: ' +
                    options.state
                );
                !!options.state && options.state !== 'back'
                  ? Trampoline.state.change({ to: options.state })
                  : Trampoline.state.back();
              }
            }
          } else {
            //Horizontal Swipe
            if (
              !!acceptableDistanceX &&
              (direction < 0
                ? dX <= acceptableDistanceX
                : dX >= acceptableDistanceX)
            ) {
              if (!!options.callback && typeof options.callback == 'function') {
                _log(
                  'Swipe Pull ' +
                    (direction > 0 ? 'Right' : 'Left') +
                    ', Callback'
                );
                options.callback.call();
              } else {
                //No callback function, change state
                _log(
                  'Swipe Pull ' +
                    (direction > 0 ? 'Right' : 'Left') +
                    ', To state: ' +
                    options.state
                );
                !!options.state && options.state !== 'back'
                  ? Trampoline.state.change({ to: options.state })
                  : Trampoline.state.back();
              }
            }
          }
        }
      }
    },
    matrixStrToArr = function(matrixStr) {
      var matrixArr = matrixStr
        .replace(/matrix\(|\)| /g, '')
        .split(',')
        .map(Number);
      return matrixArr;
    },
    countLettersNumbers = function(string) {
      var concatStr = string.replace(/[^a-zA-Z0-9.]/g, '');
      return concatStr.length;
    },
    preventDefaultThis = function(e) {
      if (e.target == this) {
        e.preventDefault();
        return false;
      }
    },
    /**
     * Gets the trampoline-generated installation id for this device
     * @return {Promise<String>} A promise that resolves to the installation id
     */
    getInstallationId = function() {
      return getLocalStorage('installation_id');
    };

  // declare the util module if it doesn't exist
  Trampoline.util = Trampoline.util || {};

  // Merge in the new methods that we'd like to attach onto the util module
  Object.assign(Trampoline.util, {
    init: init,
    isConnected: isConnected,
    fetch: fetch,
    getBuildData: getBuildData,
    displayBuildData: displayBuildData,
    setLocalStorage: setLocalStorage,
    getLocalStorage: getLocalStorage,
    resizeITS: resizeITS,
    getShowData: getShowData,
    makeSticky: makeSticky,
    scrollToTop: scrollToTop,
    underscore: underscore,
    isiOS: isiOS,
    isAmazon: isAmazon,
    isAndroid: isAndroid,
    randomInt: randomInt,
    randomArraySelection: randomArraySelection,
    toggleAnimation: toggleAnimation,
    injectSVG: injectSVG,
    tapEvent: tapEvent,
    preventDefaultThis: preventDefaultThis,
    currentTouches: currentTouches,
    copyTouchEvent: copyTouchEvent,
    handleSwipeTouchStart: handleSwipeTouchStart,
    styleSheet: styleSheet,
    addSwipePull: addSwipePull,
    matrixStrToArr: matrixStrToArr,
    getImage: getImage,
    countLettersNumbers: countLettersNumbers,
    getInstallationId: getInstallationId
  });
})(Trampoline || {});

/**
 * Trampoline Parent Gate
 * @memberof Trampoline
 * @namespace gate
 *
 */

(function(Trampoline) {
  Trampoline.gate = (function() {
    var _gateContainer,
      _gateShapeList = [
        { english: 'circle', espanol: 'círculo' },
        { english: 'square', espanol: 'cuadrado' },
        { english: 'triangle', espanol: 'triángulo' }
      ],
      _gateNumberList = [
        { english: 'one', espanol: 'uno', text: '1' },
        { english: 'two', espanol: 'dos', text: '2' },
        { english: 'three', espanol: 'tres', text: '3' },
        { english: 'four', espanol: 'quatro', text: '4' },
        { english: 'five', espanol: 'cinco', text: '5' },
        { english: 'six', espanol: 'seis', text: '6' },
        { english: 'seven', espanol: 'siete', text: '7' },
        { english: 'eight', espanol: 'ocho', text: '8' },
        { english: 'nine', espanol: 'nueve', text: '9' }
      ],
      //EVENTS
      GATE_OPEN = new Event('GATE_OPEN'),
      GATE_CLOSE = new Event('GATE_CLOSE'),
      GATE_PASS = new Event('GATE_PASS'),
      GATE_FAIL = new Event('GATE_FAIL'),
      /**
       * Initializes Parent Gate DOM element
       * @memberof Trampoline.gate
       * @param {Object} options Init options (boolean)
       **/
      init = function(options) {
        // Waiting until Init to grab these Elements, for memory management, ya know.
        _gateContainer = Trampoline.container.querySelector('section.gate');
        _gateContainer
          .querySelector('.gate-ui')
          .addEventListener(
            'touchmove',
            Trampoline.util.preventDefaultThis,
            false
          );

        if (
          (!!options && !!options.remove) ||
          (typeof options === 'boolean' && options === false)
        ) {
          Trampoline.modules.gate.remove = true;
        }

        // pick the initial language based on the trampoline set value
        var gateLanguage = 'english';
        if (Trampoline.languages.get() === 'es') {
          gateLanguage = 'espanol';
        }

        //Setup language switch
        _gateContainer.dataset.language = gateLanguage;
        Trampoline._log('Initiating Parent Gate...');
      },
      /**
       * Toggles the perent gate.
       * @param {Function} callback Required callback when calling the parent gate to open.
       * @memberof Trampoline.gate
       */

      toggleView = function(callback) {
        if (!callback && Trampoline.modules.gate.active) {
          _close();
        } else if (!Trampoline.modules.gate.active) {
          _open(callback);
        } else {
          return;
        }
      },
      _open = function(callback) {
        if (Trampoline.modules.gate.remove) {
          if (typeof callback === 'function') {
            callback();
          }
          return;
        }
        Trampoline.modules.gate.active = true;
        _buildGateUI(_gateShapeList, _gateNumberList, callback);
        _gateContainer.classList.add('active');

        Trampoline.analytics.event('Parent_Gate', 'open');
        Trampoline.events.dispatchEvent(GATE_OPEN);
      },
      _close = function() {
        function _doClose() {
          if (!Trampoline.modules.gate.active) {
            _clearUI();
            _gateContainer.removeEventListener('transitionend', _doClose);
            Trampoline.events.dispatchEvent(GATE_CLOSE);
          }
        }
        //TODO: Remove drop & lameDrop event listeners, they are stacking up

        _gateContainer.addEventListener('transitionend', _doClose);
        Trampoline.modules.gate.active = false;
        _gateContainer.classList.remove('active');
        _gateContainer.scrollTop = 0;
        return false;
      },
      _pass = function(callback) {
        _close();
        Trampoline.analytics.event('Parent_Gate', 'pass');
        Trampoline.events.dispatchEvent(GATE_PASS);
        if (typeof callback === 'function') {
          callback();
        }
      },
      _fail = function(callback) {
        //Shake for UI feedback or Close Gate
        var _gateUI = _gateContainer.querySelector('.gate-ui'),
          _doFail = function() {
            _gateContainer
              .querySelector('.gate-ui')
              .classList.remove('shaking');
            _clearUI();
            _buildGateUI(_gateShapeList, _gateNumberList, callback);
            Trampoline.analytics.event('Parent_Gate', 'fail');
            Trampoline.events.dispatchEvent(GATE_FAIL);
          };

        _gateUI.classList.add('shaking');
        _gateUI.addEventListener('animationend', _doFail);
      },
      /**
       * Build the UI from a list of shapes.
       * @param {Array}    shapeList A list of possible shapes
       * @param {Number} numShapes Int, Number of shapes to display
       */
      _buildGateUI = function(shapeList, numberList, callback) {
        //Setup the stuff:
        var _gateInstructionsEnglish = document.createElement('h1'),
          _gateInstructionsEspanol = document.createElement('h1'),
          _randomShapeList = Trampoline.util.randomArraySelection(shapeList, 3),
          _randomNumberList = Trampoline.util.randomArraySelection(
            numberList,
            3
          ),
          _nextItemList = [],
          _gateUI = _gateContainer.querySelector('.gate-ui'),
          _gateWrapper = _gateContainer.querySelector('.gate-wrapper'),
          _gateItemWrapper = _gateContainer.querySelector('.gate-item-wrapper'),
          _targetShape =
            _randomShapeList[
              Trampoline.util.randomInt(0, _randomShapeList.length - 1)
            ],
          _targetNumber =
            _randomNumberList[
              Trampoline.util.randomInt(0, _randomNumberList.length - 1)
            ],
          _addGateItem = function(gateItem) {
            //TODO: add random offset
            var _gateElement = document.createElement('div');
            _gateElement.classList.add('gate-item');
            _gateElement.dataset.name = gateItem.english;
            _gateElement.setAttribute('draggable', true);
            _gateElement.innerHTML = gateItem.hasOwnProperty('text')
              ? gateItem.text
              : '';
            _gateItemWrapper.appendChild(_gateElement);
            //Add drag to everything
            _gateElement.addEventListener('dragstart', _handleDragStart, false);
            _gateElement.addEventListener('dragleave', _handleDragLeave, false);
            _gateElement.addEventListener('dragend', _handleDragEnd, false);
            _gateElement.addEventListener(
              'touchcancel',
              _lameDropCallback,
              false
            );

            //Add drop to everything
            _gateElement.addEventListener('drop', _dropCallback, false);
            _gateElement.addEventListener('dragenter', _handleDragEnter, false);
            _gateElement.addEventListener('dragover', _handleDragOver, false);
            _gateElement.addEventListener('dragleave', _handleDragLeave, false);
          },
          _setTarget = function(gateTarget, gateKey) {
            var _gateTarget = _gateItemWrapper.querySelector(
              'div[data-name="' + gateTarget + '"]'
            );
            _gateTarget.classList.add('gate-target');
            _gateTarget.dataset.key = gateKey;
          },
          _dropCallback = function(e) {
            _handleDrop(e, callback);
          },
          _lameDropCallback = function(e) {
            _handleLameDrop(e, callback);
          };

        //Re-Setup Close (listeners are wiped away on clearUI)
        _gateContainer
          .querySelector('button.close')
          .addEventListener(Trampoline.util.tapEvent, function(e) {
            e.preventDefault();
            _close(e);
          });
        _gateWrapper.addEventListener(Trampoline.util.tapEvent, function(e) {
          //e.preventDefault();
          _handleOutsideClose(e);
        });
        _gateWrapper.addEventListener(
          'touchmove',
          function(e) {
            e.preventDefault();
            _handleOutsideClose(e);
          },
          false
        );

        //Alternate shapes and numbers and add them randomly from each list.
        for (var i = 0; i < 6; i++) {
          var _nextItemList =
              i % 2
                ? _randomShapeList.length
                  ? _randomShapeList
                  : _randomNumberList
                : _randomNumberList.length
                  ? _randomNumberList
                  : _randomShapeList,
            _randomItemIndex = Trampoline.util.randomInt(
              0,
              _nextItemList.length - 1
            ),
            _nextItem = _nextItemList[_randomItemIndex];

          _addGateItem(_nextItem);

          if (_nextItem == _targetShape) {
            _setTarget(_nextItem.english, _targetNumber.english);
          }
          //Removes item from respective list (shape or number). _nextItemList is just a reference.
          _nextItemList.splice(_randomItemIndex, 1);
        }

        _gateContainer
          .querySelector('.gate-wrapper:not(.gate-target)')
          .addEventListener('dragover', _handleDragOver, false);
        _gateContainer
          .querySelector('.gate-wrapper:not(.gate-target)')
          .addEventListener('drop', _lameDropCallback, false);

        //Add the instructions in English
        _gateInstructionsEnglish.innerHTML =
          'Drag the number <strong>' +
          _targetNumber.english +
          '</strong> to the <strong>' +
          _targetShape.english +
          '</strong>';
        _gateInstructionsEnglish.classList.add('gate-instructions', 'english');
        _gateUI.appendChild(_gateInstructionsEnglish);

        //Add the instructions en Español
        _gateInstructionsEspanol.innerHTML =
          'Arrastre el número <strong>' +
          _targetNumber.espanol +
          '</strong> en la forma de <strong>' +
          _targetShape.espanol +
          '</strong>';
        _gateInstructionsEspanol.classList.add('gate-instructions', 'espanol');
        _gateUI.appendChild(_gateInstructionsEspanol);

        // wire up the language toggle
        _gateContainer
          .querySelector('.language-switch')
          .addEventListener(Trampoline.util.tapEvent, function(e) {
            e.preventDefault();
            toggleLanguage();
          });
      },
      /**
       * Clears out the entire Gate Wrapper, replaces it with a clone that has no listeners.
       * @private
       */
      _clearUI = function() {
        var _gateUI = _gateContainer.querySelector('.gate-ui'),
          _gateWrapper = _gateContainer.querySelector('.gate-wrapper'),
          _gateWrapperClone,
          _gateInstructionsEnglish = _gateContainer.querySelector(
            '.gate-instructions.english'
          ),
          _gateInstructionsEspanol = _gateContainer.querySelector(
            '.gate-instructions.espanol'
          );

        _gateContainer.querySelector('.gate-item-wrapper').innerHTML = '';
        _gateUI.removeChild(_gateInstructionsEnglish);
        _gateUI.removeChild(_gateInstructionsEspanol);

        //replace the wrapper with clone to remove all lingering listeners
        _gateWrapperClone = _gateWrapper.cloneNode(true);
        _gateWrapper.parentNode.replaceChild(_gateWrapperClone, _gateWrapper);
      },
      _handleDragStart = function(e) {
        var _isDragging = _gateContainer.querySelector('.dragging');
        if (!_isDragging) {
          e.target.classList.add('dragging');
          //Listener does not need to be removed; e.target will be deleted.
          //e.dataTransfer.setDragImage(dragIcon, -10, -10);
          e.dataTransfer.effectAllowed = 'copy';
          e.dataTransfer.setData('text/plain', e.target.dataset.name);
        } else {
          return false;
        }
      },
      _handleDragEnter = function(e) {
        var DraggedShape = e.target;
        DraggedShape.classList.add('over');
      },
      _handleDragOver = function(e) {
        e.preventDefault();
      },
      _handleLameDrop = function(e, callback) {
        if (!e.dataTransfer) {
          return;
        }

        var droppedShape = e.dataTransfer.getData('text/plain');

        if (!e.target.dataset.target == droppedShape) {
          _fail(callback);
        }
      },
      _handleDragLeave = function() {
        this.classList.remove('over');
      },
      _handleDragEnd = function() {
        this.classList.remove('dragging');
      },
      _handleDrop = function(e, callback) {
        //element dropped
        e.preventDefault();

        var droppedShape = e.dataTransfer.getData('text/plain'),
          droppedNode = _gateContainer.querySelector(
            'div[data-name="' + droppedShape + '"]'
          );

        droppedNode.classList.add('dropped');

        if (e.target.dataset.key == droppedShape) {
          e.target.classList.add('dropped');
          _pass(callback);
        } else {
          e.target.classList.remove('over');
          _fail(callback);
        }
      },
      _handleOutsideClose = function(e) {
        if (e.target != _gateContainer.querySelector('.gate-wrapper')) {
          return;
        }
        _close();
      },
      toggleLanguage = function() {
        if (_gateContainer.dataset.language != 'english') {
          _gateContainer.dataset.language = Trampoline.modules.gate.language =
            'english';
        } else {
          _gateContainer.dataset.language = Trampoline.modules.gate.language =
            'espanol';
        }
      };

    return {
      init: init,
      toggleLanguage: toggleLanguage,
      toggleView: toggleView,
      close: _close
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Trampoline More Apps
 * @memberof Trampoline
 * @namespace moreApps
 *
 */

(function(Trampoline) {
  Trampoline.moreApps = (function() {
    //Inherintly private (_) methods
    var ready = false,
      feature = {},
      largeFeatures = [],
      _log = Trampoline._log,
      _didInit,
      _didBuild,
      _moreAppsContainer,
      _moreAppsWrapper,
      _moreAppsContentContainer,
      _panelActive,
      _headless = false,
      _removeMoreApps = false,
      _scrollParent,
      tapEvent = Trampoline.util.tapEvent,
      //_moreAppsDataEndpoint = 'https://api.pbskids.org/trampoline/moreapps/',
      //New Endpoint for Tortuga, must resolve to Default / App-Slug
      _moreAppsDataEndpoint = 'https://pbskids.org/api/trampoline/v2/moreapps/',
      //EVENTS
      MOREAPPS_READY = new Event('MOREAPPS_READY'),
      MOREAPPS_BUTTON_READY = new Event('MOREAPPS_BUTTON_READY'),
      MOREAPPS_FEATURE_READY = new Event('MOREAPPS_FEATURE_READY'),
      MOREAPPS_LARGE_FEATURES_READY = new Event(
        'MOREAPPS_LARGE_FEATURES_READY'
      ),
      MOREAPPS_OPEN = new Event('MOREAPPS_OPEN'),
      MOREAPPS_CLOSE = new Event('MOREAPPS_CLOSE'),
      /**
       * Initializes the More App section by connecting to trampoline/moreapps/{{deviceOS}} endpoint and
       * building out the more apps DOM element.
       * @memberof Trampoline.moreApps
       * @param {Object} options moreApps init option (headless mode)
       */
      init = function(options) {
        _moreAppsContainer = Trampoline.container.querySelector(
          'section.more-apps'
        );
        _moreAppsWrapper = _moreAppsContainer.querySelector(
          '.more-apps-wrapper'
        );
        _moreAppsContentContainer = _moreAppsContainer.querySelector(
          '.more-apps-wrapper .content'
        );
        _scrollParent = _moreAppsContainer.querySelector(
          '.more-apps-wrapper .content-wrapper'
        );

        _moreAppsContainer.addEventListener(
          'touchmove',
          function(e) {
            if (_moreAppsWrapper.scrollTop < 0) {
              _moreAppsWrapper.scrollY = 0;
            }
          },
          false
        );

        if (!!options) {
          if (!!options.headless) {
            _headless = true;
          }

          if (!!options.remove) {
            _removeMoreApps = true;
          }
        }

        Trampoline.util.addSwipePull(_moreAppsContainer, {
          dY: -0.1,
          state: 'back',
          scrollParent: _scrollParent
        });

        _didInit = true;
      },
      /**
       * Exposes the resources needed for startup to the module loader
       * @memberof Trampoline.moreApps
       * @public
       * @returns {Array} List of resources
       */
      listResources = function() {
        return [_getMoreAppsUri(Trampoline.GUID)];
      },
      /**
       * Builds out the section after init. Run by the module loader in core.js.
       * @param {Object} resources Config options
       */
      startup = function(resources) {
        if (_removeMoreApps) {
          return;
        }
        var moreappsResource = resources[_getMoreAppsUri(Trampoline.GUID)];

        if (moreappsResource) {
          _log('Received More Apps Data through GUID');
          _buildMoreApps(moreappsResource);
        } else if (!!Trampoline.GUID) {
          _log('More Apps Data Failed for App GUID, fetching default data...');
          var moreAppsUri = _getMoreAppsUri(Trampoline.GUID);
          Trampoline.util
            .fetch(moreAppsUri)
            .then(_buildMoreApps)
            .catch(_log);
        } else {
          _log('More Apps Data Failed');
        }
      },
      /**
       * Refreshes More Apps panel and exposed objects based on init / startup success.
       * @param {Object} options The same options from startup, just because
       */
      refresh = function(options) {
        if (!_didInit) {
          Trampoline.moreApps.init(options);
          _moreAppsRestart(options);
        } else if (!_didBuild) {
          _log('moreApps.init already completed, build failed, rebuilding');
          _moreAppsRestart(options);
        } else {
          _log('moreApps already built, refreshing data');
          var moreAppsUri = _getMoreAppsUri(Trampoline.GUID);

          _log('Getting more apps data...');
          Trampoline.util
            .fetch(moreAppsUri)
            .then(_refreshMoreAppsData)
            .catch(_log);
        }
      },
      /**
       * Builds a mini loader to run startup outside of Trampoline.init
       * @memberof Trampoline.moreApps
       * @private
       * @param {Object} options The same options from startup
       */
      _moreAppsRestart = function(options) {
        var moreAppsRefreshLoader = new Trampoline.util.ResourceLoader();

        if (_didInit && Trampoline.moreApps.listResources) {
          moreAppsRefreshLoader.add(Trampoline.moreApps.listResources());
        }

        moreAppsRefreshLoader.load().then(function() {
          Trampoline.moreApps.startup(moreAppsRefreshLoader.resources);
        });
      },
      /**
       * Refreshes moreapps data only
       * @memberof Trampoline.moreApps
       * @private
       * @param {Object} moreAppsData The data from Tortuga
       */
      _refreshMoreAppsData = function(moreAppsData) {
        _log('Refreshing More Apps data only...');
        var moreAppsDataObj = JSON.parse(moreAppsData);

        _styleMoreApps(moreAppsDataObj.settings);

        //Build the MoreApps Button if needed, inject when ready
        _log(
          'HAS MORE APPS' +
            !Trampoline.container.classList.contains('has-more-apps')
        );
        if (!Trampoline.container.classList.contains('has-more-apps')) {
          if (!_headless && moreAppsDataObj.settings) {
            Trampoline.events.addEventListener(
              'MOREAPPS_BUTTON_READY',
              _addMoreAppsButton
            );
            _buildMoreAppsButton(moreAppsDataObj.settings);
          }
        }

        !!moreAppsDataObj.featurePanel
          ? _exposeFeatureData(moreAppsDataObj.featurePanel)
          : _log('No feature data to expose');
      },
      /**
       * Returns the proper More Apps API URI for the device with links to that App Store
       * @memberof Trampoline.moreApps
       * @private
       * @param   {String} endpointSlug The GUID of the app.
       * @returns {String} The More Apps endpoint
       */
      _getMoreAppsUri = function(endpointSlug) {
        var moreappsURI = !!endpointSlug
          ? _moreAppsDataEndpoint + endpointSlug + '/'
          : _moreAppsDataEndpoint + 'default/';

        if (Trampoline.util.isiOS.call()) {
          moreappsURI += 'ios';
        } else if (Trampoline.util.isAmazon.call()) {
          moreappsURI += 'amazon';
        } else {
          moreappsURI += 'android';
        }
        return moreappsURI;
      },
      /**
       * Populates more apps panel with newest available data from json
       * @memberof Trampoline.moreApps
       * @private
       * @param   {String}  moreAppsData JSON String returned from endpoint
       */
      _buildMoreApps = function(moreAppsData) {
        _log('Building More Apps...');
        var moreAppsDataObj = JSON.parse(moreAppsData),
          moreAppsObj = moreAppsDataObj.moreApps,
          largeFeatureArray = [];

        _styleMoreApps(moreAppsDataObj.settings);

        //Build the MoreApps Button, inject when ready
        if (!_headless && moreAppsDataObj.settings) {
          Trampoline.events.addEventListener(
            'MOREAPPS_BUTTON_READY',
            _addMoreAppsButton
          );
          _buildMoreAppsButton(moreAppsDataObj.settings);
        }

        //TODO: Is this the right place to expose the feature data?
        !!moreAppsDataObj.featurePanel
          ? _exposeFeatureData(moreAppsDataObj.featurePanel)
          : _log('No feature data to expose');

        /**
         * TODO: Create some sort of object for reference so that after two panels are built, wait for all the images to load and then show the more-apps button.
         *
         * TODO: Create a function here that makes an image object, downloads the images and returns a callback.
         *
         * TODO: Have each panel animate in when all of its images have loaded
         */

        //Build out the MoreApps Section Panels
        for (var count = 0; count < moreAppsObj.blocks.length; count++) {
          var panelData = moreAppsObj.blocks[count],
            moreAppsPanel = document.createElement('div');

          switch (panelData.type) {
            case 'feature_large':
              var featureData = panelData;
              var panelHeading,
                panelImage,
                featureButton,
                featureObject = {
                  featureGraphic: featureData.featureGraphic,
                  storeUrl: featureData.apps.storeUrl,
                  buttonText: featureData.buttonText,
                  buttonColor: featureData.buttonColor,
                  type: featureData.type,
                  appIcon: featureData.apps.appIcon,
                  appIcon2x: featureData.apps.appIcon2x,
                  title: featureData.apps.title,
                  badge: featureData.apps.badge
                };

              largeFeatureArray.push(featureObject);

              //Classes
              moreAppsPanel.classList.add('feature');
              featureButton = _buildFeatureButton(featureObject, moreAppsPanel);

              //Heading
              panelHeading = document.createElement('h2');
              panelHeading.setAttribute(
                'backgroundColor',
                featureData.buttonColor
              );
              panelHeading.innerHTML = featureData.buttonText;
              moreAppsPanel.appendChild(panelHeading);

              break;

            case 'split_feature':
              featureData = panelData;
              var panelLeftHeading,
                panelLeftImage,
                panelLeftFeature,
                panelRightHeading,
                panelRightImage,
                panelRightFeature;

              moreAppsPanel.classList.add('split-feature');

              //Left Feature
              panelLeftFeature = document.createElement('a');
              panelLeftFeature.addEventListener('click', function(e) {
                //TODO: Add some UI animation to this.
                //Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
                Trampoline.gate.toggleView(function() {
                  window.open(featureData.apps[0].storeUrl, '_system');
                });
                Trampoline.analytics.event(
                  'Selected_in_' + featureData.type,
                  Trampoline.util.underscore(featureData.apps[0].title),
                  'MoreApps'
                );
              });
              Trampoline.util
                .getImage(featureData.apps[0].featureGraphic)
                .then(function(panelLeftImage) {
                  panelLeftFeature.appendChild(panelLeftImage);
                })
                .catch(function(error) {
                  _log(
                    'Panel left image ' +
                      featureData.apps[0].featureGraphic +
                      ' failed to load'
                  );
                  _log(error);
                });
              moreAppsPanel.appendChild(panelLeftFeature);

              //Right Feature
              panelRightFeature = document.createElement('a');
              panelRightFeature.addEventListener('click', function(e) {
                Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
                Trampoline.gate.toggleView(function() {
                  window.open(
                    featureData.featureData.apps[1].storeUrl,
                    '_system'
                  );
                });
                Trampoline.analytics.event(
                  'Selected_in_' + featureData.type,
                  Trampoline.util.underscore(featureData.apps[1].title),
                  'MoreApps'
                );
              });
              Trampoline.util
                .getImage(featureData.apps[1].featureGraphic)
                .then(function(panelRightImage) {
                  panelRightFeature.appendChild(panelRightImage);
                })
                .catch(function(error) {
                  _log(
                    'Panel right image ' +
                      featureData.apps[1].featureGraphic +
                      ' failed to load'
                  );
                  _log(error);
                });
              moreAppsPanel.appendChild(panelRightFeature);
              break;

            case 'panel_single_row':
              var panelHeading, panelDescription, panelApps;
              //Classes
              moreAppsPanel.classList.add('panel', 'carousel', 'pref-single');
              //Headings
              panelHeading = document.createElement('h2');
              panelHeading.innerHTML = panelData.headerText;
              moreAppsPanel.appendChild(panelHeading);

              panelDescription = document.createElement('h3');
              panelDescription.innerHTML = panelData.description;
              moreAppsPanel.appendChild(panelDescription);

              panelApps = document.createElement('ul');
              for (var i = 0; i < panelData.apps.length; i++) {
                var _newApp = _buildAppIcon(
                  panelData.apps[i],
                  panelData.headerText,
                  panelData.type
                );
                panelApps.appendChild(_newApp);
                //TODO: Keep Track of App Image Download Progress?
              }

              moreAppsPanel.appendChild(panelApps);
              break;

            case 'panel_prefer_two_rows':
              var panelHeading, panelDescription, panelApps;
              //Classes
              moreAppsPanel.classList.add('panel', 'carousel', 'pref-double');
              //Headings
              panelHeading = document.createElement('h2');
              panelHeading.innerHTML = panelData.headerText;
              moreAppsPanel.appendChild(panelHeading);

              panelDescription = document.createElement('h3');
              panelDescription.innerHTML = panelData.description;
              moreAppsPanel.appendChild(panelDescription);

              panelApps = document.createElement('ul');
              for (var i = 0; i < panelData.apps.length; i++) {
                var _newApp = _buildAppIcon(
                  panelData.apps[i],
                  panelData.headerText,
                  panelData.type
                );
                panelApps.appendChild(_newApp);
                //TODO: Keep Track of App Image Download Progress?
              }

              moreAppsPanel.appendChild(panelApps);
              break;

            case 'panel_large_icons':
              var panelHeading, panelDescription, panelApps;
              //Classes
              moreAppsPanel.classList.add('panel', 'list', 'large');
              //Headings
              panelHeading = document.createElement('h2');
              panelHeading.innerHTML = panelData.headerText;
              moreAppsPanel.appendChild(panelHeading);

              panelDescription = document.createElement('h3');
              panelDescription.innerHTML = panelData.description;
              moreAppsPanel.appendChild(panelDescription);

              panelApps = document.createElement('ul');
              for (var i = 0; i < panelData.apps.length; i++) {
                var _newApp = _buildAppIcon(
                  panelData.apps[i],
                  panelData.headerText,
                  panelData.type
                );
                panelApps.appendChild(_newApp);
                //TODO: Keep Track of App Image Download Progress?
              }

              moreAppsPanel.appendChild(panelApps);
              break;
            default:
              _log('More Apps panel Type not supported');
          }

          _moreAppsContentContainer.appendChild(moreAppsPanel);
        }

        if (largeFeatureArray.length > 0) {
          _exposeLargeFeaturesData(largeFeatureArray);
        }

        _didBuild = true;
        Trampoline.events.dispatchEvent(MOREAPPS_READY);
      },
      /**
       * Builds the more Apps button for the nav (little guy)
       * @memberof Trampoline.moreApps
       * @private
       * @param {object} settingsObj The settings obj from the more apps data
       */
      _buildMoreAppsButton = function(settingsObj) {
        _log('getting moreapps button');

        var moreAppsButtonSrc =
          window.devicePixelRatio >= 2
            ? settingsObj.trampolineIcon2x
            : settingsObj.trampolineIcon;

        Trampoline.util
          .getImage(moreAppsButtonSrc)
          .then(function(moreAppsButtonImage) {
            var moreAppsButton = document.createElement('button'),
              moreAppsButtonIcon = document.createElement('div');

            moreAppsButton.classList.add('more-apps');
            moreAppsButton.appendChild(moreAppsButtonIcon);
            moreAppsButtonIcon.classList.add('icon');
            moreAppsButtonIcon.appendChild(moreAppsButtonImage);

            // create the more apps button text, and keep the button up-to-date when language changes
            var moreAppsButtonText = document.createElement('h2');
            moreAppsButtonText.dataset.languageKey = 'moreapps';
            moreAppsButtonIcon.appendChild(moreAppsButtonText);

            if (settingsObj.trampolineBadge) {
              Trampoline.util
                .getImage(settingsObj.trampolineBadge)
                .then(function(moreAppsButtonBadge) {
                  moreAppsButtonBadge.classList.add('badge');
                  moreAppsButton.appendChild(moreAppsButtonBadge);
                });
            }

            Trampoline.container
              .querySelector('.main')
              .appendChild(moreAppsButton);
            Trampoline.events.dispatchEvent(MOREAPPS_BUTTON_READY);
          })
          .catch(function(error) {
            _log('Failed to load more apps button ' + moreAppsButtonSrc);
            _log(error);
          });
      },
      /**
       * Adds the more-apps button to the main nav bar
       * @memberof Trampoline.moreApps
       * @private
       */
      _addMoreAppsButton = function() {
        Trampoline._log('Adding More Apps Button...');
        var moreAppsButton = Trampoline.container.querySelector(
          'button.more-apps'
        );
        Trampoline.container.classList.add('has-more-apps');
        Trampoline.util.toggleAnimation(moreAppsButton, 'bounceInDown');
        moreAppsButton.style.opacity = 1;
        moreAppsButton.addEventListener(Trampoline.util.tapEvent, function(e) {
          e.preventDefault();
          Trampoline.util.toggleAnimation(moreAppsButton, 'tapped', 'tap-exit');
          Trampoline.state.change({ to: 'moreApps', from: 'init' });
        });
      },
      /**
       * Builds an app icon with title
       * @memberof Trampoline.moreApps
       * @private
       * @param   {object} appObject     The app obj from moreapps data
       * @param   {String} appPanelTitle The app title of the panel (for analytics on the link)
       * @param   {String} appPanelType  The panel type (for analytics on the link)
       * @returns {Object} A div container element that can be injected into a panel / carousel
       */
      _buildAppIcon = function(appObject, appPanelTitle, appPanelType) {
        var appContainer = document.createElement('li'),
          appIcon = document.createElement('div'),
          appBadge,
          appName = document.createElement('h4'),
          appLabel = Trampoline.util.underscore(appObject.title),
          appPanelTitle = Trampoline.util.underscore(appPanelTitle);

        appIcon.classList.add('icon');
        //TODO: Use fetch to get images?

        appIcon.style.backgroundImage =
          window.devicePixelRatio >= 2
            ? 'url(' + appObject.appIcon2x + ')'
            : 'url(' + appObject.appIcon + ')';

        //Badge the icon if it has one
        if (!!appObject.badge) {
          appBadge = document.createElement('div');
          appBadge.classList.add('badge');
          appBadge.style.backgroundImage = 'url(' + appObject.badge + ')';
          appIcon.appendChild(appBadge);
        }
        appContainer.appendChild(appIcon);

        //Parse name because it has \n for breaks
        appName.innerHTML = appObject.title.replace(/\r?\n|\r/g, ' ');
        appContainer.appendChild(appName);

        appContainer.addEventListener(
          'click',
          function(e) {
            //TODO: Update this to get badge.name from new json model (specifically GA)
            Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
            if (appObject.badge) {
              var re = /[^/]+(?=\..{3,4}$)/g;
              appLabel += '_' + re.exec(appObject.badge);
            }
            Trampoline.analytics.event(
              'Selected_in_' + appPanelTitle + '_' + appPanelType,
              appLabel,
              'MoreApps'
            );
            Trampoline.gate.toggleView(function() {
              window.open(appObject.storeUrl, '_system');
            });
          },
          false
        );

        return appContainer;
      },
      _buildFeatureButton = function(featureObject, parentPanel) {
        //Image
        var featureUrl = featureObject.storeUrl,
          featureText = featureObject.buttonText,
          panelType = featureObject.type,
          featureButton = document.createElement('img');

        featureButton.setAttribute('src', featureObject.featureGraphic);
        parentPanel.appendChild(featureButton);

        //Click
        parentPanel.addEventListener('click', function(e) {
          //TODO: Add some UI animation to this.
          //Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
          Trampoline.analytics.event(
            'Selected_in_' + panelType,
            Trampoline.util.underscore(featureText),
            'MoreApps'
          );
          Trampoline.gate.toggleView(function() {
            window.open(featureUrl, '_system');
          });
        });

        return featureButton;
      },
      /**
       * Expose the feature Data (i.e. for grownups panels in gamesapp)
       * @memberof Trampoline.moreApps
       * @private
       * @param {Obj} featureData The moreapps feature data
       */
      _exposeFeatureData = function(featureData) {
        //Expose the feature data
        if (featureData) {
          Trampoline.moreApps.feature = featureData;
          Trampoline.moreApps.ready = true;
          Trampoline.events.dispatchEvent(MOREAPPS_FEATURE_READY);
        }
      },
      _exposeLargeFeaturesData = function(largeFeatures) {
        Trampoline.moreApps.largeFeatures = largeFeatures;
        Trampoline.events.dispatchEvent(MOREAPPS_LARGE_FEATURES_READY);
      },
      /**
       * Injects new styles for the content of the moreApps panel
       * @memberof Trampoline.moreApps
       * @private
       * @param {object} settingsObj The settings obj from the More Apps Data
       */
      _styleMoreApps = function(settingsObj) {
        //More Apps Styling from JSON Data
        if (settingsObj.hasOwnProperty('headerColor')) {
          Trampoline.util.styleSheet.insertRule(
            '#trampoline section.more-apps nav{ background-color: ' +
              settingsObj.headerColor +
              ' !important; }',
            1
          );
        }
        if (settingsObj.panelTitleColor) {
          Trampoline.util.styleSheet.insertRule(
            '#trampoline section.more-apps .content-wrapper .content .panel h2 { color: ' +
              settingsObj.panelTitleColor +
              ' !important; }',
            1
          );
        }
        if (settingsObj.backgroundColor) {
          Trampoline.util.styleSheet.insertRule(
            '#trampoline section.more-apps .more-apps-wrapper{ background-color: ' +
              settingsObj.backgroundColor +
              ' !important; }',
            1
          );
          Trampoline.util.styleSheet.insertRule(
            '#trampoline section.more-apps.active{ background: linear-gradient(to bottom, transparent, transparent 80px, ' +
              settingsObj.backgroundColor +
              ' 81px, ' +
              settingsObj.backgroundColor +
              ') !important; }',
            1
          );
          Trampoline.util.styleSheet.insertRule(
            '#trampoline section.more-apps.active{ background: -webkit-linear-gradient(to bottom, transparent, transparent 80px, ' +
              settingsObj.backgroundColor +
              ' 81px, ' +
              settingsObj.backgroundColor +
              ') !important; }',
            1
          );
        }
      },
      /**
       * Shows the More Apps Panel
       * @memberof Trampoline.moreApps
       * @param {Function} callback Fires callback when shown
       */
      _open = function(callback) {
        _moreAppsContainer.classList.add('active');
        Trampoline.analytics.event('MoreApps', 'open');
        Trampoline.events.dispatchEvent(MOREAPPS_OPEN);
        Trampoline.container
          .querySelector('.more-apps nav button.close')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
            Trampoline.state.back();
          });
        _panelActive = true;
        if (typeof callback === 'function') {
          callback();
        }
      },
      /**
       * Hide MoreApps view
       * @private
       * @memberof Trampoline.moreApps
       * @param {Function} callback callback
       */
      _close = function(callback) {
        var _scrollContainer = _moreAppsContainer.querySelector(
            '.more-apps-wrapper'
          ),
          _moreAppsScrollTop = _scrollContainer.scrollTop,
          _removeActiveClass = function() {
            _moreAppsContainer.classList.remove('active');
            Trampoline.events.dispatchEvent(MOREAPPS_CLOSE);
            if (typeof callback === 'function') {
              callback();
            }
            _panelActive = false;
          };
        if (_moreAppsScrollTop <= 0) {
          _log('Not scrolling node to top, just removing active');
          _removeActiveClass();
        } else {
          // Dude, I made the scroll time relevant to the scroll distance if < window height (it's capped at 0.15s). How cool is that?
          // More obvious in portrait mode.
          var _scrollTime = 150,
            _containerHeight = _scrollContainer.offsetHeight;
          if (_moreAppsScrollTop <= _containerHeight) {
            _scrollTime = _scrollTime * (_moreAppsScrollTop / _containerHeight);
          }
          setTimeout(_removeActiveClass, _scrollTime);
          Trampoline.util.scrollToTop(_moreAppsContainer, _scrollTime);
        }
      },
      /**
       * Toggle More Apps View
       * @memberof Trampoline.moreApps
       * @param {function} callback Provides callback method.
       */
      toggleView = function(callback) {
        if (!callback) {
          callback = null;
        }
        if (!!_panelActive) {
          _close(callback);
        } else {
          _open(callback);
        }
      };

    return {
      /**
       * More Apps has connected to endpoint and bugun building
       * @memberof Trampoline.moreApps
       */
      ready: ready,
      toggleView: toggleView,
      listResources: listResources,
      startup: startup,
      init: init,
      refresh: refresh,
      feature: feature,
      largeFeatures: largeFeatures
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Parents View Module for Trampoline
 * @memberof Trampolone
 * @namespace parents
 *
 * @event PARENTS_OPEN
 * @event PARENTS_CLOSE
 */
(function(Trampoline) {
  Trampoline.parents = (function() {
    var _parentsContainer,
      _parentsContentContainer,
      _panelActive,
      _scrollParent,
      _log = Trampoline._log,
      _config = null,
      tapEvent = Trampoline.util.tapEvent,
      //Events
      PARENTS_CLOSE = new Event('PARENTS_CLOSE'),
      PARENTS_OPEN = new Event('PARENTS_OPEN'),
      //PARENTS_READY  = new Event('PARENTS_READY'),

      // Default Template Panels
      _defaultPanels = [],
      /**
       * Initialize Parents Section
       * Adds event triggers to the Parents Container
       * @memberof Trampoline.parents
       */
      init = function(config) {
        _config = config;
        _log('Initiating Parents Section...');
        _parentsContainer = Trampoline.container.querySelector(
          'section.parents'
        );
        _parentsContentContainer = Trampoline.container.querySelector(
          '.parents-wrapper .content'
        );
        _scrollParent = _parentsContainer.querySelector(
          '.parents-wrapper .content-wrapper'
        );

        Trampoline.util.makeSticky(
          _parentsContainer.querySelector('nav'),
          _parentsContainer.querySelector('.parents-wrapper')
        );

        _addParentsSection();

        _parentsContainer.addEventListener(
          'touchmove',
          Trampoline.util.preventDefaultThis
        );

        if (!!Trampoline.modules.parents.grownupsTab) {
          _addGrownupsTab();
        }

        //Connect swipe down to close
        Trampoline.util.addSwipePull(_parentsContentContainer, {
          dY: '-0.10',
          state: 'back',
          scrollParent: _scrollParent,
          parentElement: _parentsContainer
        });

        Trampoline.modules.parents.init = true;
      },
      /**
       * Returns template source files of custom and default panels (if configured true)
       * @returns {Object}
       */
      listResources = function() {
        return Trampoline.templating.listResourcesForConfig(
          _config,
          _defaultPanels
        );
      },
      /**
       * Startup runs after init. Modules are run in a specif order through Trampoline core init.
       * @memberof Trampoline.parents
       * @param {Obj} resources The resource list.
       */
      startup = function(resources) {
        if (!!Trampoline.modules.parents.build) {
          return;
        }
        Trampoline.modules.parents.build = true;
        // build the DOM elements from the templates now we have the loaded template files.
        var elements = Trampoline.templating.buildTemplates(
          _config,
          _defaultPanels,
          resources
        );

        // add document fragments to container.
        for (var i = 0; i < elements.length; i++) {
          _parentsContentContainer.appendChild(elements[i]);
        }
      },
      refresh = function(options) {
        if (!Trampoline.modules.parents.init) {
          init(options);
        }
        if (options.customPanels && options.customPanels.length > 0) {
          for (var i = 0; i < options.customPanels.length; i++) {
            if (options.customPanels[i].hasOwnProperty('refresh')) {
              options.customPanels[i].refresh();
            }
          }
        }
      },
      /**
       * Toggles Parent Bar DOM view with animation
       * @memberof Trampoline.parents
       */
      toggleView = function() {
        if (!!_panelActive) {
          _close();
        } else {
          _open();
        }
      },
      _open = function() {
        _panelActive = true;
        _parentsContainer.classList.add('active');
        if (!Trampoline.util.isConnected) {
          _parentsContainer.classList.add('offline');
        } else if (_parentsContainer.classList.contains('offline')) {
          _parentsContainer.classList.remove('offline');
        }
        Trampoline.analytics.event('Parents', 'open');
        Trampoline.events.dispatchEvent(PARENTS_OPEN);
      },
      _close = function() {
        _panelActive = false;
        _parentsContainer.classList.remove('active');
        Trampoline.events.dispatchEvent(PARENTS_CLOSE);
      },
      _addParentsSection = function() {
        Trampoline.container.classList.add('has-parents');
        Trampoline.container
          .querySelector('.parents nav .close')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
            Trampoline.state.back();
          });
      },
      _addGrownupsTab = function() {
        var grownupsTabTextContainer = document.createElement('h1');
        grownupsTabTextContainer.dataset.languageKey = 'grownups';

        var grownupsTabMarkup = document.createElement('div');
        grownupsTabMarkup.classList.add('parents-pull-tab', 'hidden');
        grownupsTabMarkup.appendChild(grownupsTabTextContainer);

        _parentsContainer.insertBefore(
          grownupsTabMarkup,
          _parentsContainer.querySelector('.parents-wrapper')
        );

        Trampoline.util.addSwipePull(grownupsTabMarkup, {
          dY: '0.20',
          state: 'parents',
          parentElement: _parentsContainer
        });

        //TODO: remove this event when not in view.
        grownupsTabMarkup.addEventListener(Trampoline.util.tapEvent, function(
          e
        ) {
          var moreAppsActive = Trampoline.container.querySelector(
            'section.parents'
          )
            ? !Trampoline.container
                .querySelector('section.parents')
                .classList.contains('active')
            : false;
          if (moreAppsActive) {
            Trampoline.state.change({ to: 'parents' });
          }
        });
      },
      connectionLost = function() {
        if (_panelActive && !Trampoline.util.isConnected) {
          _parentsContainer.classList.add('offline');
        }
      },
      connectionResume = function() {
        if (_parentsContainer.classList.contains('offline')) {
          _parentsContainer.classList.remove('offline');
        }
      },
      /**
       * Removes Parents Area from DOM
       */
      remove = function() {
        if (!_parentsContainer) {
          _parentsContainer = document
            .getElementById('trampoline')
            .querySelector('section.parents');
        }
        _parentsContainer.parentElement.removeChild(_parentsContainer);
      };

    return {
      init: init,
      startup: startup,
      refresh: refresh,
      listResources: listResources,
      toggleView: toggleView,
      connectionResume: connectionResume,
      connectionLost: connectionLost,
      remove: remove
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Popups View Module for Trampoline
 * @memberof Trampolone
 * @namespace parents
 *
 * @event POPUPS_OPEN
 * @event POPUPS_CLOSE
 */
(function(Trampoline) {
  Trampoline.popups = (function() {
    var _popupsContainer,
      _popupsContentContainer,
      _popupsById = {},
      _currentPopupId,
      _currentPoupupElement,
      _defaultPopupId,
      _panelActive,
      _log = Trampoline._log,
      _config = null,
      //Events
      POPUPS_CLOSE = new Event('POPUPS_CLOSE'),
      POPUPS_OPEN = new Event('POPUPS_OPEN'),
      // Default Template Panels
      _defaultPanels = [],
      /**
       * Initialize Popups section.
       * Adds event triggers to the Parents Container
       * @memberof Trampoline.parents
       */
      init = function(config) {
        _config = config;
        _log('Initiating Popups Section...', config);
        _popupsContainer = Trampoline.container.querySelector('section.popups');
        _popupsContentContainer = Trampoline.container.querySelector(
          '.popups-wrapper .content'
        );
        _addPopupsSection();
      },
      listResources = function() {
        return Trampoline.templating.listResourcesForConfig(
          _config,
          _defaultPanels
        );
      },
      startup = function(resources) {
        // build the DOM elements from the templates now we have the loaded template files.
        var elements = Trampoline.templating.buildTemplates(
          _config,
          _defaultPanels,
          resources
        );

        if (elements.length === 0) {
          return;
        }

        // don't add all popups immediately.
        // build a map of all popups by id and wait for a popup open request
        // to happen.
        var frag, ele;
        for (var i = 0; i < elements.length; i++) {
          frag = elements[i];
          ele = frag.firstChild;
          _popupsById[ele.id] = ele;
        }

        _defaultPopupId = elements[0].firstChild.id;
      },
      /**
       * Toggles Parent Bar DOM view with animation
       * @memberof Trampoline.parents
       */
      toggleView = function() {
        if (!!_panelActive) {
          _close();
        } else {
          _open();
        }
      },
      _open = function(popupId) {
        var id = popupId || _defaultPopupId;
        var popup = _popupsById[id];

        if (!popup) {
          return;
        }

        _popupsContainer.classList.add('active');

        if (_currentPoupupElement) {
          _popupsContentContainer.removeChild(_currentPoupupElement);
        }

        _currentPopupId = id;
        _currentPoupupElement = popup;

        _popupsContentContainer.appendChild(_currentPoupupElement);

        _panelActive = true;
        //_popupsContainer.classList.add('active');
        //Trampoline.analytics.event('Parents', 'open');
        Trampoline.events.dispatchEvent(
          POPUPS_OPEN,
          _currentPopupId,
          _currentPoupupElement
        );
      },
      _close = function() {
        if (_currentPoupupElement) {
          _popupsContentContainer.removeChild(_currentPoupupElement);
        }

        _popupsContainer.classList.remove('active');

        var ele = _currentPoupupElement;
        var id = _currentPopupId;

        _currentPoupupElement = null;
        _currentPopupId = null;

        _panelActive = false;
        //_popupsContainer.classList.remove('active');
        Trampoline.events.dispatchEvent(POPUPS_CLOSE, id, ele);
      },
      _addPopupsSection = function() {
        //TODO: Inject popups section into the DOM here.
      },
      /**
       * Removes Parents Area from DOM
       */
      remove = function() {
        if (!_popupsContainer) {
          _popupsContainer = document
            .getElementById('trampoline')
            .querySelector('section.popups');
        }
        _popupsContainer.parentElement.removeChild(_popupsContainer);
      };

    return {
      init: init,
      startup: startup,
      listResources: listResources,
      toggleView: toggleView,
      remove: remove,
      open: _open,
      close: _close
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Settings View Module for Trampoline
 * @memberof Trampoline
 * @namespace settings
 */
(function(Trampoline) {
  Trampoline.settings = (function() {
    var _settingsButton,
      _settingsModule,
      _settingsContainer,
      _settingsContent,
      _panelActive,
      _scrollParent,
      _log = Trampoline._log,
      tapEvent = Trampoline.util.tapEvent,
      //Events
      SETTINGS_CLOSE = new Event('SETTINGS_CLOSE'),
      SETTINGS_OPEN = new Event('SETTINGS_OPEN'),
      /**
       * Initialize Settings DOM element
       * @memberof Trampoline.settings
       */
      init = function(config) {
        _settingsButton = document.querySelector('.settings.button');
        _settingsModule = document.querySelector('#settings-module');
        _settingsContainer = Trampoline.container.querySelector(
          'section.settings'
        );
        _scrollParent = _settingsContainer.querySelector('.content-wrapper');
        _settingsContent = _scrollParent.querySelector('.content');

        if (!!Trampoline.modules.settings == false) {
          return;
        } else {
          _log('init settings');

          if (Trampoline.modules.localize === false) {
            _log('Localize : false. Removing station picker...');
            stationPicker.remove();
          } else {
            //Localize Station Picker
            stationPicker.init();
          }

          Trampoline.util.makeSticky(
            _settingsContainer.querySelector('nav'),
            _settingsContainer.querySelector('.settings-wrapper')
          );

          _addSettings();

          _settingsContainer.addEventListener(
            'touchmove',
            Trampoline.util.preventDefaultThis
          );

          captionToggle.init();

          languageToggle.init();

          Trampoline.util.addSwipePull(_settingsContainer, {
            dY: -0.1,
            state: 'back',
            scrollParent: _scrollParent
          });
        }
      },
      refresh = function(options) {
        if (!Trampoline.modules.settings.init) {
          init(options);
        } else {
          //Something bonked. Let's reinit the station picker
          stationPicker.init();
        }
      },
      /**
       * Add a module to the settings view
       * @param {object} settingsObj TBD
       * @memberof Trampoline.settings
       */
      addSettingsModule = function(settingsObj) {
        //TODO: Add settings to module from settingsObject.
        _log('add setting');
        if (typeof settingsObj === 'object') {
        } else {
          _log('error in settings object');
        }
      },
      listResources = function() {
        // TODO: The below function call was relying on this. What should this actually be?
        var _config, _defaultPanels;
        return Trampoline.templating.listResourcesForConfig(
          _config,
          _defaultPanels
        );
      },
      captionToggle = {
        init: function() {
          if (!Trampoline.modules.captions) {
            return;
          }

          // don't double add the captions toggle
          if (_settingsContent.querySelector('.caption-toggle') !== null) {
            return;
          }

          _log('Adding Captions toggle to settings view');
          captionToggle.build();
        },
        build: function() {
          _log('Building Captions Toggle');
          var _container = document.createElement('div'),
            _heading = document.createElement('h2'),
            _onButtonContainer = document.createElement('div'),
            _onButton = document.createElement('button'),
            _offButtonContainer = document.createElement('div'),
            _offButton = document.createElement('button'),
            _captionDescription = document.createElement('h3');

          _container.classList.add('panel', 'caption-toggle');

          _heading.dataset.languageKey = 'captions';
          _heading.innerHTML = 'Captions';
          _container.appendChild(_heading);

          if (Trampoline.modules.captions.hasOwnProperty('description')) {
            _captionDescription.innerHTML =
              Trampoline.modules.captions.description;
            _container.appendChild(_captionDescription);
          }

          _onButtonContainer.classList.add('button-wrapper');
          _onButton.classList.add('turn-on');
          _onButton.dataset.languageKey = 'turn_on';

          if (Trampoline.modules.captions.show) {
            _onButton.classList.add('active');
          }
          _onButton.innerHTML = 'On';
          _onButton.addEventListener(
            Trampoline.util.tapEvent,
            captionToggle.toggle,
            false
          );
          _onButtonContainer.appendChild(_onButton);
          _container.appendChild(_onButtonContainer);

          _offButtonContainer.classList.add('button-wrapper');
          _offButton.classList.add('turn-off');
          _offButton.dataset.languageKey = 'turn_off';
          if (!Trampoline.modules.captions.show) {
            _offButton.classList.add('active');
          }
          _offButton.innerHTML = 'Off';
          _offButtonContainer.appendChild(_offButton);
          _offButton.addEventListener(tapEvent, captionToggle.toggle, false);
          _container.appendChild(_offButtonContainer);

          _settingsContent.appendChild(_container);
        },
        toggle: function(e) {
          //Switch the UI classes on toggle buttons.
          var captionOnButton = _settingsContainer.querySelector(
              '.caption-toggle button.turn-on'
            ),
            captionOffButton = _settingsContainer.querySelector(
              '.caption-toggle button.turn-off'
            );

          if (
            e.target.classList.contains('turn-on') &&
            !Trampoline.modules.captions.show
          ) {
            //Toggle captiosn ON
            Trampoline.util.toggleAnimation(e.target, 'tap-pulse-button');
            captionOffButton.classList.remove('active');
            captionOnButton.classList.add('active');
            Trampoline.captions.toggle();
          } else if (
            e.target.classList.contains('turn-off') &&
            Trampoline.modules.captions.show
          ) {
            //Toggle captions OFF
            Trampoline.util.toggleAnimation(e.target, 'tap-pulse-button');
            captionOnButton.classList.remove('active');
            captionOffButton.classList.add('active');
            Trampoline.captions.toggle();
          }
        }
      },
      languageToggle = {
        init: function() {
          if (!Trampoline.modules.language) {
            return;
          }

          // check if the language toggle is already there, so it's not added a second time during refresh
          if (_settingsContent.querySelector('.language-toggle') !== null) {
            return;
          }

          var panel = document.createElement('div');
          panel.classList.add('panel', 'language-toggle');
          _settingsContent.appendChild(panel);

          var h2 = document.createElement('h2');
          h2.dataset.languageKey = 'app_language';
          panel.appendChild(h2);

          var supportedLanguages = [
            { code: 'en', text: 'English' },
            { code: 'es', text: 'Español' }
          ];

          supportedLanguages.forEach(function(languageConfig) {
            var wrapper = document.createElement('div');
            wrapper.classList.add('button-wrapper');

            var button = document.createElement('button');
            button.classList.add(languageConfig.code);
            button.dataset.languageCode = languageConfig.code;
            button.innerText = languageConfig.text;
            wrapper.appendChild(button);

            if (Trampoline.languages.get() === languageConfig.code) {
              button.classList.add('active');
            }

            button.addEventListener('click', function() {
              Trampoline.languages.set(languageConfig.code);
            });

            panel.appendChild(wrapper);
          });

          Trampoline.events.addEventListener(
            'LANGUAGE_CHANGED',
            languageToggle.highlightCorrectButton
          );
        },

        highlightCorrectButton: function() {
          var buttons = _settingsContent.querySelectorAll(
            '.language-toggle button'
          );
          for (var i = 0; i < buttons.length; i++) {
            buttons[i].classList.remove('active');
            if (
              buttons[i].dataset.languageCode === Trampoline.languages.get()
            ) {
              buttons[i].classList.add('active');
            }
          }
        }
      },
      stationPicker = {
        //TODO: if there is no station data (network exists, but connection error) we need show that things got messed up
        init: function() {
          //Localize to local storage data
          stationPicker.localize();

          //Build out the picker if connected
          if (Trampoline.util.isConnected) {
            _log('Building Station Picker', ': connected');
            Trampoline.events.addEventListener(
              'STATION_LIST_POPULATED',
              stationPicker.build
            );

            if (Trampoline.localize.isLocalizing) {
              _log(
                'No data for Station Picker, waiting for localization to complete'
              );
            } else if (
              !Trampoline.localize.didLocalize ||
              !Object.keys(Trampoline.localize.stationList).length
            ) {
              _log('No data for Station Picker, attempting auto localization');
              Trampoline.localize.auto();
            } else {
              stationPicker.build();
            }

            // prevent non-numerical input into the zip code field
            var zipInput = Trampoline.container.querySelector('.zipcode-input');
            zipInput.addEventListener('keyup', function () {
              zipInput.value = zipInput.value.replace(/[^0-9]/g, '').substr(0, 5);
            });
          } else {
            // Error, No internet connection fallbacks
            _log('Trying to build Station Picker', ': network error');
            connectionLost();
          }
          //Set to non-localized view. Try to auto localize again?
        },
        localize: function() {
          Trampoline.util
            .getLocalStorage('trampolineLocalStation')
            .then(function(_localStationStr) {
              _log('Local Station is in Local Storage, set it and forget it!');
              Trampoline.localize.getStationImage(
                JSON.parse(_localStationStr),
                'color-logo',
                stationPicker.setStationLogo
              );
            })
            .catch(function(err) {
              Trampoline.util
                .getLocalStorage(
                  'trampolineAutoLocalStation',
                  Date.now() - 60 * 60 * 1000
                )
                .then(function(_autoLocalStationStr) {
                  Trampoline.localize.getStationImage(
                    JSON.parse(_autoLocalStationStr),
                    'color-logo',
                    stationPicker.setStationLogo
                  );
                })
                .catch(function(err) {
                  _log('No Station data in local storage');
                });
            });
        },
        build: function() {
          var _stationList = Trampoline.localize.stationList;
          _log('Localized, Building Station Picker', _stationList);
          stationPicker.updateStationList();
        },
        submitZipcode: function(e) {
          var zipcodeValue = document.querySelector('.zipcode-input').value;

          Trampoline.util.toggleAnimation(e.target, 'tap-pulse-button');

          if (
            zipcodeValue === null ||
            zipcodeValue === '' ||
            zipcodeValue.toString().length < 5 ||
            isNaN(zipcodeValue)
          ) {
            //TODO: Improve Zipcode UX
            return false;
          } else {
            Trampoline.localize.zipcode(
              zipcodeValue,
              null,
              stationPicker.inputError
            );
          }
        },

        updateStationList: function() {
          var _stationsButtonContainer = _settingsContainer.querySelector(
              '.station-picker ul.station-buttons'
            ),
            _localStationFromStorage;

          _stationsButtonContainer.innerHTML = '';
          _stationsButtonContainer.dataset.languageKey = '';

          Trampoline.util
            .getLocalStorage('trampolineLocalStation')
            .then(function(lsLocalStation) {
              _localStationFromStorage = JSON.parse(lsLocalStation);
            })
            .catch(function() {
              _localStationFromStorage = false;
            })
            .then(function() {
              for (
                var i = 0;
                i < Object.keys(Trampoline.localize.stationList).length;
                i++
              ) {
                var stationCallsign = Object.keys(
                  Trampoline.localize.stationList
                )[i];
                var isCurrentStationLocal =
                  !!_localStationFromStorage &&
                  _localStationFromStorage.callsign == stationCallsign;
                var stationButton = stationPicker.makeStationButton(
                  stationCallsign,
                  isCurrentStationLocal
                );
                _stationsButtonContainer.appendChild(stationButton);
              }
              _log('station list buttons updated');
            });
        },

        makeStationButton: function(stationCallsign, isSelected) {
          var stationData = Trampoline.localize.stationList[stationCallsign],
            stationButton = document.createElement('li'),
            stationName = document.createTextNode(stationData.full_common_name);

          if (isSelected) {
            stationButton.classList.add('selected');
          }

          stationButton.dataset.callsign = stationCallsign;
          //TODO: make tap event on station list global/general
          stationButton.addEventListener(tapEvent, function(e) {
            e.preventDefault();
            if (!e.target.classList.contains('selected')) {
              var i,
                stationListItems = e.currentTarget.parentElement.children;

              //Persist the Localstation
              stationPicker.updateLocalStation(e.target.dataset.callsign);

              if (!!Trampoline.localize.didLocalize) {
                Trampoline.analytics.event(
                  'Settings',
                  Trampoline.localize.didLocalize
                );
                _log('Settings, ' + Trampoline.localize.didLocalize);
              }

              Trampoline.util.toggleAnimation(e.target, 'tap-pulse');
              for (i = 0; i < stationListItems.length; i++) {
                if (stationListItems[i].classList.contains('selected')) {
                  stationListItems[i].classList.remove('selected');
                }
              }
              e.target.classList.add('selected');
            }
          });

          //TODO: add .selected to station if it's also set as the Selected Station

          Trampoline.util
            .getImage(stationData.images['color-logo'])
            .then(function(stationImage) {
              // always append the image first
              stationButton.appendChild(stationImage);
            })
            .catch(function() {
              _log(
                'Failed station image for ' + stationData.images['color-logo']
              );
            })
            .then(function() {
              // no matter what, append the station name and the button itself
              stationButton.appendChild(stationName);
            });

          return stationButton;
        },

        inputError: function() {
          stationPicker.clearStationButtons();
          var _stationsButtonContainer = _settingsContainer.querySelector(
            'ul.station-buttons'
          );

          var errorElement = document.createElement('li');
          errorElement.classList.add('no-data');
          var oops = document.createElement('h2');
          oops.innerText = 'Oops!';
          var line1 = document.createElement('span');
          line1.dataset.languageKey = 'no_station_for_zip_line1';
          var line2 = document.createElement('span');
          line2.dataset.languageKey = 'no_station_for_zip_line2';
          errorElement.appendChild(oops);
          errorElement.appendChild(line1);
          errorElement.appendChild(document.createElement('br'));
          errorElement.appendChild(line2);

          _stationsButtonContainer.innerHTML = '';
          _stationsButtonContainer.appendChild(errorElement);
          Trampoline.util.toggleAnimation(_stationsButtonContainer, 'pulse');
          Trampoline.container.querySelector(
            'section.settings input.zipcode-input'
          ).value = null;
        },
        updateLocalStation: function(callsign) {
          _log('update local station', callsign);

          var _localStation = Trampoline.localize.stationList[callsign];
          Trampoline.localize.getStationImage(
            _localStation,
            'color-logo',
            stationPicker.setStationLogo
          );
          //            Trampoline.util.setLocalStorage('trampolineLocalStation', _localStation);
          //
          //            Trampoline.localize.localStation = _localStation;
          //            Trampoline.events.dispatchEvent(LOCALIZED);
          Trampoline.localize.setLocalStation(callsign);
        },
        clearStationButtons: function() {
          var _stationsButtonContainer = _settingsContainer.querySelector(
            'ul.station-buttons'
          );
          //stationsButtons.parentNode.removeChild(stationsButtons);
          _stationsButtonContainer.innerHTML = '';
        },
        setStationLogo: function(stationLogoObj) {
          var _localStationImg = _settingsContainer.querySelector(
            '.station-picker .selected-station img.station-logo'
          );
          stationLogoObj.classList.add('station-logo', 'localized');
          Trampoline.util.toggleAnimation(stationLogoObj, 'pulse');

          _localStationImg = _localStationImg.parentNode.replaceChild(
            stationLogoObj,
            _localStationImg
          );
        },
        showZipcodeEntry: function(e) {
          var zipcodeDisplay = e.target;
          _settingsContainer.classList.add('zipcode-entry');
        },
        remove: function() {
          var _stationPickerContainer = _settingsContainer.querySelector(
            '.station-picker'
          );
          if (typeof _stationPickerContainer === 'object') {
            _stationPickerContainer.parentElement.removeChild(
              _stationPickerContainer
            );
          } else {
            Trampoline._log('Error removing Station Picker from Settings');
          }
        }
      },
      _addSettings = function() {
        Trampoline.container.classList.add('has-settings');
        Trampoline.container
          .querySelector('.settings nav .close')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
            Trampoline.state.back();
          });
        //Add a real thing to the zipcode button
        if (!!Trampoline.modules.localize) {
          _settingsContainer
            .querySelector('.zipcode-submit')
            .addEventListener(tapEvent, stationPicker.submitZipcode);
        }
      },
      connectionLost = function() {
        if (_panelActive && !Trampoline.util.isConnected) {
          _settingsContainer.classList.add('offline');
        }
      },
      connectionResume = function() {
        if (_settingsContainer.classList.contains('offline')) {
          _settingsContainer.classList.remove('offline');
        }
      },
      /**
       * Removes the Settings DOM element
       * @memberof Trampoline.settings
       */
      remove = function() {
        _log('config', 'remove settings module');
        if (!!_settingsModule) {
          _settingsModule.parentElement.removeChild(_settingsModule);
        }
      },
      /**
       * Toggles the Settings View with animation
       * @memberof Trampoline.settings
       */
      toggleView = function() {
        if (!!_panelActive) {
          _close();
        } else {
          _open();
        }
      },
      _open = function() {
        _panelActive = true;
        _settingsContainer.classList.add('active');
        if (!Trampoline.util.isConnected) {
          _settingsContainer.classList.add('offline');
        } else if (_settingsContainer.classList.contains('offline')) {
          _settingsContainer.classList.remove('offline');
        }
        Trampoline.analytics.event('Settings', 'open');
        Trampoline.events.dispatchEvent(SETTINGS_OPEN);
      },
      _close = function() {
        _panelActive = false;
        _settingsContainer.classList.remove('active');
        _settingsContainer.scrollTop = 0;
        Trampoline.events.dispatchEvent(SETTINGS_CLOSE);
      },
      //Relics from the original setting modules
      _openSettingsModule = function() {
        _log('show settings module');
        _settingsButton.removeEventListener(tapEvent, function(e) {
          e.preventDefault();
          _openSettingsModule();
        });
        _settingsButton.addEventListener(tapEvent, function(e) {
          e.preventDefault();
          _closeSettingsModule();
        });
        _settingsModule.classList.add('active');
      },
      _closeSettingsModule = function() {
        _settingsButton.removeEventListener(tapEvent, function(e) {
          e.preventDefault();
          _closeSettingsModule();
        });
        _settingsButton.addEventListener(tapEvent, function(e) {
          e.preventDefault();
          _openSettingsModule();
        });
        _settingsModule.classList.remove('active');
      };

    return {
      init: init,
      refresh: refresh,
      addSettingsModule: addSettingsModule,
      remove: remove,
      toggleView: toggleView,
      connectionLost: connectionLost,
      connectionResume: connectionResume
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * Splash Screen Module for Trampoline
 * @memberof Trampoline
 * @namespace localize
 */
(function(Trampoline) {
  Trampoline.splash = (function() {
    var _splashContainer,
      _stationLogo,
      _isLocalized = false,
      _splashActive = false,
      _log = Trampoline._log,
      _localizeTimer,
      _splashSpinner,
      config = {},
      //EVENTS
      SPLASH_HIDE = new Event('SPLASH_HIDE'),
      SPLASH_DONE = new Event('SPLASH_DONE'),
      /**
       * Initializes the Splash screen, attempts to localize, fades out.
       * @memberof Trampoline.splash
       */
      init = function() {
        _splashContainer = Trampoline.container.querySelector('.splash');
        _stationLogo = _splashContainer.querySelector('.station-logo');

        _splashContainer.classList.remove('hidden');
        _splashActive = true;

        _splashContainer.addEventListener(
          'touchmove',
          Trampoline.util.preventDefaultThis
        );

        // Remove Cordova Splash Screen if exists,
        if (navigator.hasOwnProperty('splashscreen')) {
          navigator.splashscreen.hide();
        }

        //reset the HTML bgcolor which has been set by css to suppress a white flash when the webview is loading
        document.body.style.backgroundColor = 'initial';

        //Don't localize if config `splash: {localize: false}`
        if (
          Trampoline.splash.config.hasOwnProperty('localize') &&
          Trampoline.splash.config.localize == false
        ) {
          setTimeout(function() {
            _log('Trampoline config set to NOT localize splash.');
            _splashDone();
          }, 2500);
        } else if (Trampoline.util.isConnected) {
          _localizeSplashScreen();
        } else {
          setTimeout(function() {
            _log('Trampoline is not connected, cannot localize station.');
            if (!_isLocalized) {
              _splashDone();
            }
          }, 2500);
          //Check to see if there is a persistent localStation data.
          //TODO: Write this once localStorage Images are available

          //stationLogo = _getPersistentStationImage();
          //Otherwise, The splash screen is over, give the kids logo a little time to read before calling _splashDone
        }
      },
      _getPersistentStationImage = function() {
        var localStation = Trampoline.util.getLocalStorage(
          'trampolineLocalStation'
        );

        if (localStation && localStation.images['white-logo']) {
          var localStationImage = localStation.images['white-logo'];
          return localStationImage;
        } else {
          return null;
        }
      },
      /**
       * Starts timer, (checks for local storage, if none,) attempts to autolocalize.
       * Shows station logo if StationLogo is returned before timeout.
       */
      _localizeSplashScreen = function() {
        var _localStation;

        //check for persistent localization data
        Trampoline.util
          .getLocalStorage('trampolineLocalStation')
          .then(function(localStorageStation) {
            _log('Localizing from local storage');
            _localStation = JSON.parse(localStorageStation);
            Trampoline.localize.getStationImage(
              _localStation,
              'white-logo',
              _showStationLogo,
              550
            );
          })
          .catch(function() {
            if (Trampoline.modules.localize.auto) {
              Trampoline.localize.auto(_showStationLogo);
            } else if (Trampoline.modules.localize.zipCode) {
              Trampoline.localize.zipcode(
                Trampoline.modules.localize.zipCode,
                _showStationLogo,
                Trampoline.analytics.dimension(1, 'NO_STATION')
              );
            }
          });

        _startLocalizeTimer(2500);

        //TODOL This could be turned into a Promise somehow
        function _handleLocalizedListener(e) {
          if (
            !_isLocalized &&
            !!Object.keys(Trampoline.localize.stationList)[0]
          ) {
            Trampoline.localize.getStationImage(
              Trampoline.localize.stationList[
                Object.keys(Trampoline.localize.stationList)[0]
              ],
              'white-logo',
              _showStationLogo,
              550
            );
          }
          e.target.removeEventListener('LOCALIZED', _handleLocalizedListener);
        }

        Trampoline.events.addEventListener(
          'LOCALIZED',
          _handleLocalizedListener
        );
      },
      /**
       * Simple UX timer for splash data retrieval.
       * @param {Number} time Time in MS
       */
      _startLocalizeTimer = function(time) {
        _localizeTimer = setTimeout(function() {
          if (!_isLocalized) {
            _log('Splash screen localization time out');
            _splashDone();
          }
        }, time);
      },
      /**
       * Append station logo as DOM Node and animate PBS Kids Logo
       * @param {Object} stationLogoObj Image DOM node
       */
      _showStationLogo = function(stationLogoObj) {
        //We have a station logo! Set it and forget it.
        _isLocalized = true;
        clearTimeout(_localizeTimer);

        //Just a few fallbacks on the callsign...
        var _callsign =
          (typeof stationLogoObj.dataset.callsign !== 'undefined'
            ? stationLogoObj.dataset.callsign
            : 0) ||
          (typeof Trampoline.localize.localStation.callsign !== 'undefined'
            ? Trampoline.localize.localStation.callsign
            : 0) ||
          (typeof Object.keys(Trampoline.localize.stationList)[0] !==
          'undefined'
            ? Object.keys(Trampoline.localize.stationList)[0]
            : 0) ||
          false;

        if (!!_callsign) {
          //We have a definite station, set the dimension (this can change again through the station-picker).
          Trampoline.analytics.dimension(1, _callsign);
        }

        //Set the station logo.
        _stationLogo.appendChild(stationLogoObj);
        _splashContainer.classList.add('localized');
        setTimeout(function() {
          _splashDone();
        }, 3000);
      },
      /**
       * Whenever the splash screen is finished, regardless of connection state, we want to run the same block
       * So that if the developer wants to hang, while they load the rest of the joint, we can do that.
       * This also triggers the Trampoline.onReady
       *
       * @event SPLASH_DONE The splash screen is done, if splash.hide = true we will stall with a loader until state is changed to 'main'
       */
      _splashDone = function() {
        Trampoline.onReady();
        if (
          Trampoline.splash.config.hasOwnProperty('hide') &&
          Trampoline.splash.config.hide == false
        ) {
          _log(
            'Splash screen auto-hide set to false, waiting for Trampoline.state.change...'
          );

          //Inject the loading spinner (previously part of markup)
          _splashSpinner = document.createElement('div');
          _splashSpinner.classList.add('splash-spinner');
          _splashSpinner.innerHTML =
            '<div class="splash-loader-text">Loading</div>';
          _splashContainer
            .querySelector('.container')
            .appendChild(_splashSpinner);

          Trampoline.events.dispatchEvent(SPLASH_DONE);
          Trampoline.util.toggleAnimation(_splashSpinner, 'pulse-in');
          _splashSpinner.classList.add('active');
        } else {
          Trampoline.events.dispatchEvent(SPLASH_DONE);
          Trampoline.state.change({ to: 'main', from: 'splash' });
        }
      },
      /**
       * Hides the Splash screen once transition has ended, if there is one.
       * @param {Function} callback Callback, no return
       */
      _hide = function(callback) {
        _splashContainer.addEventListener('transitionend', function() {
          if (_splashActive) {
            Trampoline.events.dispatchEvent(SPLASH_HIDE);
            remove();
            document.body.style.backgroundColor = 'initial';
            _splashActive = false;
          }
        });
        _splashContainer.classList.remove('active');
        if (typeof callback === 'function') {
          callback();
        }
      },
      remove = function() {
        var splashContainer =
          _splashContainer ||
          document.getElementById('trampoline').querySelector('.splash');

        if (!!splashContainer) {
          splashContainer.parentElement.removeChild(splashContainer);
        }
        document.body.style.backgroundColor = 'initial';
      },
      toggleView = function() {
        if (!_splashActive) {
          init();
        } else {
          if (!!_splashSpinner) {
            Trampoline.util.toggleAnimation(
              _splashSpinner,
              'pulse-out',
              'hidden'
            );
            window.setTimeout(function() {
              _hide();
              //slightly shorter than animation
            }, 200);
          } else {
            _hide();
          }
        }
      };

    return {
      config: config,
      remove: remove,
      toggleView: toggleView
    };
  })();

  return Trampoline;
})(Trampoline || {});

/**
 * PBS Kids Super Vision Module for Trampoline
 * @memberof Trampoline
 * @namespace supervision
 */
(function(Trampoline) {
  Trampoline.supervision = (function() {
    var _supervisionButton,
      _supervisionContainer,
      _syncCodeContainer,
      _playTimerContainer,
      _connectingContainer,
      _log = Trampoline._log,
      _panelActive = false,
      _fayeClient = null,
      _currentSessionId = null,
      _currentPlayTimerTimeout = null,
      _closePanelTimeout = null,
      _isPaired = false,
      _previousSubscription = null,
      _options = {},
      tapEvent = Trampoline.util.tapEvent,
      sync_state = null,
      //EVENTS
      SUPER_VISION_OPEN = new Event('SUPER_VISION_OPEN'),
      SUPER_VISION_CLOSE = new Event('SUPER_VISION_CLOSE'),
      SUPER_VISION_PAIR = new Event('SUPER_VISION_PAIR'),
      SUPER_VISION_UNPAIR = new Event('SUPER_VISION_UNPAIR'),
      PLAYTIMER_SHOW = new Event('PLAYTIMER_SHOW'),
      PLAYTIMER_HIDE = new Event('PLAYTIMER_HIDE'),
      /**
       * Initialize Supervision Module
       * @memberof Trampoline.supervision
       */
      init = function() {
        _log('Supervision init...');

        _injectPlaytimer();

        // provide some default options
        _options = Trampoline.modules.supervision || {};
        _options.origin = _options.origin || 'org.pbskids.WebSite';
        _options.endpoint =
          _options.endpoint || 'https://supervision.pbskids.org:9300';

        // A few DOM Elements we need
        _supervisionButton = Trampoline.container.querySelector(
          'nav .button.supervision'
        );
        _supervisionContainer = Trampoline.container.querySelector(
          'section.supervision'
        );
        _connectingContainer = _supervisionContainer.querySelector(
          '.connecting-wrapper'
        );
        _syncCodeContainer = _supervisionContainer.querySelector('.sync-code');
        _playTimerContainer = Trampoline.container.querySelector(
          'section.play-timer'
        );

        // TODO: Refactor this so that we can just use data attributes
        var statusText = _syncCodeContainer.querySelector('h3.status > span');
        var statusTextWatch = Trampoline.languages.autoTranslateElement(
          statusText,
          'sv_getting_code'
        );

        // totally supported: https://caniuse.com/#feat=mutationobserver
        var observer = new MutationObserver(function(mutationsList) {
          mutationsList
            .filter(function(mutation) {
              return mutation.attributeName === 'data-status';
            })
            .forEach(function(mutation) {
              // update the translation key based on the status
              var translationKey =
                'sv_' + _syncCodeContainer.dataset.status.replace(/-/g, '_');
              statusTextWatch.setTranslationKey(translationKey);
            });
        });
        observer.observe(_syncCodeContainer, { attributes: true });

        _supervisionContainer.addEventListener(
          'touchmove',
          Trampoline.util.preventDefaultThis
        );

        // Inject the Onboarding SVGs so we can manipulate them with CSS, and leave them out of the markup.
        var svgPath = !!Trampoline._resourcePath
          ? Trampoline._resourcePath
          : '';

        Trampoline.util.injectSVG(
          _supervisionContainer.querySelector('.tablet-user'),
          svgPath + 'img/supervision/tablet-user.svg'
        );
        Trampoline.util.injectSVG(
          _supervisionContainer.querySelector('.mobile-hand'),
          svgPath + 'img/supervision/mobile-hand.svg'
        );

        // Hook in some events
        _supervisionContainer
          .querySelector('nav .close')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
            Trampoline.state.back();
          });

        Trampoline.util.addSwipePull(_supervisionContainer, {
          dY: -0.1,
          state: 'back',
          scrollParent: _connectingContainer
        });

        var connectingPagination = _supervisionContainer.querySelectorAll(
          '.dot'
        );
        for (var i = 0; i < connectingPagination.length; i++) {
          connectingPagination[i].addEventListener(
            tapEvent,
            _setOnboardingScreen
          );
        }

        _supervisionContainer
          .querySelector('.disconnect')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            _showDisconnectDialogue();
          });
        _supervisionContainer
          .querySelector('.okay')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            //Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
            _hideDisconnectDialogue();
            disconnect();
          });
        //TODO: add tap animations that don't suck
        _supervisionContainer
          .querySelector('.cancel')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            //Trampoline.util.toggleAnimation(e.target, 'tap-exit', 'tap-exit');
            _hideDisconnectDialogue();
          });
        _supervisionContainer
          .querySelector('.done')
          .addEventListener(tapEvent, function(e) {
            e.preventDefault();
            Trampoline.util.toggleAnimation(e.target, 'tapped', 'tap-exit');
            window.setTimeout(function() {
              Trampoline.state.back();
            }, 350);
          });

        function _showSupervisionNotifier() {
          var _supervisionNotifier = Trampoline.container.querySelector(
            '.main #supervision-notifier'
          );
          if (!!_supervisionNotifier) {
            window.setTimeout(function() {
              Trampoline.util.toggleAnimation(
                _supervisionNotifier,
                'bounceDown',
                null
              );
              _supervisionNotifier.classList.add('active');
              _supervisionNotifier
                .querySelector('.notifier-container')
                .addEventListener(Trampoline.util.tapEvent, function() {
                  window.clearTimeout();
                  Trampoline.util.toggleAnimation(
                    _supervisionNotifier,
                    'tapped'
                  );
                  Trampoline.util.toggleAnimation(
                    _supervisionNotifier,
                    'bounceDownReturn'
                  );
                  window.setTimeout(function() {
                    _supervisionNotifier.classList.remove('active');
                  }, 600);
                  Trampoline.state.change({ to: 'supervision', from: 'main' });
                });
              window.setTimeout(function() {
                Trampoline.util.toggleAnimation(
                  _supervisionNotifier,
                  'bounceDownReturn'
                );
                window.setTimeout(function() {
                  _supervisionNotifier.classList.remove('active');
                }, 600);
              }, 30000);
              // 5 Second delay on notifier
            }, 2000);
          }
        }

        function _addSupervisionNotifierOnMain(e) {
          if (Trampoline.state.current.name == 'main') {
            e.target.removeEventListener(
              'TRAMPOLINE_STATE_CHANGE',
              _addSupervisionNotifierOnMain
            );
            _showSupervisionNotifier();
          }
        }

        // Show the tooltip on state.main
        if (
          Trampoline.state.current.hasOwnProperty('name') &&
          Trampoline.state.current.name == 'main'
        ) {
          _showSupervisionNotifier();
        } else {
          Trampoline.events.addEventListener(
            'TRAMPOLINE_STATE_CHANGE',
            _addSupervisionNotifierOnMain
          );
        }

        //Connect swipe events to Onboarding Screens
        _connectingContainer.addEventListener(
          'touchstart',
          Trampoline.util.handleSwipeTouchStart,
          false
        );
        Trampoline.events.addEventListener(
          'TRAMPOLINE_SWIPE_RIGHT',
          _regressOnboardingScreen
        );
        Trampoline.events.addEventListener(
          'TRAMPOLINE_SWIPE_LEFT',
          _advanceOnboardingScreen
        );

        //Cancel Event Bubbling through Play-Timer screens
        if (!!_playTimerContainer) {
          _playTimerContainer.addEventListener(tapEvent, function(e) {
            e.preventDefault();
          });
        }

        // Whenever the app closes, hide the super vision panel, so we don't get stale sync codes
        document.addEventListener('pause', _closePanel);
        document.addEventListener('resign', _closePanel); // ios specific 'pause' event: http://cordova.apache.org/docs/en/5.4.0/cordova/events/events.pause.html#ios-quirks

        // Create the initial connection
        reconnectToExistingChannel().catch(function(e) {
          _log('Failed to reconnect to supervision channel: ' + e.message);
        });
      },
      connectionResume = function() {
        if (_supervisionContainer.classList.contains('offline')) {
          _supervisionContainer.classList.remove('offline');
        }
        if (!_isPaired) {
          //Make sure the UI state is reset
          _syncCodeContainer.dataset.status = 'getting-code';
          connectToNewChannel();

          // Set the panel to close after inactivity. That way, the parent doesn't accidentally try to sync with an expired code
          window.clearTimeout(_closePanelTimeout);
          _closePanelTimeout = window.setTimeout(_closePanel, 4 * 60 * 1000);
        }
      },
      connectionLost = function() {
        _log('supervision connection lost');
        if (_panelActive) {
          _supervisionContainer.classList.add('offline');
        }
      },
      _closePanel = function() {
        if (_panelActive) {
          Trampoline.state.back();
        }
      },
      _setOnboardingScreen = function(e) {
        var currentScreen = parseInt(_connectingContainer.dataset.screen),
          toScreen = e.target.dataset.screen;
        if (toScreen != currentScreen && toScreen > 0 && toScreen <= 3) {
          e.preventDefault();
          _log('setting onboarding screen to: ' + toScreen);
          _connectingContainer.dataset.screen = toScreen.toString();
        }
      },
      _advanceOnboardingScreen = function(e) {
        var currentScreen = parseInt(_connectingContainer.dataset.screen),
          wasChildNodeEvent = _supervisionContainer.contains(
            e.detail.touchEndEvent.target
          );

        if (wasChildNodeEvent && currentScreen < 3) {
          currentScreen++;
          _connectingContainer.dataset.screen = currentScreen.toString();
        }
      },
      _regressOnboardingScreen = function(e) {
        var currentScreen = parseInt(_connectingContainer.dataset.screen),
          wasChildNodeEvent = _supervisionContainer.contains(
            e.detail.touchEndEvent.target
          );

        if (wasChildNodeEvent && currentScreen > 1) {
          currentScreen--;
          _connectingContainer.dataset.screen = currentScreen.toString();
        }
      },
      _injectPlaytimer = function() {
        var _playtimerContainer = document.createElement('div');

        Trampoline.util
          .fetch(Trampoline._path + 'play-timer.html')
          .then(function(playtimerMarkup) {
            _playtimerContainer.setAttribute('id', 'trampoline-play-timer');
            _playtimerContainer.insertAdjacentHTML(
              'beforeend',
              playtimerMarkup
            );
            document.body.appendChild(_playtimerContainer);
            _log('...Playtimer injected into body!');
          })
          .catch(function(err) {
            _log('...Playtimer failed to inject! :(', err);
          });
      },
      _showDisconnectDialogue = function() {
        _supervisionContainer
          .querySelector('.disconnect-alert')
          .classList.add('active');
      },
      _hideDisconnectDialogue = function() {
        var _disconnectContainer = _supervisionContainer.querySelector(
          '.disconnect-alert'
        );
        Trampoline.util.toggleAnimation(
          _disconnectContainer,
          'bounceDownReturn'
        );
        _disconnectContainer.classList.remove('active');
      },
      /**
       * Retrieve a Super Vision sync code form the Faye client
       * @memberof Trampoline.supervision
       * @param {function} onSuccess Success callback
       */
      getSyncCode = function(onSuccess, numTries) {
        numTries = numTries || 5;

        var syncCodeUrl = _options.endpoint + '/channel/create',
          ajaxOptions = {
            method: 'POST',
            data: { origin: _options.origin }
          },
          _fetchSyncCode = function(numFetchTries) {
            // if we run out of tries, we'll need to do something...
            var _fetchSyncCodeSuccess = onSuccess || function() {},
              _fetchSyncCodeFail = function() {
                _log(
                  'Sync code failed. ' + (numFetchTries - 1) + ' tries left'
                );
                window.setTimeout(function() {
                  _fetchSyncCode(numFetchTries - 1);
                }, 2000);
              };

            //TODO: Add in timeout for 'try-again' and attach a tap event handler to reconnect.
            if (numFetchTries <= 0) {
              _syncCodeContainer.dataset.status = 'try-later';
              _clearSyncCode();
              return;
            }

            // If the fetch call fails, try again in a second or two, until we have no more tries left
            Trampoline.util
              .fetch(syncCodeUrl, ajaxOptions)
              .then(_fetchSyncCodeSuccess)
              .catch(_fetchSyncCodeFail);
          };

        //Try to get a sync code (5) times
        _fetchSyncCode(numTries);
      },
      _clearSyncCode = function() {
        var _syncCodeCharacters = _syncCodeContainer.querySelectorAll(
          '.character'
        );

        for (var i = 0; i < _syncCodeCharacters.length; i++) {
          _syncCodeCharacters[i].innerHTML = '';
        }
      },
      /**
       * Sets up the faye client, using a singleton pattern so we don't get duplicate events
       * @memberof Trampoline.supervision
       * @return {Faye.Client} A Faye client instance
       */
      initializeFayeClient = function() {
        if (_fayeClient !== null) {
          return _fayeClient;
        }

        _fayeClient = new Faye.Client(_options.endpoint + '/faye');

        // Add some Faye middleware to detect when the super vision app pairs and disconnects with this running
        // instance of trampoline
        var monitorConnectionState = function(message, callback) {
          var messageData = message.data || {};

          // If it's not a connection status event, ignore it
          if (messageData.type !== 'status') {
            return callback(message);
          }

          // Detect an "unpair" event
          if (messageData.value === 'unpaired') {
            return disconnect();
          }

          // notify listeners if another client (a super vision app instance) subscribes
          if (messageData.value === 'paired') {
            Trampoline.util.setLocalStorage(
              'supervision_channel_id',
              message.channel.replace('/', '')
            );
            Trampoline.events.dispatchEvent(SUPER_VISION_PAIR);
            _supervisionContainer.classList.add('connected');
            Trampoline.container.classList.add('supervision-connected');
            _isPaired = true;

            // also, clear the "auto-close" timeout, since they successfully connected
            window.clearTimeout(_closePanelTimeout);
          }

          callback(message);
        };
        _fayeClient.addExtension({ incoming: monitorConnectionState });

        // Add Faye middleware for detecting timer changes
        var monitorTimers = function(message, callback) {
          var messageData = message.data || {};

          // If we just subscribed, and there's an existing timer, we'll need to attach a new timer
          if (
            message.channel == '/meta/subscribe' &&
            message._channel &&
            message._channel.timer
          ) {
            setPlayTimer(message._channel.timer);
            return callback(message);
          }

          // If it's not a play timer event, just break out early
          if (
            messageData._meta === undefined ||
            messageData._meta.type !== 'play_timer'
          ) {
            return callback(message);
          }

          // If we receive a play timer event, process it the same way
          if (messageData.name === 'sleep') {
            setPlayTimer(messageData);
          }

          // If we receive a cancellation, cancel
          if (messageData.name === 'cancel_sleep') {
            clearPlayTimer(message);
          }

          return callback(message);
        };
        _fayeClient.addExtension({ incoming: monitorTimers });

        // Add Faye middleware for detecting kid label reassignments
        var monitorKidLabels = function(message, callback) {
          var messageData = message.data || {};

          // If we just subscribed be sure to attach sync state
          if (message.channel == '/meta/subscribe' && message._channel) {
            Trampoline.supervision.sync_state = message._channel;
          }

          // ignore everything but an update kid label message
          if (
            messageData._meta === undefined ||
            messageData._meta.type != 'update_kid_label'
          ) {
            return callback(message);
          }

          // make sure that sync_state is indeed defined
          Trampoline.supervision.sync_state =
            Trampoline.supervision.sync_state || {};

          // if there's a save slot, treat sync_state's default kid label as an object. Otherwise, it should be flat
          if (messageData.save_slot !== undefined) {
            Trampoline.supervision.sync_state.default_kid_label =
              Trampoline.supervision.sync_state.default_kid_label || {};
            Trampoline.supervision.sync_state.default_kid_label[
              messageData.save_slot
            ] = messageData.kid_label_guid;
          } else {
            Trampoline.supervision.sync_state.default_kid_label =
              messageData.kid_label_guid;
          }

          return callback(message);
        };
        _fayeClient.addExtension({ incoming: monitorKidLabels });

        return _fayeClient;
      },
      /**
       * Checks if this trampoline instance has a cached connection to super vision and reconnects. However, if there
       * is no connection, this function is a no-op
       * @memberof Trampoline.supervision
       * @return {Boolean} Whether or not a connection was able to be established
       */
      reconnectToExistingChannel = function() {
        initializeFayeClient();

        // Determine if the storage has anything
        return Trampoline.util
          .getLocalStorage('supervision_channel_id')
          .then(function(_cachedChannelId) {
            if (
              _cachedChannelId !== null &&
              _cachedChannelId !== '' &&
              _cachedChannelId !== undefined
            ) {
              // reconnect
              var _onSuccessfulReconnect = function() {
                _supervisionContainer.classList.add('connected');
                Trampoline.container.classList.add('supervision-connected');
                _isPaired = true;
              };

              var _onFailedReconnect = function() {
                Trampoline.util.setLocalStorage('supervision_channel_id', '');
              };

              _previousSubscription = _fayeClient.subscribe(
                '/' + _cachedChannelId
              );
              return _previousSubscription.then(
                _onSuccessfulReconnect,
                _onFailedReconnect
              );
            }
          });
      },
      /**
       * Establishes a connection to a new channel
       * @memberof Trampoline.supervision
       */
      connectToNewChannel = function() {
        // A callback that initiates the Faye connection on a channel when a new (or existing) channel is created
        // (or retrieved from localstorage)
        var onGetChannel = function(channel) {
          // update the UI
          displaySyncCode(channel.sync_code);

          // now subscribe to the channel (the middleware will handle the rest)
          _previousSubscription = _fayeClient.subscribe(
            '/' + channel.channel_id
          );
        };

        getSyncCode(function(response) {
          onGetChannel(JSON.parse(response));
        });
      },
      /**
       * Sends data to super vision over a websocket connection
       * @memberof Trampoline.supervision
       * @param {object} message The data to send to supervision
       * @param {Function} callback A callback for when the message is has been received and confirmed by the server
       * @return {Boolean} Whether or not a message was sent
       */
      send = function(message, callback) {
        // If we're not paired, this is a no-op
        if (!_isPaired) {
          return false;
        }

        // create a new session id if this is a new activity
        if (message._meta && message._meta.type == 'activity') {
          _currentSessionId = _sessionId();
        }

        // make sure to attach session id
        message.game_session = _currentSessionId;

        callback = callback instanceof Function ? callback : function() {};
        Trampoline.util
          .getLocalStorage('supervision_channel_id')
          .then(function(channeliD) {
            _fayeClient.publish('/' + channeliD, message);
          })
          .then(callback);

        return true;
      },
      /**
       * Disconnects from the current connected channel on super vision
       * @memberof Trampoline.supervision
       */
      disconnect = function() {
        var okayButton = _supervisionContainer.querySelector('.okay');
        var cancelButton = _supervisionContainer.querySelector('.cancel');

        var _finishDisconnect = function() {
          // "forget" this existing channel
          Trampoline.util.setLocalStorage('supervision_channel_id', '');

          // notify any local listeners
          Trampoline.analytics.event('SuperVision', 'unpair');
          Trampoline.events.dispatchEvent(SUPER_VISION_UNPAIR);
          _isPaired = false;

          //Reset the status which controls the UI state.
          _syncCodeContainer.dataset.status = 'getting-code';

          // Allow the buttons to be used again (even though they're being hidden)
          okayButton.classList.remove('disabled');
          okayButton.disabled = false;
          cancelButton.classList.remove('disabled');
          cancelButton.disabled = false;

          // now, attempt to reconnect
          connectToNewChannel();
          _supervisionContainer.classList.remove('connected');
          Trampoline.container.classList.remove('supervision-connected');
        };

        // mark the container that we're trying to disconnect
        okayButton.classList.add('disabled');
        okayButton.disabled = true;
        cancelButton.classList.add('disabled');
        cancelButton.disabled = true;

        // stop listening for faye messages on this channel
        if (_previousSubscription) {
          // Notify apps that we're unpairing
          return send({ type: 'status', value: 'unpaired' }, function() {
            _previousSubscription.cancel();
            _previousSubscription = null;
            _finishDisconnect();
          });
        }

        _finishDisconnect();
      },
      /**
       * Displays a given sync code in the sync code box on the screen
       * @memberof Trampoline.supervision
       * @param {String} syncCode The sync code to display
       */
      displaySyncCode = function(syncCode) {
        //Cycle through the sync code letters
        var _syncCodeCharacters = _syncCodeContainer.querySelectorAll(
          '.character'
        );

        if (!!syncCode && syncCode.length > 0) {
          for (var i = 0; i < syncCode.length; i++) {
            _syncCodeCharacters[i].innerHTML = syncCode[i];
          }
          _syncCodeContainer.dataset.status = 'connecting';
        } else {
          _log('error displaying sync code');
          _syncCodeContainer.dataset.status = 'try-later';
          _clearSyncCode();
        }
      },
      /**
       * Displays the play timer overlay for a specific type
       * @memberof Trampoline.supervision
       * @param {String} type The type of play timer
       */
      showPlayTimerOverlay = function(type) {
        //TODO: The type is returning undefined
        _log(type);
        document
          .getElementById('trampoline-play-timer')
          .classList.add('active');
        document.getElementById(type + '-overlay').classList.add('active');
        Trampoline.events.dispatchEvent(PLAYTIMER_SHOW);
      },
      /**
       * Sets a new play timer
       * @param {Object} timer The timer instance received from Faye
       */
      setPlayTimer = function(timer) {
        clearPlayTimer();

        // If the timer has passed, ignore it
        if (timer.value < 0) {
          return;
        }

        _currentPlayTimerTimeout = window.setTimeout(function() {
          showPlayTimerOverlay(timer.mode);
        }, timer.value);
      },
      /**
       * Clears the local play timer
       * @member Trampoline.supervision
       */
      clearPlayTimer = function() {
        window.clearTimeout(_currentPlayTimerTimeout);
        _currentPlayTimerTimeout = null;

        // hide the current play timer overlay (if there are any)
        document
          .getElementById('trampoline-play-timer')
          .classList.remove('active');

        Array.prototype.forEach.call(
          document.querySelectorAll('.play-timer-overlay.active'),
          function(element) {
            element.classList.remove('active');
          }
        );
        Trampoline.events.dispatchEvent(PLAYTIMER_HIDE);
      },
      /**
       * Toggle the Super Vision module view
       * @memberof Trampoline.supervision
       */
      toggleView = function() {
        if (!!_panelActive) {
          _close();
        } else {
          _open();
        }
      },
      /**
       * Opens the Super Vision view
       * @memberof Trampoline.supervision
       */
      _open = function() {
        if (!_isPaired) {
          connectToNewChannel();

          // Set the panel to close after inactivity. That way, the parent doesn't accidentally try to sync with an expired code
          window.clearTimeout(_closePanelTimeout);
          _closePanelTimeout = window.setTimeout(
            Trampoline.state.back,
            4 * 60 * 1000
          );
        }

        _panelActive = true;
        if (!Trampoline.util.isConnected) {
          _supervisionContainer.classList.add('offline');
        } else if (_supervisionContainer.classList.contains('offline')) {
          _supervisionContainer.classList.remove('offline');
        }
        _supervisionContainer.classList.add('active');
        Trampoline.analytics.event('SuperVision', 'open');
        Trampoline.events.dispatchEvent(SUPER_VISION_OPEN);
      },
      /**
       * Closes the Super Vision view
       * @memberof Trampoline.supervision
       */
      _close = function() {
        _panelActive = false;
        _supervisionContainer.classList.remove('active');
        Trampoline.events.dispatchEvent(SUPER_VISION_CLOSE);
      },
      /**
       * Helper function to generate a random session id to uniquely distinguish sessions on the same device
       * @memberof Trampoline.supervision
       * @return {String}
       */
      _sessionId = function() {
        // Pad with timestamp, which will make collisions difficult
        var timestamp = new Date().getTime().toString(16),
          // Lastly, add a padded random integer as well to decrease collisions. The following number was chosen due to
          // https://bugs.chromium.org/p/v8/issues/detail?id=558 which indicates Math.random in "Chrome-like" browsers
          // have only 30 bits of entropy for random numbers.
          MAX_SAFE_INTEGER = 1073741824,
          random = Trampoline.util.randomInt(0, MAX_SAFE_INTEGER).toString(16),
          padLength = 8 - random.length;

        random = '00000000'.slice(0, padLength) + random;

        return timestamp + random;
      },
      /**
       * Removes the Super Vision and Play-Timer views from the DOM
       * @memberof Trampoline.supervision
       */
      remove = function() {
        if (!_supervisionContainer) {
          _supervisionContainer = document
            .getElementById('trampoline')
            .querySelector('section.supervision');
        }
        if (!_playTimerContainer) {
          _playTimerContainer = document.getElementById(
            '#trampoline-play-timer'
          );
        }
        if (!!_supervisionContainer && !!_supervisionContainer.parentElement) {
          _supervisionContainer.parentElement.removeChild(
            _supervisionContainer
          );
        }
        if (!!_playTimerContainer && !!_playTimerContainer.parentElement) {
          _playTimerContainer.parentElement.removeChild(_playTimerContainer);
        }
      };

    return {
      init: init,
      disconnect: disconnect,
      remove: remove,
      send: send,
      toggleView: toggleView,
      sync_state: sync_state,
      connectionLost: connectionLost,
      connectionResume: connectionResume
    };
  })();

  return Trampoline;
})(Trampoline || {});

//# sourceMappingURL=maps/trampoline.js.map
